{$x+}
program cube;

uses crt,grfx;

const
     maxlines = 12;
     obj : array [1..maxlines, 1..2, 1..3] of integer =
     (
     ((-10,-10,-10),(10,-10,-10)),((-10,-10,-10),(-10,10,-10)),
     ((-10,10,-10),(10,10,-10)),((10,-10,-10),(10,10,-10)),
     ((-10,-10,10),(10,-10,10)),((-10,-10,10),(-10,10,10)),
     ((-10,10,10),(10,10,10)),((10,-10,10),(10,10,10)),
     ((-10,-10,10),(-10,-10,-10)),((-10,10,10),(-10,10,-10)),
     ((10,10,10),(10,10,-10)),((10,-10,10),(10,-10,-10))
     );

type
    point = record
                  x,y,z:real;
            end;

var
   x,y,z                : integer;
   yoff,xoff,zoff       : integer;
   points               : array [1..maxlines, 1..2] of point;
   trans                : array [1..maxlines, 1..2] of point;
   lookup : array [0..360, 1..2] of real;

function rad (theta:real):real;
begin
     rad:=theta*pi/180;
end;

procedure perspective (x,y,z:integer);
begin
     xoff:=x;
     yoff:=y;
     zoff:=z;
end;

Procedure RotatePoints (X,Y,Z:Integer);
  { This rotates object lines by X,Y and Z; then places the result in
    TRANSLATED }
VAR loop1:integer;
    temp:point;
BEGIN
  For loop1:=1 to maxlines do BEGIN
    temp.x:=points[loop1,1].x;
    temp.y:=lookup[x,2]*points[loop1,1].y - lookup[x,1]*points[loop1,1].z;
    temp.z:=lookup[x,1]*points[loop1,1].y + lookup[x,2]*points[loop1,1].z;

    trans[loop1,1]:=temp;

    If y>0 then BEGIN
      temp.x:=lookup[y,2]*trans[loop1,1].x - lookup[y,1]*trans[loop1,1].y;
      temp.y:=lookup[y,1]*trans[loop1,1].x + lookup[y,2]*trans[loop1,1].y;
      temp.z:=trans[loop1,1].z;
      trans[loop1,1]:=temp;
    END;

    If z>0 then BEGIN
      temp.x:=lookup[z,2]*trans[loop1,1].x + lookup[z,1]*trans[loop1,1].z;
      temp.y:=trans[loop1,1].y;
      temp.z:=-lookup[z,1]*trans[loop1,1].x + lookup[z,2]*trans[loop1,1].z;
      trans[loop1,1]:=temp;
    END;

    temp.x:=points[loop1,2].x;
    temp.y:=cos (rad(X))*points[loop1,2].y - sin (rad(X))*points[loop1,2].z;
    temp.z:=sin (rad(X))*points[loop1,2].y + cos (rad(X))*points[loop1,2].z;

    trans[loop1,2]:=temp;

    If y>0 then BEGIN
      temp.x:=cos (rad(Y))*trans[loop1,2].x - sin (rad(Y))*trans[loop1,2].y;
      temp.y:=sin (rad(Y))*trans[loop1,2].x + cos (rad(Y))*trans[loop1,2].y;
      temp.z:=trans[loop1,2].z;
      trans[loop1,2]:=temp;
    END;

    If z>0 then BEGIN
      temp.x:=cos (rad(Z))*trans[loop1,2].x + sin (rad(Z))*trans[loop1,2].z;
      temp.y:=trans[loop1,2].y;
      temp.z:=-sin (rad(Z))*trans[loop1,2].x + cos (rad(Z))*trans[loop1,2].z;
      trans[loop1,2]:=temp;
    END;
  END;
END;

procedure setpoints;
var
   j : integer;
   k : integer;
begin
     for k:= 0 to 360 do
         begin
              lookup[k,1]:=sin (rad(k));
              lookup[k,2]:=cos (rad(k));
         end;

     for j:= 1 to maxlines do
         begin
              points[j,1].x:= obj[j,1,1];
              points[j,1].y:= obj[j,1,2];
              points[j,1].z:= obj[j,1,3];
              points[j,2].x:= obj[j,2,1];
              points[j,2].y:= obj[j,2,2];
              points[j,2].z:= obj[j,2,3];
         end;
end;


procedure display(where:word);
var
   loop1:integer;
   nx,ny,nx2,ny2:integer;
   temp : integer;

begin
     for loop1:= 1 to maxlines do
         begin
              if (points[loop1,1].z+zoff<0) and (points[loop1,2].z+zoff<0) then
                 begin
                      temp:=round (trans[loop1,1].z+zoff);
                      nx:=round (256*trans[loop1,1].x) div temp+xoff;
                      ny:=round (256*trans[loop1,1].y) div temp+yoff;
                      temp:=round (trans[loop1,2].z+zoff);
                      nx2:=round (256*trans[loop1,2].x) div temp+xoff;
                      ny2:=round (256*trans[loop1,2].y) div temp+yoff;
                      if (nx >0) and (nx < 320) and (ny > 25) and (ny < 200) and
                         (nx2>0) and (nx2< 320) and (ny2> 25) and (ny2< 200) then
                                 line (nx,ny,nx2,ny2,9,where);
                 end;
         end;
end;

procedure clear(where:word);
var
   loop1:integer;
   nx,ny,nx2,ny2:integer;
   temp : integer;
begin
     for loop1:= 1 to maxlines do
         begin
              if (points[loop1,1].z+zoff<0) and (points[loop1,2].z+zoff<0) then
                 begin
                      temp:=round (trans[loop1,1].z+zoff);
                      nx:=round (256*trans[loop1,1].x) div temp+xoff;
                      ny:=round (256*trans[loop1,1].y) div temp+yoff;
                      temp:=round (trans[loop1,2].z+zoff);
                      nx2:=round (256*trans[loop1,2].x) div temp+xoff;
                      ny2:=round (256*trans[loop1,2].y) div temp+yoff;
                      if (nx >0) and (nx < 320) and (ny > 25) and (ny < 200) and
                         (nx2>0) and (nx2< 320) and (ny2> 25) and (ny2< 200) then
                                 line (nx,ny,nx2,ny2,15,where);
                 end;
         end;
end;

var
   c:char;
   deg:integer;

begin
     directvideo:=false;
     setvga;
     cls(15,vaddr);
     cls(15,vga);
     perspective(160,100,-70);
     setpoints;
     deg:=(deg+5) mod 360;
     gotoxy(1,1);
     writeln('this is my 3d cube :)');
     readkey;
     repeat
           begin
                rotatepoints(deg,deg,deg);
                display(vaddr);
                delay(10);
                waitretrace;
                flip (vaddr,vga);
                clear(vaddr);
                rotatepoints (deg,deg,deg);
                deg:=(deg+5) mod 360;
                if keypressed then c:=readkey;
           end;
     until c=#27;
     settext;
end.

