unit Basic;
{
  BASIC.TPU
  Programmed by Boo Khan Ming

  Provides common string handling, and miscellaneous functions
}

interface

procedure CursorOn;
procedure CursorOff;
function UpperCase(s:string):string;
function LowerCase(s:string):string;
function ZeroPrecedence(c:word;Len:byte):string;
function FormatString(Len:byte;s:string):string;
function FormatWord(Len:byte;w:word):string;
function FormatReal(Len:byte;r:real):string;
procedure ClearKeyboardBuffer;

implementation

uses Crt;

procedure CursorOn; assembler;
asm
  mov ah,01h
  mov cx,0607h
  int 10h
end;

procedure CursorOff; assembler;
asm
  mov ah,01h
  mov cx,2020h
  int 10h
end;

function UpperCase(s:string):string;
var
  w:word;

begin
  for w:=1 to Length(s) do
    if (s[w]>='a') and (s[w]<='z') then
      Dec(s[w],32);
  UpperCase:=s;
end;

function LowerCase(s:string):string;
var
  w:word;

begin
  for w:=1 to Length(s) do
    if (s[w]>='A') and (s[w]<='Z') then
      Inc(s[w],32);
  LowerCase:=s;
end;

function ZeroPrecedence(c:word;Len:byte):string;
var
  s:string;
begin
  Str(c:0,s);
  while Length(s)<Len do
    s:='0'+s;
  ZeroPrecedence:=s;
end;

function FormatString(Len:byte;s:string):string;
var
  b:byte;
  ns:string;

begin
  if Len<Length(s) then
  begin
    FormatString:=Copy(s,1,Len);
    Exit;
  end;

  ns:=s;
  for b:=Length(ns)+1 to Len do
    ns:=ns+#32;

  FormatString:=ns;
end;

function FormatWord(Len:byte;w:word):string;
var
  b:byte;
  ns:string;

begin
  Str(w,ns);

  if Len<Length(ns) then
  begin
    FormatWord:=Copy(ns,1,Len);
    Exit;
  end;

  for b:=Length(ns)+1 to Len do
    ns:=ns+#32;

  FormatWord:=ns;
end;

function FormatReal(Len:byte;r:real):string;
var
  b:byte;
  ns:string;

begin
  Str(r:0:2,ns);

  if Len<Length(ns) then
  begin
    FormatReal:=Copy(ns,1,Len);
    Exit;
  end;

  for b:=Length(ns)+1 to Len do
    ns:=ns+#32;

  FormatReal:=ns;
end;

procedure ClearKeyboardBuffer;
begin
  while Keypressed do
    ReadKey;
end;

end.