PROGRAM Display_PCX;
USES CRT,DOS,GRAPH;

CONST
    BUFFERLENGTH = $FFFE;
    FINISH : BOOLEAN = FALSE;

TYPE
    PCXTYPE = OBJECT
                    KNOWN,V : BYTE;
                    COMPROM : BOOLEAN;
                    BITSPERPIXEL : BYTE;

                    FRAME : RECORD
                                  LEFT : WORD;
                                  TOP : WORD;
                                  RIGHT : WORD;
                                  BOTTOM : WORD;
                            END;

                    HIRES : WORD;
                    VRES : WORD;

                    COLOR : ARRAY[0..15] OF RECORD
                                                  RER : BYTE;
                                                  GREEN : BYTE;
                                                  BlUE : BYTE;
                                            END;

                    RESERVE : BYTE;
                    NUMLEVELS : BYTE;
                    NUMBYTESPERLYNE : WORD;
                    PALETINFO : WORD;
                    RESERVEAARRAY : ARRAY[1..58] OF BYTE;
              END;

    ARRBYTE = ARRAY[0..$FFFE] OF BYTE;

    RGBCOLOR = RECORD
                    RR : BYTE;
                    GG : BYTE;
                    BB : BYTE;
               END;

    VGAPELET = ARRAY[0..255] Of RGBCOLOR;

VAR
   AGAIN,COUNTER,TT,XX,YY,MAXX,MAXY : WORD;
   PCX : PCXTYPE;
   BUFFER,LINES : ^ARRBYTE;
   PCX_B : File;
   BUFSIZE : WORD;
   REGS : REGISTERS;
   COLOR256 : ARRAY[0..255] OF RECORD
                                     RED : BYTE;
                                     GREEN : BYTE;
                                     BLUE : BYTE;
                               END;
   PALETNR,ID : BYTE;
   T,XXX,YYY,Q,R,J,U : INTEGER;
   ABC : LONGINT;
   PPPP : POINTER;
   SSSS : WORD;
{============================================================================}
PROCEDURE READBUF;
BEGIN
     FINISH := FINISH OR EOF(PCX_B);
     BLOCKREAD(PCX_B,BUFFER^,SIZEOF(BUFFER^),BUFSIZE);
END;

PROCEDURE READ256COLOR;
BEGIN
     SEEK(PCX_B,FILESIZE(PCX_B) - 769);
     ID := 0;
     BLOCKREAD(PCX_B,ID,1);
     IF ID = 12
     THEN WITH REGS DO
     BEGIN
          BLOCKREAD(PCX_B,COLOR256,768);
          FOR PALETNR := 0 TO 255 DO
             WITH COLOR256[PALETNR] Do
             BEGIN
                  RED:= RED SHR 2;
                  GREEN:= GREEN SHR 2;
                  BLUE:= BLUE SHR 2;
             END;

             AX:= $1012;
             BX:= 0;
             CX:= 256;
             ES:= SEG(COLOR256);
             DX:= OFS(COLOR256);
             INTR($10,REGS);
     END;
     SEEK(PCX_B,SIZEOF(PCX));
END;

PROCEDURE INCREMENT;
BEGIN
     IF COUNTER < BUFFERLENGTH THEN INC(COUNTER)
     ELSE BEGIN
               COUNTER:= 0;
               READBUF;
          END;
END;

PROCEDURE LOAD_PCX(POSX,POSY,BROAD,HIGHT : WORD;PCXNAME : STRING);
BEGIN
     MAXX := (BROAD + POSX) - 1;
     MAXY := (HIGHT + POSY) - 1;
     ASSIGN(PCX_B,PCXNAME);
  {$I-}
     RESET(PCX_B,1);
  {$I+}
     IF IORESULT = 0
     THEN BEGIN
               BLOCKREAD(PCX_B,PCX,SIZEOF(PCX));
               GETMEM(BUFFER,BUFFERLENGTH);
               READ256COLOR;
               XX := POSX;
               YY := POSY;
               COUNTER := 0;
               READBUF;
               WHILE NOT FINISH DO
               BEGIN
                    IF BUFFER^[COUNTER] AND $C0 = $C0
                    THEN BEGIN
                              AGAIN := BUFFER^[COUNTER] - $C0;
                              INCREMENT;
                         END
                    ELSE AGAIN := 1;
                    FOR TT := 1 TO AGAIN DO
                    BEGIN
                         IF XX <= MAXX THEN PUTPIXEL(XX,YY,BUFFER^[COUNTER]);
                         INC(XX);
                    END;
                    IF XX >= PCX.NUMBYTESPERLYNE + POSX
                    THEN BEGIN
                              XX := POSX;
                              INC(YY);
                              IF YY > MAXY
                              THEN FINISH := TRUE;
                         END;
                    INCREMENT;
               END;
               FREEMEM(BUFFER,BUFFERLENGTH);
               CLOSE(PCX_B);
               FINISH := FALSE;
     END;
END;

PROCEDURE SETVIDEO(SCR : BYTE);
VAR
   AUTODETECT : POINTER;
   GRMOD,GRDRV : INTEGER;

  {$F+}
     FUNCTION DETECTVGA0 : INTEGER;
     BEGIN
          DETECTVGA0 := 0;
     END;

     FUNCTION DETECTVGA1 : INTEGER;
     BEGIN
          DETECTVGA1 := 1;
     END;

     FUNCTION DETECTVGA2 : INTEGER;
     BEGIN
          DETECTVGA2 := 2;
     END;

     FUNCTION DETECTVGA3 : INTEGER;
     BEGIN
          DETECTVGA3 := 3;
     END;

     FUNCTION DETECTVGA4 : INTEGER;
     BEGIN
          DETECTVGA4 := 4;
     END;
  {$F-}
BEGIN
     AUTODETECT := @DETECTVGA2;
     CASE SCR Of
     0 : AUTODETECT := @DETECTVGA0;
     1 : AUTODETECT := @DETECTVGA1;
     2 : AUTODETECT := @DETECTVGA2;
     3 : AUTODETECT := @DETECTVGA3;
     4 : AUTODETECT := @DETECTVGA4;
     END;

     GRDRV := INSTALLUSERDRIVER('SVGA256',AUTODETECT);
     GRDRV := DETECT;
     INITGRAPH(GRDRV,GRMOD,'');
END;


{ H O O F - P R O G R A M }
            {IMAGE : 640 width * 480 height * 256 COLORS}
 VAR
  qwe : char;
  grDriver : Integer;
  grMode   : Integer;
  ErrCode  : Integer;
BEGIN
 grDriver := Detect;
 SetVideo(2);
 CLEARDEVICE;
{
LOAD_PCX
(0,       [ Die X - posisie op die grafika skerm waar jy wil begin ]
 0,                [ Die Y - posisie op die grafika skerm waar jy wil begin ]

                                                          ################
 640,              [ Die X - groote van die PCX - file ]  #  LEES ONDER  #
 480,              [ Die Y - groote van die PCX - file ]  ################

 'A:\DUNCAN.PCX'); [ Die volledige naam en directory van PCX - file
 #############################################################################
 #             OM DIE X- & Y-GROOTTE VAN DIE PCX -FILE TE KRY                #
 #             ----------------------------------------------                #
 #                                                                           #
 #   Gaan na paint in " WINDOWS "                                           #
 #   Kies "File" , "Open"                                                   #
 #   Kies die PCX-file wat jy in die Load_Pcx - procedure gespesifiseer het #
 #   Kies "Image"  ,  "Atttributes"                                         #
 #   Let op na die volgende :   UnitsĿ         #
 #                                                      [X] Pels           #
 #                                       #
 #   Width is jou X - grootte                                               #
 #   Height is jou Y - grootte                                              #
 #############################################################################
}


 LOAD_PCX(0,0,640,480,'EXAMPLE.PCX'); { load pcx images 640 x 480 x 256 colors }
 Readln;
 ClearViewport;
 SetColor(28);
END.

