{****************************************************
*  The big F. Yes the mouse controlled program      *
*showing the 3D possibilities through Turbo Pascal  *
*A unique program, created 25/11/96, to demonstrate *
*how to program in 3D.                              *
*  Aren't you bored of those crappy 2D pictures,    *
*you've been displaying up on screen all your so    *
*called programming life (get a life) 3D programming*
*is the way ahead now, and this program shows you   *
*how to do it!!                                     *
*                                                   *
*  Just thank me for saving you from that shite life*
*you where almost stuck with until you down-loaded  *
*this.                                              *
*                                                   *
*finbarrs_F: programmed by Adam "Finbarr" Saunders  *
*                 email me <acsaunde@csm.uwe.ac.uk> *
****************************************************}

{$m,16000,0,64000}
program finbarrs_F;

uses crt,graph,fin;

const num=72;{number of pixels in box}

var pixel:array[1..num] of record
                            x,y,z:real;
                           end;
    pcos,ncos,psin,nsin:real;
    c:char;
    page,mtype:byte;
    size,h,v:integer;
    music:boolean;

procedure rotx(dir:byte);
var y1,z1:real;
    i:integer;
begin
 for i:=1 to num do
  begin
   if dir=1 then
    begin
     y1:=pcos*pixel[i].y-psin*pixel[i].z;
     z1:=psin*pixel[i].y+pcos*pixel[i].z;
    end
    else
    begin
     y1:=ncos*pixel[i].y-nsin*pixel[i].z;
     z1:=nsin*pixel[i].y+ncos*pixel[i].z;
    end;
   pixel[i].y:=y1;
   pixel[i].z:=z1;
  end;
end;

procedure roty(dir:byte);
var x1,z1:real;
    i:integer;
begin
 for i:=1 to num do
  begin
   if dir=1 then
    begin
     x1:=pcos*pixel[i].x-psin*pixel[i].z;
     z1:=psin*pixel[i].x+pcos*pixel[i].z;
    end
    else
    begin
     x1:=ncos*pixel[i].x-nsin*pixel[i].z;
     z1:=nsin*pixel[i].x+ncos*pixel[i].z;
    end;
   pixel[i].x:=x1;
   pixel[i].z:=z1;
  end;
end;

procedure rotz(dir:byte);
var x1,y1:real;
    i:integer;
begin
 for i:=1 to num do
  begin
   if dir=1 then
    begin
     y1:=pcos*pixel[i].y-psin*pixel[i].x;
     x1:=psin*pixel[i].y+pcos*pixel[i].x;
    end
    else
    begin
     y1:=ncos*pixel[i].y-nsin*pixel[i].x;
     x1:=nsin*pixel[i].y+ncos*pixel[i].x;
    end;
   pixel[i].x:=x1;
   pixel[i].y:=y1;
  end;
end;

procedure display_box;
var i,x,y,x1,y1:integer;
begin
 setactivepage(page);
 delay(10);
 cleardevice;
 for i:=1 to 71 do
  begin
   if i in[1..21,23..35,37..53,55..71]then
    begin
     setcolor(trunc(8-pixel[i].z/(size div 5))+1);
     x:=getmaxx div 2+round(pixel[i].x);
     y:=getmaxy div 2+round(pixel[i].y);
     x1:=getmaxx div 2+round(pixel[i+1].x);
     y1:=getmaxy div 2+round(pixel[i+1].y);
     line(x,y,x1,y1);
    end;
  end;
 line(getmaxx div 2+round(pixel[22].x),getmaxy div 2+round(pixel[22].y),
      getmaxx div 2+round(pixel[1].x),getmaxy div 2+round(pixel[1].y));
 line(getmaxx div 2+round(pixel[36].x),getmaxy div 2+round(pixel[36].y),
      getmaxx div 2+round(pixel[23].x),getmaxy div 2+round(pixel[23].y));
 line(getmaxx div 2+round(pixel[54].x),getmaxy div 2+round(pixel[54].y),
      getmaxx div 2+round(pixel[37].x),getmaxy div 2+round(pixel[37].y));
 line(getmaxx div 2+round(pixel[72].x),getmaxy div 2+round(pixel[72].y),
      getmaxx div 2+round(pixel[55].x),getmaxy div 2+round(pixel[55].y));
 setvisualpage(page);
 page:=1-page;
end;

procedure init;
const col:array[1..15]of byte=(1,2,3,4,5,20,7,56,57,58,59,60,61,62,63);
var i,x,y,z:integer;
    f:text;
    st:string;
begin
 music:=false;
 if(paramstr(1)='sb')or(paramstr(1)='SB')then
  begin
   music:=true;
   mtype:=7;
  end;
 if(paramstr(1)='ps')or(paramstr(1)='PS')then
  begin
   music:=true;
   mtype:=0;
  end;
 if((music)and(paramcount<>2))then music:=false;
 initmouse;
 x:=9;
 y:=1;
 initgraph(x,y,'egavga.bgi');
 if music then
  begin
   modinit;
   modvolume(255,255,255,255);
   modname:=paramstr(2);
   modsetup(stat,mtype,14422,0,4,modname);
   case stat of
    1:writeln('Error In Module.');
    2:writeln('Already Playing A Module.');
    4:writeln('Not Enough Memory To Play Module.');
   end;
   if stat in[1,2,4] then halt(1);
  end;
 size:=50;
 assign(f,'F.dat');
 reset(f);
 for i:=1 to num do
  begin
   readln(f,pixel[i].x);
   readln(f,pixel[i].y);
   pixel[i].z:=0;
   readln(f);
  end;
 for i:=1 to 15 do setrgbpalette(col[i],64-i*4,64-i*4,64-i*4);
 page:=1;
 setactivepage(page);
 display_box;
end;

procedure workout(r:integer);
begin
 pcos:=cos(r div 2*2*pi/360);
 ncos:=cos(-r div 2*2*pi/360);
 psin:=sin(r div 2*2*pi/360);
 nsin:=sin(-r div 2*2*pi/360);
end;

begin
 init;
 display_box;
 repeat
 if rclick then
  repeat
   mousemove(h,v);
   if h<0 then begin workout(-h);rotz(1);end;
   if h>0 then begin workout(h);rotz(0);end;
   if h<>0 then display_box;
  until rrelease;
  mousemove(h,v);
  if v<0 then begin workout(-v);rotx(1);end;
  if v>0 then begin workout(v);rotx(0);end;
  if h<0 then begin workout(-h);roty(1);end;
  if h>0 then begin workout(h);roty(0);end;
  if(v<>0)or(h<>0)then display_box;
 until lclick;
 closegraph;
 if music then modstop;
end.