Unit Graphics;
Interface
Procedure WaitRetrace;
Procedure DrawBlock(x,y:Integer);
Procedure WriteText(x,y:integer; s:string; cl:byte);
Procedure ReadText(x,y:integer; lng:byte; var s:string);
Procedure OpenPCX(name:string;x,y:integer);
Procedure Die1(Px,Py:Integer);
Implementation
Uses Crt, Graph, SMGraf;
(***************************************************************************)
Procedure WaitRetrace; Assembler;
Label
  L1,L2;
Asm
    Mov DX,3DAh
L1:
    IN AL,DX
    AND AL,08h
    JNZ l1
L2:
    IN AL,DX
    AND AL,08h
    JZ  l2
End;
(***************************************************************************)
Procedure DrawBlock(x,y:Integer);
Begin
SetColor(24);
Rectangle(10+x*4,10+y*4, 13+x*4, 13+y*4);
SetColor(25);
Rectangle(11+x*4,11+y*4,12+x*4,12+y*4);
PutPixel(12+x*4,12+y*4,26);
End;
(***************************************************************************)
Procedure WriteText(x,y:integer; s:string; cl:byte);
var
i,j:integer;
Begin
SetColor(16);
OutTextXY(0,0,s);
for i:=0 to 200 do for j:=0 to 8 Do
Begin
if getpixel(i,j)=16 Then DrawBlock(x+i,y+j);
End;
for i:=0 to 200 do for j:=0 to 8 Do
Begin
if getpixel(i,j)=16 Then PutPixel(i,j,cl);
End;
End;
(***************************************************************************)
Procedure ReadText(x,y:integer; lng:byte; var s:string);
var
gr:byte;
Ky:Char;
Begin
SetTextStyle(0,0,1);
Repeat
if Ky=#8 Then begin
Delete(s,length(s),1);
lng:=lng+1;
gr:=gr-8;
SetFillStyle(1,0);
Bar(x+gr,y,x+gr+8,y+8);
end;
if (((Ky>Chr(47))and(Ky<Chr(58)))or((Ky>Chr(64))and(Ky<Chr(91)))or((Ky>Chr(96))and(Ky<Chr(123))))and(lng>0) Then
Begin
 OutTextXY(x+gr,y,Ky);
 gr:=gr+8;
 s:=s+Ky;
 lng:=lng-1;
End;
Ky:=readkey;
Until (ky=#13);
End;
(***************************************************************************)
Procedure OpenPCX(name:string;x,y:integer);

type
	pcxheader=record
		man,ver,enc,bpp: byte;
		xl,yl,xh,yh,hres,vres: word;
		palette: array [0..47] of byte;
		rsr,cp: byte;
		bpl: word;
		ptype: word;
		filler: array [0..57] of byte;
	end;

var
	header: pcxheader;
	bytes: word;
	f: file;
  c:byte;
	cc: array[0..255] of byte;
	npal:array[0..255,1..3] of byte;
  count:byte;
  pal:array[0..255,1..3] of byte;
  i,j,k,z,zz,gd,gm:integer;
  width, height:integer;
  p:pointer;
  op:word;
  uur,min,sec,hon,t1,t2:word;

begin
	assign(f,name);
	{$I-}
	reset(f,1);
	{$I+}
	if ioresult=0 then
	begin
		blockread(f,header,sizeof(header));
		if (header.man=10) and (header.ver=5) and (header.bpp=8) and (header.cp=1) then
		begin
			seek (f,filesize(f)-769);
			blockread (f,c,1);
			if (c=12) then
			begin
				blockread (f,pal, 768);
				for i:=0 to 255 do for j:=1 to 3 do pal[i,j]:=pal[i,j] shr 2;
        for i:=0 to 255 do setpal(i,pal[i,1],pal[i,2],pal[i,3]);
				seek (f, 128);
				width:=header.xh-header.xl;
				height:=header.yh-header.yl;
				bytes:=header.bpl;
        count:=255;
				for j:=0 to height do
				begin
					i:=0;
					k:=0;
					while (k<bytes) do
					begin
            inc(count);
            if count=0 then blockread(f,cc,256);
						if ((cc[count] and 192)=192) then
						begin
							z:=cc[count] and 63;
              inc(count);
              if count=0 then blockread(f,cc,256);
							k:=k+z;
							for zz:=0 to z-1 do
							begin
								putpixel(i,j,cc[count]);
								inc(i);
							end;
						end else
						begin
							inc(k);
							putpixel(i,j,cc[count]);
							inc(i);
						end;
					end;
				end;
			end;
  	end;
	end;
end;
(***************************************************************************)
Procedure Die1(Px,Py:Integer);
Begin
PutPixel(Px+5,Py+0,41);
PutPixel(Px+6,Py+0,41);
PutPixel(Px+2,Py+1,41);
PutPixel(Px+3,Py+1,41);
PutPixel(Px+4,Py+1,41);
PutPixel(Px+5,Py+1,41);
PutPixel(Px+6,Py+1,41);
PutPixel(Px+7,Py+1,41);
PutPixel(Px+1,Py+2,41);
PutPixel(Px+2,Py+2,41);
PutPixel(Px+3,Py+2,41);
PutPixel(Px+4,Py+2,41);
PutPixel(Px+5,Py+2,41);
PutPixel(Px+6,Py+2,41);
PutPixel(Px+0,Py+3,41);
PutPixel(Px+1,Py+3,41);
PutPixel(Px+2,Py+3,64);
PutPixel(Px+3,Py+3,64);
PutPixel(Px+4,Py+3,64);
PutPixel(Px+5,Py+3,41);
PutPixel(Px+6,Py+3,41);
PutPixel(Px+1,Py+4,41);
PutPixel(Px+2,Py+4,41);
PutPixel(Px+3,Py+4,64);
PutPixel(Px+4,Py+4,64);
PutPixel(Px+5,Py+4,64);
PutPixel(Px+6,Py+4,41);
PutPixel(Px+7,Py+4,41);
PutPixel(Px+2,Py+5,41);
PutPixel(Px+3,Py+5,41);
PutPixel(Px+4,Py+5,64);
PutPixel(Px+5,Py+5,64);
PutPixel(Px+6,Py+5,64);
PutPixel(Px+7,Py+5,41);
PutPixel(Px+8,Py+5,41);
PutPixel(Px+2,Py+6,41);
PutPixel(Px+3,Py+6,41);
PutPixel(Px+4,Py+6,64);
PutPixel(Px+5,Py+6,64);
PutPixel(Px+6,Py+6,64);
PutPixel(Px+7,Py+6,41);
PutPixel(Px+8,Py+6,41);
PutPixel(Px+1,Py+7,41);
PutPixel(Px+2,Py+7,41);
PutPixel(Px+3,Py+7,64);
PutPixel(Px+4,Py+7,64);
PutPixel(Px+5,Py+7,64);
PutPixel(Px+6,Py+7,41);
PutPixel(Px+7,Py+7,41);
PutPixel(Px+8,Py+7,41);
PutPixel(Px+9,Py+7,41);
PutPixel(Px+1,Py+8,41);
PutPixel(Px+2,Py+8,41);
PutPixel(Px+3,Py+8,41);
PutPixel(Px+4,Py+8,41);
PutPixel(Px+5,Py+8,41);
PutPixel(Px+6,Py+8,41);
PutPixel(Px+7,Py+8,41);
PutPixel(Px+8,Py+8,41);
PutPixel(Px+2,Py+9,41);
PutPixel(Px+3,Py+9,41);
PutPixel(Px+4,Py+9,41);
PutPixel(Px+5,Py+9,41);
End;
(***************************************************************************)
End.
