{$R-,S-,I-}
program SampleModule1;
{
  Sample Module 1
  Programmed by Boo Khan Ming

  This is an module example for album database maintenance.
}

uses Dos,Crt,Screen,Basic;

const
  SubTitle='Sample Module 1 - Album Database Maintenance';
  DataFilename='ALBUM.DAT';
  MaxStock=200; { maximum number of album allowed }

type
  StockRecType=record
    MediaType:word;
    MediaTitle:string[20];
    AlbumSinger:string[20];
    SerialNumber:string[10];
    Quantity:word;
    Cost:real;
    SalePrice:real;
    MemberPrice:real;
  end;
  StockFileType=file of StockRecType;

label
  Redo,ExitPoint;

var
  { common variables }
  y,y2:byte;
  w:word;
  r:real;
  s:string;
  f:file;

  { long name variables }
  MenuArray:PopUpMenuArrayType;
  BrowseArray:array [1..MaxStock] of string[80];
  Status:byte;
  Lst:text;

  { specific variables }
  MediaType:byte;
  StockRec:array [1..MaxStock] of StockRecType;
  StockFile:StockFileType;
  TempRec:StockRecType;
  CurrentRecPtr:byte;
  bRecExist:boolean;

function OpenFile:boolean;
begin
  OpenFile:=False;

  Assign(StockFile,DataFilename);
  Reset(StockFile);

  { check if found }
  if IOResult=0 then
  begin
    if FileSize(StockFile)=0 then
      CurrentRecPtr:=0
    else
      CurrentRecPtr:=FileSize(StockFile)-1
  end
  else
  { otherwise create new file }
  begin
    Rewrite(StockFile);
    CurrentRecPtr:=0;

    { check if still disk error (possibly disk is write-protected) }
    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to create file on disk.');

      repeat until Keypressed;
    end;
  end;

  OpenFile:=True;
end;

procedure EditAlbumRecord(RecNum:word);
{ for Add, Edit }
var
  InputText:string;
  New:boolean;

begin
  if RecNum=0 then
  begin
    New:=True;
    Inc(CurrentRecPtr);
    RecNum:=CurrentRecPtr;

    OpenDialog(2,3,79,24,'Add Album Record');
  end
  else
  begin
    New:=False;
    OpenDialog(2,3,79,24,'Edit Album Record');
  end;

  StockRec[RecNum].MediaType:=MediaType;

  CursorOn;

  InputText:=StockRec[RecNum].MediaTitle;
  if not AcquireString(5,6,20,'Media Title:     ',InputText) then
  begin
    if New then
      Dec(CurrentRecPtr);
    Exit;
  end;
  StockRec[RecNum].MediaTitle:=InputText;

  InputText:=StockRec[RecNum].AlbumSinger;
  if not AcquireString(5,7,20,'Album Singer:    ',InputText) then
  begin
    if New then
      Dec(CurrentRecPtr);
    Exit;
  end;
  StockRec[RecNum].AlbumSinger:=InputText;

  InputText:=StockRec[RecNum].SerialNumber;
  if not AcquireString(5,8,10,'Serial Number:   ',InputText) then
  begin
    if New then
      Dec(CurrentRecPtr);
    Exit;
  end;
  StockRec[RecNum].SerialNumber:=InputText;

  if not AcquireWord(5,9,4,   'Quantity:        ',StockRec[RecNum].Quantity) then
  begin
    if New then
      Dec(CurrentRecPtr);
    Exit;
  end;

  if not AcquireReal(5,10,6, 'Cost:         RM ',StockRec[RecNum].Cost) then
  begin
    if New then
      Dec(CurrentRecPtr);
    Exit;
  end;
  if not AcquireReal(5,11,6, 'Sale Price:   RM ',StockRec[RecNum].SalePrice) then
  begin
    if New then
      Dec(CurrentRecPtr);
    Exit;
  end;
  if not AcquireReal(5,12,6, 'Member Price: RM ',StockRec[RecNum].MemberPrice) then
  begin
    if New then
      Dec(CurrentRecPtr);
    Exit;
  end;

  CursorOff;

  Seek(StockFile,RecNum);
  Write(StockFile,StockRec[RecNum]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to save records to file.');

    repeat until Keypressed;

    if New then
      Dec(CurrentRecPtr);

    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  if New then
    Write('New record saved.')
  else
    Write('Changes saved.');

  repeat until Keypressed;
end;

function FindAlbumRecord:word;
{ for Display Single, Find }
var
  FindText:string;
  w:word;

begin
  bRecExist:=False;
  FindAlbumRecord:=255;

  OpenDialog(2,3,79,24,'Find Album Record');
  CursorOn;

  if not AcquireString(5,6,20,'Media Title to Find: ',FindText) then
    FindAlbumRecord:=0;

  CursorOff;

  for w:=1 to CurrentRecPtr do
  begin
    Seek(StockFile,w);
    Read(StockFile,StockRec[w]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to find records on file.');

      repeat until Keypressed;
      Exit;
    end;

    if (UpperCase(StockRec[w].MediaTitle)=UpperCase(FindText)) and
    (StockRec[w].MediaType=MediaType) then
    begin
      bRecExist:=True;
      FindAlbumRecord:=w;

      Exit;
    end;
  end;
end;

procedure DisplayAlbumRecord(RecNum:word);
{ for Display Single only }
begin
  OpenDialog(2,3,79,24,'Display Single Album Record');

  Seek(StockFile,RecNum);
  Read(StockFile,StockRec[RecNum]);
  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to retrieve record from file.');

    repeat until Keypressed;
    Exit;
  end;

  Write('Media Type:    ');
  case StockRec[RecNum].MediaType of
    1:WriteLn('Audio CD');
    2:WriteLn('Video CD');
    3:WriteLn('Cassette Tape');
    else
      WriteLn('N/A');
  end;

  WriteLn('Media Title:   ',StockRec[RecNum].MediaTitle);
  WriteLn('Album Singer:  ',StockRec[RecNum].AlbumSinger);
  WriteLn('Serial Number: ',StockRec[RecNum].SerialNumber);
  WriteLn('Quantity:      ',StockRec[RecNum].Quantity);
  WriteLn('Cost:          ',StockRec[RecNum].Cost:0:2);
  WriteLn('Sale Price:    ',StockRec[RecNum].SalePrice:0:2);
  WriteLn('Member Price:  ',StockRec[RecNum].MemberPrice:0:2);

  repeat until Keypressed;
end;

function BrowseAlbumRecord:word;
{ for Display All, Delete Single, Edit, Print Single }
const
  MaxViewLine=16;
label
  Redo;
var
  b,b2:byte;
  c:char;
  w:word;
  NewChoice,OldChoice:byte;
  RecStart,RecEnd,RecLen:word;

  procedure UpdateBrowser;
  var
    b:byte;
  begin
    if NewChoice<>OldChoice then   { skip unnecessary updates }
    begin
      TextColor(MenuFrontColor);
      TextBackground(MenuBackColor);

      GotoXY(1,OldChoice);
      Write(BrowseArray[RecStart+OldChoice-1]);

      Write(#32:(74-Length(BrowseArray[RecStart+OldChoice-1])));

      TextColor(SelectionBarFrontColor);
      TextBackground(SelectionBarBackColor);

      GotoXY(1,NewChoice);
      Write(BrowseArray[RecStart+NewChoice-1]);

      Write(#32:(74-Length(BrowseArray[RecStart+NewChoice-1])));
    end;
  end;

  function FindRecords:boolean;
  var
    w,w2:word;
  begin
    FindRecords:=False;

    w2:=1;
    for w:=1 to CurrentRecPtr do
    begin
      Seek(StockFile,w);
      Read(StockFile,StockRec[w]);

      if IOResult<>0 then
      begin
        OpenErrorDialog(10,10,70,15,'Disk Operation Error');
        Write('Program was unable to find records on file.');

        repeat until Keypressed;
        Exit;
      end;

      if StockRec[w].MediaType=MediaType then
      begin
        BrowseArray[w2]:=FormatString(17,StockRec[w].MediaTitle)+#32
                        +FormatString(17,StockRec[w].AlbumSinger)+#32
                        +FormatString(11,StockRec[w].SerialNumber)
                        +FormatWord(5,StockRec[w].Quantity)
                        +FormatReal(7,StockRec[w].Cost)
                        +FormatReal(7,StockRec[w].SalePrice)
                        +FormatReal(7,StockRec[w].MemberPrice);
        Inc(w2);
      end;
    end;

    RecLen:=w2;
    FindRecords:=True;
  end;

begin
  BrowseAlbumRecord:=0;

  RecStart:=1;
  RecEnd:=MaxViewLine;

  for w:=1 to 200 do
    BrowseArray[w]:='';

  if not FindRecords then
    Exit;

Redo:
  OpenDialog(2,3,79,24,'Browse Album Record');

  Window(3,5,78,5);
  TextColor(SubTitleBarFrontColor);
  TextBackground(SubTitleBarBackColor);
  ClrScr;
  Write(#32,FormatString(17,'Media Title'),#32,FormatString(17,'Album Singer'),
        #32,FormatString(11,'Serial No'),FormatString(5,'Qty'),
        FormatString(7,'Cost'),FormatString(7,'Sale'),
        FormatString(7,'Member'));

  Window(2+2,3+3,79-2,24-2);

  TextColor(MenuFrontColor);
  TextBackground(MenuBackColor);
  ClrScr;

  b2:=0;
  for b:=RecStart to RecEnd do
  begin
    Inc(b2);
    GotoXY(1,b2);
    Write(BrowseArray[b]);
  end;

  c:=#0;
  NewChoice:=1;
  OldChoice:=2;

  UpdateBrowser;

  repeat
    if Keypressed then
    begin
      OldChoice:=NewChoice;

      c:=ReadKey;
      case c of
        { up direction }
        #72:Dec(NewChoice);
        { down direction }
        #80:Inc(NewChoice);
        { home key }
        #71:NewChoice:=1;
        { end key }
        #79:NewChoice:=MaxViewLine;
        { page up key }
        #73:
        if RecStart>1 then
        begin
          Dec(RecStart,MaxViewLine);
          RecEnd:=RecStart+MaxViewLine-1;

          goto Redo;
        end;
        { page down key }
        #81:
        if RecEnd<RecLen-1 then
        begin
          Inc(RecStart,MaxViewLine);
          RecEnd:=RecStart+MaxViewLine;

          goto Redo;
        end;
        { enter key - select }
        #13:
        if RecStart+NewChoice-1<RecLen then
        begin
          BrowseAlbumRecord:=RecStart+NewChoice-1;
          Exit;
        end;
      end;

      { check menu pointer range }
      if NewChoice<1 then
        NewChoice:=1;
      if NewChoice>MaxViewLine then
        NewChoice:=MaxViewLine;

      UpdateBrowser;
    end;
  until c=#27; { esc key - cancel }
end;

procedure DeleteAlbumRecord(RecNum:word);
{ for Delete Single only }
begin
  ClearKeyboardBuffer;

  OpenWarningDialog(30,8,70,16,'Delete Selected Record?');

  MenuArray[1]:='  Yes  ';
  MenuArray[2]:='  No   ';

  Status:=PopUpMenu(MenuArray,2);

  if Status in [2,255] then
    Exit;

  if RecNum=CurrentRecPtr then
  begin
    { cut off file at current position }
    Seek(StockFile,CurrentRecPtr);
    Truncate(StockFile);
  end else
  { otherwise located somewhere inside the file }
  begin
    { move record from EOF to replace deleted record }
    Seek(StockFile,CurrentRecPtr);
    Read(StockFile,TempRec);
    Seek(StockFile,RecNum);
    Write(StockFile,TempRec);
    Seek(StockFile,CurrentRecPtr);
    Truncate(StockFile);
  end;

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to delete record from file.');

    repeat until Keypressed;
    Exit;
  end;

  Dec(CurrentRecPtr);

  OpenDialog(10,10,70,15,'');
  Write('Record deleted.');

  repeat until Keypressed;
end;

procedure DeleteAllAlbumRecord;
{ for Delete All only }
var
  w:word;

begin
  ClearKeyboardBuffer;

  OpenWarningDialog(30,8,70,16,'Delete All Records?');

  MenuArray[1]:='  Yes  ';
  MenuArray[2]:='  No   ';

  Status:=PopUpMenu(MenuArray,2);

  if Status in [2,255] then
    Exit;

  for w:=1 to CurrentRecPtr do
  begin
    Seek(StockFile,w);
    Read(StockFile,StockRec[w]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to find records on file.');

      repeat until Keypressed;
      Exit;
    end;

    if StockRec[w].MediaType=MediaType then
    begin
      { Not really erase the record, instead make the record invisible }
      StockRec[w].MediaType:=255;
      Seek(StockFile,w);
      Write(StockFile,StockRec[w]);

      Dec(CurrentRecPtr);
    end;
  end;

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to delete records from file.');

    repeat until Keypressed;
    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('All records deleted.');

  repeat until Keypressed;
end;

procedure PrintAlbumRecord(RecNum:word);
{ for Print Single only }
begin
  ClearKeyboardBuffer;

  OpenWarningDialog(30,8,70,16,'Is Printer Ready?');

  MenuArray[1]:='  Yes  ';
  MenuArray[2]:='  No   ';

  Status:=PopUpMenu(MenuArray,2);

  if Status in [2,255] then
    Exit;

  OpenDialog(10,10,70,15,'');
  Write('Printing...');

  Assign(Lst,'PRN');
  Rewrite(Lst);

  { *************** Put your print routine here ******************* }



  { *************************************************************** }

  { form feed paper }
  Write(Lst,#12);
  Close(Lst);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Printer Device Error');
    Write('Program was unable to print record.');

    repeat until Keypressed;
    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('Record printed.');

  repeat until Keypressed;
end;

procedure PrintAllAlbumRecord;
{ for Print All only }
var
  w:word;

begin
  ClearKeyboardBuffer;

  OpenWarningDialog(30,8,70,16,'Is Printer Ready?');

  MenuArray[1]:='  Yes  ';
  MenuArray[2]:='  No   ';

  Status:=PopUpMenu(MenuArray,2);

  if Status in [2,255] then
    Exit;

  OpenDialog(10,10,70,15,'');
  Write('Printing...');

  Assign(Lst,'PRN');
  Rewrite(Lst);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Printer Device Error');
    Write('Program was unable to print record.');

    repeat until Keypressed;
    Exit;
  end;

  for w:=1 to CurrentRecPtr do
  begin
    Seek(StockFile,w);
    Read(StockFile,StockRec[w]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to find records on file.');

      repeat until Keypressed;
      Exit;
    end;

    if StockRec[w].MediaType=MediaType then
    begin
      { *************** Put your print routine here ******************* }



      { *************************************************************** }
    end;
  end;

  { form feed paper }
  Write(Lst,#12);

  Close(Lst);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Printer Device Error');
    Write('Program was unable to print records.');

    repeat until Keypressed;
    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('All records printed.');

  repeat until Keypressed;
end;

function FindActualRecord(Media:byte;RelPtr:word):word;
var
  w,w2:word;

begin
  FindActualRecord:=0;
  w2:=0;

  for w:=1 to CurrentRecPtr do
  begin
    Seek(StockFile,w);
    Read(StockFile,StockRec[w]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to find records on file.');

      repeat until Keypressed;
      Exit;
    end;

    if StockRec[w].MediaType=Media then
    begin
      Inc(w2);
      if w2=RelPtr then
      begin
        FindActualRecord:=w;
        Exit;
      end;
    end;
  end;
end;

begin
  PrepareTextScreen;

  OpenScreen(SubTitle);
  SaveScreen(1);

  CursorOff;

  if not OpenFile then
    goto ExitPoint;

Redo:
  { clear type ahead keyboard buffer }
  ClearKeyboardBuffer;

  CursorOff;
  RestoreScreen(1);

  OpenDialog(30,7,50,16,'Media Type');

  MenuArray[1]:='  Audio CD      ';
  MenuArray[2]:='  Video CD      ';
  MenuArray[3]:='  Casette Tape  ';
  MenuArray[4]:='';
  MenuArray[5]:='  Exit          ';

  Status:=PopUpMenu(MenuArray,5);

  RestoreScreen(1);

  { quit module if cancelled }
  if Status>=5 then
    goto ExitPoint
  else
    MediaType:=Status;

  OpenDialog(20,6,60,18,'Record Maintenance Options');
  MenuArray[1]:='  Add Album Record         ';
  MenuArray[2]:='  Display Album Record...  ';
  MenuArray[3]:='  Edit Album Record        ';
  MenuArray[4]:='  Delete Album Record...   ';
  MenuArray[5]:='  Find Album Record        ';
  MenuArray[6]:='  Print Album Record...    ';
  MenuArray[7]:='';
  MenuArray[8]:='  Back to Main Menu        ';

  Status:=PopUpMenu(MenuArray,8);

  RestoreScreen(1);

  { quit module if cancelled }
  if Status>=8 then
    goto Redo
  else
  begin
    y:=Status;

    if Status in [2,4,6] then
    begin
      OpenDialog(25,8,55,14,'Display/Delete/Find');
      MenuArray[1]:='  Single Record Only  ';
      MenuArray[2]:='  All Records         ';

      Status:=PopUpMenu(MenuArray,2);

      RestoreScreen(1);

      { quit module if cancelled }
      if Status=255 then
        goto Redo;
    end;

    case y of
      { Add }
      1:EditAlbumRecord(0);
      { Display }
      2:
      case Status of
        1:
        begin
          y2:=BrowseAlbumRecord;
          if y2>0 then
            DisplayAlbumRecord(FindActualRecord(MediaType,y2));
        end;
        2:BrowseAlbumRecord;
      end;
      { Edit }
      3:
      begin
        y2:=BrowseAlbumRecord;
        if y2>0 then
          EditAlbumRecord(FindActualRecord(MediaType,y2));
      end;
      { Delete }
      4:
      case Status of
        1:
        begin
          y2:=BrowseAlbumRecord;
          if y2>0 then
            DeleteAlbumRecord(FindActualRecord(MediaType,y2));
        end;
        2:DeleteAllAlbumRecord;
      end;
      { Find }
      5:
      begin
        y2:=FindAlbumRecord;
        if (not bRecExist) and (y2<>0) then
        begin
          OpenErrorDialog(10,10,70,15,'Record Not Found');
          Write('No matching record found.');

          repeat until Keypressed;
        end
        else if bRecExist then
          DisplayAlbumRecord(y2);
      end;
      { Print }
      6:
      case Status of
        1:
        begin
          y2:=BrowseAlbumRecord;
          if y2>0 then
            PrintAlbumRecord(FindActualRecord(MediaType,y2));
        end;
        2:PrintAllAlbumRecord;
      end;
    end;

    goto Redo;
  end;

ExitPoint:
  Close(StockFile);

  ShutTextScreen;
end.