{$R-,S-,I-}
program SampleModule2;
{
  Sample Module 1
  Programmed by Boo Khan Ming

  This is an module example for record maintenance over database files.
}

uses Dos,Crt,Screen,Basic;

const
  MaxCustomerMasterFileRecord=200;
  MaxStockMasterFileRecord=200;
  MaxInvoiceFileRecord=200;
  MaxOrderFileRecord=200;

  CustomerMasterFileName='CUSTOMER.DAT';
  StockMasterFileName='STOCK.DAT';
  InvoiceFileName='INVOICE.DAT';
  OrderFileName='REORDER.DAT';

  ProgramTitle='Sample Module 2 - Database File Record Maintenance';

type
  DateType=record
    Day,Month:byte;
    Year:word;
  end;

  CustomerMasterFileRecordType=record
    Name:string[50];
    AccountNo:string[6];
    Address:string[70];
    TelNo:string[10];
    CreditLimit:word;
    OutstandingBalance:real;
    LastPayment:DateType;
  end;

  StockMasterFileRecordType=record
    ProductCode:string[6];
    Description:string[20];
    Quantity:word;
    CostPrice:real;
  end;

  InvoiceFileRecordType=record
    InvoiceNo:string[6];
    CustomerAccountNo:string[6];
    StockNo:string[6];
    Quantity:word;
    Cost:real;
    TotalCost:real;
    DateSend:DateType;
    DatePaid:DateType;
  end;

  OrderFileRecordType=record
    OrderNo:string[6];
    Quantity:word;
    StockNo:string[6];
    DateOrder:DateType;
    DatePaid:DateType;
  end;

  CustomerMasterFileType=file of CustomerMasterFileRecordType;
  StockMasterFileType=file of StockMasterFileRecordType;
  InvoiceFileType=file of InvoiceFileRecordType;
  OrderFileType=file of OrderFileRecordType;

label
  Redo;

var
  MenuArray:PopUpMenuArrayType;
  Status:byte;

  CustomerMasterFileRecord:array [1..MaxCustomerMasterFileRecord] of CustomerMasterFileRecordType;
  StockMasterFileRecord:array [1..MaxStockMasterFileRecord] of StockMasterFileRecordType;
  InvoiceFileRecord:array [1..MaxInvoiceFileRecord] of InvoiceFileRecordType;
  OrderFileRecord:array [1..MaxOrderFileRecord] of OrderFileRecordType;

  CustomerMasterFile:CustomerMasterFileType;
  StockMasterFile:StockMasterFileType;
  InvoiceFile:InvoiceFileType;
  OrderFile:OrderFileType;

  CustomerMasterFileRecordPtr,
  StockMasterFileRecordPtr,
  InvoiceFileRecordPtr,
  OrderFileRecordPtr:word;

  Counter:word;
  SelectedMenu:byte;
  Year,Month,Day,WeekDay:word;

procedure OpenDatabase;
begin
  Assign(CustomerMasterFile,CustomerMasterFileName);
  Reset(CustomerMasterFile);

  if IOResult=0 then
    CustomerMasterFileRecordPtr:=FileSize(CustomerMasterFile)
  else
    Rewrite(CustomerMasterFile);

  Assign(StockMasterFile,StockMasterFileName);
  Reset(StockMasterFile);

  if IOResult=0 then
    StockMasterFileRecordPtr:=FileSize(StockMasterFile)
  else
    Rewrite(StockMasterFile);

  Assign(InvoiceFile,InvoiceFileName);
  Reset(InvoiceFile);

  if IOResult=0 then
    InvoiceFileRecordPtr:=FileSize(InvoiceFile)
  else
    Rewrite(InvoiceFile);

  Assign(OrderFile,OrderFileName);
  Reset(OrderFile);

  if IOResult=0 then
    OrderFileRecordPtr:=FileSize(OrderFile)
  else
    Rewrite(OrderFile);

  { Preload all database entries onto memory }
  {
  for Counter:=1 to CustomerMasterFileRecordPtr do
    Read(CustomerMasterFile,CustomerMasterFileRecord[Counter]);

  for Counter:=1 to StockMasterFileRecordPtr do
    Read(StockMasterFile,StockMasterFileRecord[Counter]);

  for Counter:=1 to InvoiceFileRecordPtr do
    Read(InvoiceFile,InvoiceFileRecord[Counter]);

  for Counter:=1 to OrderFileRecordPtr do
    Read(OrderFile,OrderFileRecord[Counter]);
  }
end;

procedure CloseDatabase;
begin
  Close(CustomerMasterFile);
  Close(StockMasterFile);
  Close(InvoiceFile);
  Close(OrderFile);
end;

procedure AddCustomer;
var
  InputText:string;

begin
  OpenDialog(2,3,79,24,'Add Customer Record');
  CursorOn;

  Inc(CustomerMasterFileRecordPtr);

  CustomerMasterFileRecord[CustomerMasterFileRecordPtr].AccountNo:=ZeroPrecedence(CustomerMasterFileRecordPtr,6);
  GotoXY(2,1);
  Write('Account Number:      ',CustomerMasterFileRecord[CustomerMasterFileRecordPtr].AccountNo);

  InputText:='';
  if not AcquireString(5,7,50,'Name:                ',InputText) then
  begin
    Dec(CustomerMasterFileRecordPtr);
    Exit;
  end
  else
    CustomerMasterFileRecord[CustomerMasterFileRecordPtr].Name:=Copy(InputText,1,50);

  InputText:='';
  if not AcquireString(5,8,50,'Address:             ',InputText) then
  begin
    Dec(CustomerMasterFileRecordPtr);
    Exit;
  end
  else
    CustomerMasterFileRecord[CustomerMasterFileRecordPtr].Address:=Copy(InputText,1,70);

  InputText:='';
  if not AcquireString(5,9,10,'Phone Number:        ',InputText) then
  begin
    Dec(CustomerMasterFileRecordPtr);
    Exit;
  end
  else
    CustomerMasterFileRecord[CustomerMasterFileRecordPtr].TelNo:=Copy(InputText,1,10);

  if not AcquireWord(5,10,5,'Credit Limit:        ',CustomerMasterFileRecord[CustomerMasterFileRecordPtr].CreditLimit) then
  begin
    Dec(CustomerMasterFileRecordPtr);
    Exit;
  end;

  CursorOff;

  Seek(CustomerMasterFile,CustomerMasterFileRecordPtr-1);
  Write(CustomerMasterFile,CustomerMasterFileRecord[CustomerMasterFileRecordPtr]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to save record to file.');

    repeat until Keypressed;

    Dec(CustomerMasterFileRecordPtr);

    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('New record saved.');

  repeat until Keypressed;
end;

procedure AmendCustomer;
var
  InputText:string;
  FindStatus:boolean;

begin
  OpenDialog(2,3,79,24,'Amend Customer Record');
  CursorOn;

  InputText:='';
  if not AcquireString(5,6,6,'Account Number:      ',InputText) then
    Exit;

  CursorOff;

  FindStatus:=False;

  for Counter:=1 to FileSize(CustomerMasterFile) do
  begin
    Seek(CustomerMasterFile,Counter-1);
    Read(CustomerMasterFile,CustomerMasterFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if CustomerMasterFileRecord[Counter].AccountNo=Copy(InputText,1,6) then
    begin
      FindStatus:=True;
      CustomerMasterFileRecordPtr:=Counter;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    OpenErrorDialog(10,10,70,15,'Record Not Found');
    Write('No matching record found.');

    repeat until Keypressed;
    Exit;
  end;

  CursorOn;

  InputText:=CustomerMasterFileRecord[CustomerMasterFileRecordPtr].Name;
  if not AcquireString(5,7,50,'Name:                ',InputText) then
    Exit
  else
    CustomerMasterFileRecord[CustomerMasterFileRecordPtr].Name:=Copy(InputText,1,50);

  InputText:=CustomerMasterFileRecord[CustomerMasterFileRecordPtr].Address;
  if not AcquireString(5,8,50,'Address:             ',InputText) then
    Exit
  else
    CustomerMasterFileRecord[CustomerMasterFileRecordPtr].Address:=Copy(InputText,1,70);

  InputText:=CustomerMasterFileRecord[CustomerMasterFileRecordPtr].TelNo;
  if not AcquireString(5,9,10,'Phone Number:        ',InputText) then
    Exit
  else
    CustomerMasterFileRecord[CustomerMasterFileRecordPtr].TelNo:=Copy(InputText,1,10);

  if not AcquireWord(5,10,5,'Credit Limit:        ',CustomerMasterFileRecord[CustomerMasterFileRecordPtr].CreditLimit) then
    Exit;

  CursorOff;

  Seek(CustomerMasterFile,CustomerMasterFileRecordPtr-1);
  Write(CustomerMasterFile,CustomerMasterFileRecord[CustomerMasterFileRecordPtr]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to save record to file.');

    repeat until Keypressed;
    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('Changes saved.');

  repeat until Keypressed;
end;

procedure DeleteCustomer;
var
  InputText:string;
  FindStatus:boolean;
  TemporaryCustomerMasterFileRecord:CustomerMasterFileRecordType;

begin
  OpenDialog(2,3,79,24,'Delete Customer Record');
  CursorOn;

  InputText:='';
  if not AcquireString(5,6,6,'Account Number:      ',InputText) then
    Exit;

  CursorOff;

  FindStatus:=False;

  for Counter:=1 to FileSize(CustomerMasterFile) do
  begin
    Seek(CustomerMasterFile,Counter-1);
    Read(CustomerMasterFile,CustomerMasterFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if CustomerMasterFileRecord[Counter].AccountNo=Copy(InputText,1,6) then
    begin
      FindStatus:=True;
      CustomerMasterFileRecordPtr:=Counter;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    OpenErrorDialog(10,10,70,15,'Record Not Found');
    Write('No matching record found.');

    repeat until Keypressed;
    Exit;
  end;

  ClearKeyboardBuffer;

  OpenWarningDialog(30,8,70,16,'Delete Record?');

  MenuArray[1]:='  Yes  ';
  MenuArray[2]:='  No   ';

  Status:=PopUpMenu(MenuArray,2);

  if Status>=2 then
    Exit;

  { Method 1) To delete record physically (and eternally) from database file }
  {
  if CustomerMasterFileRecordPtr=FileSize(CustomerMasterFile) then
  begin
    Seek(CustomerMasterFile,CustomerMasterFileRecordPtr-1);
    Truncate(CustomerMasterFile);
  end
  else
  begin
    Seek(CustomerMasterFile,FileSize(CustomerMasterFile)-1);
    Read(CustomerMasterFile,TemporaryCustomerMasterFileRecord);
    Seek(CustomerMasterFile,CustomerMasterFileRecordPtr-1);
    Write(CustomerMasterFile,TemporaryCustomerMasterFileRecord);
    Seek(CustomerMasterFile,FileSize(CustomerMasterFile)-1);
    Truncate(CustomerMasterFile);
  end;

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to delete record from file.');

    repeat until Keypressed;
    Exit;
  end;

  Dec(CustomerMasterFileRecordPtr);
  }

  { Method 2) To delete record logically (hidden record) }
  CustomerMasterFileRecord[CustomerMasterFileRecordPtr].AccountNo:=
  '~'+Copy(CustomerMasterFileRecord[CustomerMasterFileRecordPtr].AccountNo,2,5);

  Seek(CustomerMasterFile,CustomerMasterFileRecordPtr-1);
  Write(CustomerMasterFile,CustomerMasterFileRecord[CustomerMasterFileRecordPtr]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to delete record from file.');

    repeat until Keypressed;
    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('Record deleted.');

  repeat until Keypressed;
end;

procedure ViewCustomer;
var
  InputText:string;
  FindStatus:boolean;

begin
  OpenDialog(2,3,79,24,'Interrogate Customer Record');
  CursorOn;

  InputText:='';
  if not AcquireString(5,6,6,'Account Number:      ',InputText) then
    Exit;

  CursorOff;

  FindStatus:=False;

  for Counter:=1 to FileSize(CustomerMasterFile) do
  begin
    Seek(CustomerMasterFile,Counter-1);
    Read(CustomerMasterFile,CustomerMasterFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if CustomerMasterFileRecord[Counter].AccountNo=Copy(InputText,1,6) then
    begin
      FindStatus:=True;
      CustomerMasterFileRecordPtr:=Counter;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    OpenErrorDialog(10,10,70,15,'Record Not Found');
    Write('No matching record found.');

    repeat until Keypressed;
    Exit;
  end;

  Window(5,7,79,24);
  TextColor(DialogTextFrontColor);
  TextBackground(DialogTextBackColor);

  WriteLn('Name:                ',CustomerMasterFileRecord[CustomerMasterFileRecordPtr].Name);
  WriteLn('Address:             ',CustomerMasterFileRecord[CustomerMasterFileRecordPtr].Address);
  WriteLn('Phone Number:        ',CustomerMasterFileRecord[CustomerMasterFileRecordPtr].TelNo);
  WriteLn('Credit Limit:        ',CustomerMasterFileRecord[CustomerMasterFileRecordPtr].CreditLimit);
  WriteLn('Outstanding Balance: ',CustomerMasterFileRecord[CustomerMasterFileRecordPtr].OutstandingBalance:0:2);
  WriteLn('Last Payment:        ',ZeroPrecedence(CustomerMasterFileRecord[CustomerMasterFileRecordPtr].LastPayment.Day,2),
                                  '/',
                                  ZeroPrecedence(CustomerMasterFileRecord[CustomerMasterFileRecordPtr].LastPayment.Month,2),
                                  '/',
                                  ZeroPrecedence(CustomerMasterFileRecord[CustomerMasterFileRecordPtr].LastPayment.Year,4));

  repeat until Keypressed;
end;

procedure AddStock;
var
  InputText:string;

begin
  OpenDialog(2,3,79,24,'Add Stock Record');
  CursorOn;

  Inc(StockMasterFileRecordPtr);

  { Method 1) To generate Product-Code automatically }
  StockMasterFileRecord[StockMasterFileRecordPtr].ProductCode:=ZeroPrecedence(StockMasterFileRecordPtr,6);
  GotoXY(2,1);
  Write('Product Code:        ',StockMasterFileRecord[StockMasterFileRecordPtr].ProductCode);

  { Method 2) To manually enter the Product-Code }
  {
  InputText:='';
  if not AcquireString(5,6,6,'Product Code:        ',InputText) then
  begin
    Dec(StockMasterFileRecordPtr);
    Exit;
  end
  else
    StockMasterFileRecord[StockMasterFileRecordPtr].ProductCode:=Copy(InputText,1,6);
  }

  InputText:='';
  if not AcquireString(5,7,20,'Description:         ',InputText) then
  begin
    Dec(StockMasterFileRecordPtr);
    Exit;
  end
  else
    StockMasterFileRecord[StockMasterFileRecordPtr].Description:=Copy(InputText,1,20);

  if not AcquireWord(5,8,5,'Quantity:            ',StockMasterFileRecord[StockMasterFileRecordPtr].Quantity) then
  begin
    Dec(StockMasterFileRecordPtr);
    Exit;
  end;

  if not AcquireReal(5,9,5,'Cost Price:       RM ',StockMasterFileRecord[StockMasterFileRecordPtr].CostPrice) then
  begin
    Dec(StockMasterFileRecordPtr);
    Exit;
  end;

  CursorOff;

  Seek(StockMasterFile,StockMasterFileRecordPtr-1);
  Write(StockMasterFile,StockMasterFileRecord[StockMasterFileRecordPtr]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to save record to file.');

    repeat until Keypressed;

    Dec(StockMasterFileRecordPtr);

    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('New record saved.');

  repeat until Keypressed;
end;

procedure AmendStock;
var
  InputText:string;
  FindStatus:boolean;

begin
  OpenDialog(2,3,79,24,'Amend Stock Record');
  CursorOn;

  InputText:='';
  if not AcquireString(5,6,6,'Product Code:        ',InputText) then
    Exit;

  CursorOff;

  FindStatus:=False;

  for Counter:=1 to FileSize(StockMasterFile) do
  begin
    Seek(StockMasterFile,Counter-1);
    Read(StockMasterFile,StockMasterFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if StockMasterFileRecord[Counter].ProductCode=Copy(InputText,1,6) then
    begin
      FindStatus:=True;
      StockMasterFileRecordPtr:=Counter;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    OpenErrorDialog(10,10,70,15,'Record Not Found');
    Write('No matching record found.');

    repeat until Keypressed;
    Exit;
  end;

  CursorOn;

  InputText:=StockMasterFileRecord[StockMasterFileRecordPtr].Description;
  if not AcquireString(5,7,20,'Description:         ',InputText) then
  begin
    Dec(StockMasterFileRecordPtr);
    Exit;
  end
  else
    StockMasterFileRecord[StockMasterFileRecordPtr].Description:=Copy(InputText,1,20);

  if not AcquireWord(5,8,5,'Quantity:            ',StockMasterFileRecord[StockMasterFileRecordPtr].Quantity) then
  begin
    Dec(StockMasterFileRecordPtr);
    Exit;
  end;

  if not AcquireReal(5,9,5,'Cost Price:       RM ',StockMasterFileRecord[StockMasterFileRecordPtr].CostPrice) then
  begin
    Dec(StockMasterFileRecordPtr);
    Exit;
  end;

  CursorOff;

  Seek(StockMasterFile,StockMasterFileRecordPtr-1);
  Write(StockMasterFile,StockMasterFileRecord[StockMasterFileRecordPtr]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to save record to file.');

    repeat until Keypressed;
    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('Changes saved.');

  repeat until Keypressed;
end;

procedure DeleteStock;
var
  InputText:string;
  FindStatus:boolean;
  TemporaryStockMasterFileRecord:StockMasterFileRecordType;

begin
  OpenDialog(2,3,79,24,'Delete Stock Record');
  CursorOn;

  InputText:='';
  if not AcquireString(5,6,6,'Product Code:        ',InputText) then
    Exit;

  CursorOff;

  FindStatus:=False;

  for Counter:=1 to FileSize(StockMasterFile) do
  begin
    Seek(StockMasterFile,Counter-1);
    Read(StockMasterFile,StockMasterFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if StockMasterFileRecord[Counter].ProductCode=Copy(InputText,1,6) then
    begin
      FindStatus:=True;
      StockMasterFileRecordPtr:=Counter;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    OpenErrorDialog(10,10,70,15,'Record Not Found');
    Write('No matching record found.');

    repeat until Keypressed;
    Exit;
  end;

  ClearKeyboardBuffer;

  OpenWarningDialog(30,8,70,16,'Delete Record?');

  MenuArray[1]:='  Yes  ';
  MenuArray[2]:='  No   ';

  Status:=PopUpMenu(MenuArray,2);

  if Status>=2 then
    Exit;

  { Method 1) To delete record physically (and eternally) from database file }
  {
  if StockMasterFileRecordPtr=FileSize(StockMasterFile) then
  begin
    Seek(StockMasterFile,StockMasterFileRecordPtr-1);
    Truncate(StockMasterFile);
  end
  else
  begin
    Seek(StockMasterFile,FileSize(StockMasterFile)-1);
    Read(StockMasterFile,TemporaryStockMasterFileRecord);
    Seek(StockMasterFile,StockMasterFileRecordPtr-1);
    Write(StockMasterFile,TemporaryStockMasterFileRecord);
    Seek(StockMasterFile,FileSize(StockMasterFile)-1);
    Truncate(StockMasterFile);
  end;

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to delete record from file.');

    repeat until Keypressed;
    Exit;
  end;

  Dec(StockMasterFileRecordPtr);
  }

  { Method 2) To delete record logically (hidden record) }
  StockMasterFileRecord[StockMasterFileRecordPtr].ProductCode:=
  '~'+Copy(StockMasterFileRecord[StockMasterFileRecordPtr].ProductCode,2,5);

  Seek(StockMasterFile,StockMasterFileRecordPtr-1);
  Write(StockMasterFile,StockMasterFileRecord[StockMasterFileRecordPtr]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to delete record from file.');

    repeat until Keypressed;
    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('Record deleted.');

  repeat until Keypressed;
end;

procedure ViewStock;
var
  InputText:string;
  FindStatus:boolean;

begin
  OpenDialog(2,3,79,24,'Interrogate Stock Record');
  CursorOn;

  InputText:='';
  if not AcquireString(5,6,6,'Product Code:        ',InputText) then
    Exit;

  CursorOff;

  FindStatus:=False;

  for Counter:=1 to FileSize(StockMasterFile) do
  begin
    Seek(StockMasterFile,Counter-1);
    Read(StockMasterFile,StockMasterFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if StockMasterFileRecord[Counter].ProductCode=Copy(InputText,1,6) then
    begin
      FindStatus:=True;
      StockMasterFileRecordPtr:=Counter;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    OpenErrorDialog(10,10,70,15,'Record Not Found');
    Write('No matching record found.');

    repeat until Keypressed;
    Exit;
  end;

  Window(5,7,79,24);
  TextColor(DialogTextFrontColor);
  TextBackground(DialogTextBackColor);

  WriteLn('Description:         ',StockMasterFileRecord[StockMasterFileRecordPtr].Description);
  WriteLn('Quantity:            ',StockMasterFileRecord[StockMasterFileRecordPtr].Quantity);
  WriteLn('Cost Price:       RM ',StockMasterFileRecord[StockMasterFileRecordPtr].CostPrice:0:2);

  repeat until Keypressed;
end;

procedure AddInvoice;
label RedoCustomer, RedoStock;
var
  InputText:string;
  FindStatus:boolean;

begin
  OpenDialog(2,3,79,24,'Add Invoice Record');
  CursorOn;

  Inc(InvoiceFileRecordPtr);

  InvoiceFileRecord[InvoiceFileRecordPtr].InvoiceNo:=ZeroPrecedence(InvoiceFileRecordPtr,6);
  GotoXY(2,1);
  Write('Invoice Number:      ',InvoiceFileRecord[InvoiceFileRecordPtr].InvoiceNo);

RedoCustomer:
  ClearKeyboardBuffer;

  InputText:='';
  if not AcquireString(5,7,6,'Account Number:      ',InputText) then
  begin
    Dec(InvoiceFileRecordPtr);
    Exit;
  end
  else
    InvoiceFileRecord[InvoiceFileRecordPtr].CustomerAccountNo:=InputText;

  FindStatus:=False;

  for Counter:=1 to FileSize(CustomerMasterFile) do
  begin
    Seek(CustomerMasterFile,Counter-1);
    Read(CustomerMasterFile,CustomerMasterFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if CustomerMasterFileRecord[Counter].AccountNo=InvoiceFileRecord[InvoiceFileRecordPtr].CustomerAccountNo then
    begin
      FindStatus:=True;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    CursorOff;
    SaveScreen(2);

    OpenErrorDialog(10,10,70,15,'Invalid Input');
    Write('The specified account number is unavailable in database.');

    repeat until Keypressed;

    RestoreScreen(2);
    CursorOn;

    goto RedoCustomer;
  end;

RedoStock:
  ClearKeyboardBuffer;

  InputText:='';
  if not AcquireString(5,8,6,'Stock Number:        ',InputText) then
  begin
    Dec(InvoiceFileRecordPtr);
    Exit;
  end
  else
    InvoiceFileRecord[InvoiceFileRecordPtr].StockNo:=InputText;

  FindStatus:=False;

  for Counter:=1 to FileSize(StockMasterFile) do
  begin
    Seek(StockMasterFile,Counter-1);
    Read(StockMasterFile,StockMasterFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if StockMasterFileRecord[Counter].ProductCode=InvoiceFileRecord[InvoiceFileRecordPtr].StockNo then
    begin
      FindStatus:=True;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    CursorOff;
    SaveScreen(2);

    OpenErrorDialog(10,10,70,15,'Invalid Input');
    Write('The specified stock number is unavailable in database.');

    repeat until Keypressed;

    RestoreScreen(2);
    CursorOn;

    goto RedoStock;
  end;

  if not AcquireWord(5,9,5,'Quantity:            ',InvoiceFileRecord[InvoiceFileRecordPtr].Quantity) then
  begin
    Dec(InvoiceFileRecordPtr);
    Exit;
  end;

  { Method 1) Manually enter the cost of the stock product }
  {
  if not AcquireReal(5,10,5,'Cost:             RM ',InvoiceFileRecord[InvoiceFileRecordPtr].Cost) then
  begin
    Dec(InvoiceFileRecordPtr);
    Exit;
  end;
  }

  InvoiceFileRecord[InvoiceFileRecordPtr].Cost:=StockMasterFileRecord[Counter].CostPrice;

  InvoiceFileRecord[InvoiceFileRecordPtr].TotalCost:=
  InvoiceFileRecord[InvoiceFileRecordPtr].Cost*InvoiceFileRecord[InvoiceFileRecordPtr].Quantity;

  Window(5,7,79,24);
  TextColor(DialogTextFrontColor);
  TextBackground(DialogTextBackColor);

  GotoXY(1,4);
  WriteLn('Cost:             RM ',InvoiceFileRecord[InvoiceFileRecordPtr].Cost:0:2);
  GotoXY(1,5);
  WriteLn('Total Cost:       RM ',InvoiceFileRecord[InvoiceFileRecordPtr].TotalCost:0:2);

  InvoiceFileRecord[InvoiceFileRecordPtr].DateSend.Day:=Day;
  InvoiceFileRecord[InvoiceFileRecordPtr].DateSend.Month:=Month;
  InvoiceFileRecord[InvoiceFileRecordPtr].DateSend.Year:=Year;

  CursorOff;

  Seek(InvoiceFile,InvoiceFileRecordPtr-1);
  Write(InvoiceFile,InvoiceFileRecord[InvoiceFileRecordPtr]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to save record to file.');

    repeat until Keypressed;

    Dec(InvoiceFileRecordPtr);

    Exit;
  end;

  OpenDialog(10,15,70,20,'');
  Write('New record saved.');

  repeat until Keypressed;
end;

procedure AmendInvoice;
label RedoCustomer,RedoStock;
var
  InputText:string;
  FindStatus:boolean;

begin
  OpenDialog(2,3,79,24,'Amend Invoice Record');
  CursorOn;

  InputText:='';
  if not AcquireString(5,6,6,'Invoice Number:      ',InputText) then
    Exit;

  CursorOff;

  FindStatus:=False;

  for Counter:=1 to FileSize(InvoiceFile) do
  begin
    Seek(InvoiceFile,Counter-1);
    Read(InvoiceFile,InvoiceFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if InvoiceFileRecord[Counter].InvoiceNo=Copy(InputText,1,6) then
    begin
      FindStatus:=True;
      InvoiceFileRecordPtr:=Counter;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    OpenErrorDialog(10,10,70,15,'Record Not Found');
    Write('No matching record found.');

    repeat until Keypressed;
    Exit;
  end;

  CursorOn;

RedoCustomer:
  ClearKeyboardBuffer;

  InputText:=InvoiceFileRecord[InvoiceFileRecordPtr].CustomerAccountNo;
  if not AcquireString(5,7,6,'Account Number:      ',InputText) then
  begin
    Dec(InvoiceFileRecordPtr);
    Exit;
  end
  else
    InvoiceFileRecord[InvoiceFileRecordPtr].CustomerAccountNo:=InputText;

  FindStatus:=False;

  for Counter:=1 to FileSize(CustomerMasterFile) do
  begin
    Seek(CustomerMasterFile,Counter-1);
    Read(CustomerMasterFile,CustomerMasterFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if CustomerMasterFileRecord[Counter].AccountNo=InvoiceFileRecord[InvoiceFileRecordPtr].CustomerAccountNo then
    begin
      FindStatus:=True;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    CursorOff;
    SaveScreen(2);

    OpenErrorDialog(10,10,70,15,'Invalid Input');
    Write('The specified account number is unavailable in database.');

    repeat until Keypressed;

    RestoreScreen(2);
    CursorOn;

    goto RedoCustomer;
  end;

RedoStock:
  ClearKeyboardBuffer;

  InputText:=InvoiceFileRecord[InvoiceFileRecordPtr].StockNo;
  if not AcquireString(5,8,6,'Stock Number:        ',InputText) then
  begin
    Dec(InvoiceFileRecordPtr);
    Exit;
  end
  else
    InvoiceFileRecord[InvoiceFileRecordPtr].StockNo:=InputText;

  FindStatus:=False;

  for Counter:=1 to FileSize(StockMasterFile) do
  begin
    Seek(StockMasterFile,Counter-1);
    Read(StockMasterFile,StockMasterFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if StockMasterFileRecord[Counter].ProductCode=InvoiceFileRecord[InvoiceFileRecordPtr].StockNo then
    begin
      FindStatus:=True;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    CursorOff;
    SaveScreen(2);

    OpenErrorDialog(10,10,70,15,'Invalid Input');
    Write('The specified stock number is unavailable in database.');

    repeat until Keypressed;

    RestoreScreen(2);
    CursorOn;

    goto RedoStock;
  end;

  if not AcquireWord(5,9,5,'Quantity:            ',InvoiceFileRecord[InvoiceFileRecordPtr].Quantity) then
  begin
    Dec(InvoiceFileRecordPtr);
    Exit;
  end;

  { Method 1) Manually enter the cost of the stock product }
  {
  if not AcquireReal(5,10,5,'Cost:             RM ',InvoiceFileRecord[InvoiceFileRecordPtr].Cost) then
  begin
    Dec(InvoiceFileRecordPtr);
    Exit;
  end;
  }

  InvoiceFileRecord[InvoiceFileRecordPtr].Cost:=StockMasterFileRecord[Counter].CostPrice;

  InvoiceFileRecord[InvoiceFileRecordPtr].TotalCost:=
  InvoiceFileRecord[InvoiceFileRecordPtr].Cost*InvoiceFileRecord[InvoiceFileRecordPtr].Quantity;

  Window(5,7,79,24);
  TextColor(DialogTextFrontColor);
  TextBackground(DialogTextBackColor);

  GotoXY(1,4);
  WriteLn('Cost:             RM ',InvoiceFileRecord[InvoiceFileRecordPtr].Cost:0:2);
  GotoXY(1,5);
  WriteLn('Total Cost:       RM ',InvoiceFileRecord[InvoiceFileRecordPtr].TotalCost:0:2);

  InvoiceFileRecord[InvoiceFileRecordPtr].DateSend.Day:=Day;
  InvoiceFileRecord[InvoiceFileRecordPtr].DateSend.Month:=Month;
  InvoiceFileRecord[InvoiceFileRecordPtr].DateSend.Year:=Year;

  CursorOff;

  Seek(InvoiceFile,InvoiceFileRecordPtr-1);
  Write(InvoiceFile,InvoiceFileRecord[InvoiceFileRecordPtr]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to save record to file.');

    repeat until Keypressed;
    Exit;
  end;

  OpenDialog(10,15,70,20,'');
  Write('Changes saved.');

  repeat until Keypressed;
end;

procedure DeleteInvoice;
var
  InputText:string;
  FindStatus:boolean;
  TemporaryInvoiceFileRecord:InvoiceFileRecordType;

begin
  OpenDialog(2,3,79,24,'Delete Invoice Record');
  CursorOn;

  InputText:='';
  if not AcquireString(5,6,6,'Invoice Number:      ',InputText) then
    Exit;

  CursorOff;

  FindStatus:=False;

  for Counter:=1 to FileSize(InvoiceFile) do
  begin
    Seek(InvoiceFile,Counter-1);
    Read(InvoiceFile,InvoiceFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if InvoiceFileRecord[Counter].InvoiceNo=Copy(InputText,1,6) then
    begin
      FindStatus:=True;
      InvoiceFileRecordPtr:=Counter;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    OpenErrorDialog(10,10,70,15,'Record Not Found');
    Write('No matching record found.');

    repeat until Keypressed;
    Exit;
  end;

  ClearKeyboardBuffer;

  OpenWarningDialog(30,8,70,16,'Delete Record?');

  MenuArray[1]:='  Yes  ';
  MenuArray[2]:='  No   ';

  Status:=PopUpMenu(MenuArray,2);

  if Status>=2 then
    Exit;

  { Method 1) To delete record physically (and eternally) from database file }
  {
  if InvoiceFileRecordPtr=FileSize(InvoiceFile) then
  begin
    Seek(InvoiceFile,InvoiceFileRecordPtr-1);
    Truncate(InvoiceFile);
  end
  else
  begin
    Seek(InvoiceFile,FileSize(InvoiceFile)-1);
    Read(InvoiceFile,TemporaryInvoiceFileRecord);
    Seek(InvoiceFile,InvoiceFileRecordPtr-1);
    Write(InvoiceFile,TemporaryInvoiceFileRecord);
    Seek(InvoiceFile,FileSize(InvoiceFile)-1);
    Truncate(InvoiceFile);
  end;

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to delete record from file.');

    repeat until Keypressed;
    Exit;
  end;

  Dec(InvoiceFileRecordPtr);
  }

  { Method 2) To delete record logically (hidden record) }
  InvoiceFileRecord[InvoiceFileRecordPtr].InvoiceNo:=
  '~'+Copy(InvoiceFileRecord[InvoiceFileRecordPtr].InvoiceNo,2,5);

  Seek(InvoiceFile,InvoiceFileRecordPtr-1);
  Write(InvoiceFile,InvoiceFileRecord[InvoiceFileRecordPtr]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to delete record from file.');

    repeat until Keypressed;
    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('Record deleted.');

  repeat until Keypressed;
end;

procedure ViewInvoice;
var
  InputText:string;
  FindStatus:boolean;

begin
  OpenDialog(2,3,79,24,'Interrogate Invoice Record');
  CursorOn;

  InputText:='';
  if not AcquireString(5,6,6,'Invoice Number:      ',InputText) then
    Exit;

  CursorOff;

  FindStatus:=False;

  for Counter:=1 to FileSize(InvoiceFile) do
  begin
    Seek(InvoiceFile,Counter-1);
    Read(InvoiceFile,InvoiceFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if InvoiceFileRecord[Counter].InvoiceNo=Copy(InputText,1,6) then
    begin
      FindStatus:=True;
      InvoiceFileRecordPtr:=Counter;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    OpenErrorDialog(10,10,70,15,'Record Not Found');
    Write('No matching record found.');

    repeat until Keypressed;
    Exit;
  end;

  Window(5,7,79,24);
  TextColor(DialogTextFrontColor);
  TextBackground(DialogTextBackColor);

  WriteLn('Account Number:      ',InvoiceFileRecord[InvoiceFileRecordPtr].CustomerAccountNo);
  WriteLn('Stock Number:        ',InvoiceFileRecord[InvoiceFileRecordPtr].StockNo);
  WriteLn('Quantity:            ',InvoiceFileRecord[InvoiceFileRecordPtr].Quantity);
  WriteLn('Cost:             RM ',InvoiceFileRecord[InvoiceFileRecordPtr].Cost:0:2);
  WriteLn('Total Cost:       RM ',InvoiceFileRecord[InvoiceFileRecordPtr].TotalCost:0:2);
  WriteLn('Date Send:           ',ZeroPrecedence(InvoiceFileRecord[InvoiceFileRecordPtr].DateSend.Day,2),'/',
                                  ZeroPrecedence(InvoiceFileRecord[InvoiceFileRecordPtr].DateSend.Month,2),'/',
                                  ZeroPrecedence(InvoiceFileRecord[InvoiceFileRecordPtr].DateSend.Year,4));
  WriteLn('Date Paid:           ',ZeroPrecedence(InvoiceFileRecord[InvoiceFileRecordPtr].DatePaid.Day,2),'/',
                                  ZeroPrecedence(InvoiceFileRecord[InvoiceFileRecordPtr].DatePaid.Month,2),'/',
                                  ZeroPrecedence(InvoiceFileRecord[InvoiceFileRecordPtr].DatePaid.Year,4));

  repeat until Keypressed;
end;

procedure AddOrder;
label RedoStock;
var
  InputText:string;
  FindStatus:boolean;

begin
  OpenDialog(2,3,79,24,'Add Order Record');
  CursorOn;

  Inc(OrderFileRecordPtr);

  OrderFileRecord[OrderFileRecordPtr].OrderNo:=ZeroPrecedence(OrderFileRecordPtr,6);
  GotoXY(2,1);
  Write('Order Number:        ',OrderFileRecord[OrderFileRecordPtr].OrderNo);

  if not AcquireWord(5,7,5,'Quantity:            ',OrderFileRecord[OrderFileRecordPtr].Quantity) then
  begin
    Dec(OrderFileRecordPtr);
    Exit;
  end;

RedoStock:
  ClearKeyboardBuffer;

  InputText:='';
  if not AcquireString(5,8,6,'Stock Number:        ',InputText) then
  begin
    Dec(OrderFileRecordPtr);
    Exit;
  end
  else
    OrderFileRecord[OrderFileRecordPtr].StockNo:=InputText;

  FindStatus:=False;

  for Counter:=1 to FileSize(StockMasterFile) do
  begin
    Seek(StockMasterFile,Counter-1);
    Read(StockMasterFile,StockMasterFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if StockMasterFileRecord[Counter].ProductCode=OrderFileRecord[OrderFileRecordPtr].StockNo then
    begin
      FindStatus:=True;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    CursorOff;
    SaveScreen(2);

    OpenErrorDialog(10,10,70,15,'Invalid Input');
    Write('The specified stock number is unavailable in database.');

    repeat until Keypressed;

    RestoreScreen(2);
    CursorOn;

    goto RedoStock;
  end;

  OrderFileRecord[OrderFileRecordPtr].DateOrder.Day:=Day;
  OrderFileRecord[OrderFileRecordPtr].DateOrder.Month:=Month;
  OrderFileRecord[OrderFileRecordPtr].DateOrder.Year:=Year;

  CursorOff;

  Seek(OrderFile,OrderFileRecordPtr-1);
  Write(OrderFile,OrderFileRecord[OrderFileRecordPtr]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to save record to file.');

    repeat until Keypressed;

    Dec(OrderFileRecordPtr);

    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('New record saved.');

  repeat until Keypressed;
end;

procedure AmendOrder;
label
  RedoStock;
var
  InputText:string;
  FindStatus:boolean;

begin
  OpenDialog(2,3,79,24,'Amend Order Record');
  CursorOn;

  InputText:='';
  if not AcquireString(5,6,6,'Account Number:      ',InputText) then
    Exit;

  CursorOff;

  FindStatus:=False;

  for Counter:=1 to FileSize(OrderFile) do
  begin
    Seek(OrderFile,Counter-1);
    Read(OrderFile,OrderFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if OrderFileRecord[Counter].OrderNo=Copy(InputText,1,6) then
    begin
      FindStatus:=True;
      OrderFileRecordPtr:=Counter;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    OpenErrorDialog(10,10,70,15,'Record Not Found');
    Write('No matching record found.');

    repeat until Keypressed;
    Exit;
  end;

  CursorOn;

  if not AcquireWord(5,7,5,'Quantity:            ',OrderFileRecord[OrderFileRecordPtr].Quantity) then
  begin
    Dec(OrderFileRecordPtr);
    Exit;
  end;

RedoStock:
  ClearKeyboardBuffer;

  InputText:=OrderFileRecord[OrderFileRecordPtr].StockNo;
  if not AcquireString(5,8,6,'Stock Number:        ',InputText) then
  begin
    Dec(OrderFileRecordPtr);
    Exit;
  end
  else
    OrderFileRecord[OrderFileRecordPtr].StockNo:=InputText;

  FindStatus:=False;

  for Counter:=1 to FileSize(StockMasterFile) do
  begin
    Seek(StockMasterFile,Counter-1);
    Read(StockMasterFile,StockMasterFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if StockMasterFileRecord[Counter].ProductCode=OrderFileRecord[OrderFileRecordPtr].StockNo then
    begin
      FindStatus:=True;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    CursorOff;
    SaveScreen(2);

    OpenErrorDialog(10,10,70,15,'Invalid Input');
    Write('The specified stock number is unavailable in database.');

    repeat until Keypressed;

    RestoreScreen(2);
    CursorOn;

    goto RedoStock;
  end;

  OrderFileRecord[OrderFileRecordPtr].DateOrder.Day:=Day;
  OrderFileRecord[OrderFileRecordPtr].DateOrder.Month:=Month;
  OrderFileRecord[OrderFileRecordPtr].DateOrder.Year:=Year;

  CursorOff;

  Seek(OrderFile,OrderFileRecordPtr-1);
  Write(OrderFile,OrderFileRecord[OrderFileRecordPtr]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to save record to file.');

    repeat until Keypressed;
    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('Changes saved.');

  repeat until Keypressed;
end;

procedure DeleteOrder;
var
  InputText:string;
  FindStatus:boolean;
  TemporaryOrderFileRecord:OrderFileRecordType;

begin
  OpenDialog(2,3,79,24,'Delete Order Record');
  CursorOn;

  InputText:='';
  if not AcquireString(5,6,6,'Account Number:      ',InputText) then
    Exit;

  CursorOff;

  FindStatus:=False;

  for Counter:=1 to FileSize(OrderFile) do
  begin
    Seek(OrderFile,Counter-1);
    Read(OrderFile,OrderFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if OrderFileRecord[Counter].OrderNo=Copy(InputText,1,6) then
    begin
      FindStatus:=True;
      OrderFileRecordPtr:=Counter;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    OpenErrorDialog(10,10,70,15,'Record Not Found');
    Write('No matching record found.');

    repeat until Keypressed;
    Exit;
  end;

  ClearKeyboardBuffer;

  OpenWarningDialog(30,8,70,16,'Delete Record?');

  MenuArray[1]:='  Yes  ';
  MenuArray[2]:='  No   ';

  Status:=PopUpMenu(MenuArray,2);

  if Status>=2 then
    Exit;

  { Method 1) To delete record physically (and eternally) from database file }
  {
  if OrderFileRecordPtr=FileSize(OrderFile) then
  begin
    Seek(OrderFile,OrderFileRecordPtr-1);
    Truncate(OrderFile);
  end
  else
  begin
    Seek(OrderFile,FileSize(OrderFile)-1);
    Read(OrderFile,TemporaryOrderFileRecord);
    Seek(OrderFile,OrderFileRecordPtr-1);
    Write(OrderFile,TemporaryOrderFileRecord);
    Seek(OrderFile,FileSize(OrderFile)-1);
    Truncate(OrderFile);
  end;

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to delete record from file.');

    repeat until Keypressed;
    Exit;
  end;

  Dec(OrderFileRecordPtr);
  }

  { Method 2) To delete record logically (hidden record) }
  OrderFileRecord[OrderFileRecordPtr].OrderNo:=
  '~'+Copy(OrderFileRecord[OrderFileRecordPtr].OrderNo,2,5);

  Seek(OrderFile,OrderFileRecordPtr-1);
  Write(OrderFile,OrderFileRecord[OrderFileRecordPtr]);

  if IOResult<>0 then
  begin
    OpenErrorDialog(10,10,70,15,'Disk Operation Error');
    Write('Program was unable to delete record from file.');

    repeat until Keypressed;
    Exit;
  end;

  OpenDialog(10,10,70,15,'');
  Write('Record deleted.');

  repeat until Keypressed;
end;

procedure ViewOrder;
var
  InputText:string;
  FindStatus:boolean;

begin
  OpenDialog(2,3,79,24,'Interrogate Order Record');
  CursorOn;

  InputText:='';
  if not AcquireString(5,6,6,'Account Number:      ',InputText) then
    Exit;

  CursorOff;

  FindStatus:=False;

  for Counter:=1 to FileSize(OrderFile) do
  begin
    Seek(OrderFile,Counter-1);
    Read(OrderFile,OrderFileRecord[Counter]);

    if IOResult<>0 then
    begin
      OpenErrorDialog(10,10,70,15,'Disk Operation Error');
      Write('Program was unable to access record on file.');

      repeat until Keypressed;
      Exit;
    end;

    if OrderFileRecord[Counter].OrderNo=Copy(InputText,1,6) then
    begin
      FindStatus:=True;
      OrderFileRecordPtr:=Counter;

      Break;
    end;
  end;

  if not FindStatus then
  begin
    OpenErrorDialog(10,10,70,15,'Record Not Found');
    Write('No matching record found.');

    repeat until Keypressed;
    Exit;
  end;

  Window(5,7,79,24);
  TextColor(DialogTextFrontColor);
  TextBackground(DialogTextBackColor);

  WriteLn('Quantity:            ',OrderFileRecord[OrderFileRecordPtr].Quantity);
  WriteLn('Stock Number:        ',OrderFileRecord[OrderFileRecordPtr].StockNo);
  WriteLn('Date Order:          ',ZeroPrecedence(OrderFileRecord[OrderFileRecordPtr].DateOrder.Day,2),'/',
                                  ZeroPrecedence(OrderFileRecord[OrderFileRecordPtr].DateOrder.Month,2),'/',
                                  ZeroPrecedence(OrderFileRecord[OrderFileRecordPtr].DateOrder.Year,4));
  WriteLn('Date Paid:           ',ZeroPrecedence(OrderFileRecord[OrderFileRecordPtr].DatePaid.Day,2),'/',
                                  ZeroPrecedence(OrderFileRecord[OrderFileRecordPtr].DatePaid.Month,2),'/',
                                  ZeroPrecedence(OrderFileRecord[OrderFileRecordPtr].DatePaid.Year,4));

  repeat until Keypressed;
end;

begin
(* SETUP *)
  PrepareTextScreen;

  CustomerMasterFileRecordPtr:=0;
  StockMasterFileRecordPtr:=0;
  InvoiceFileRecordPtr:=0;
  OrderFileRecordPtr:=0;

  OpenDatabase;

  GetDate(Year,Month,Day,WeekDay);

  OpenScreen(ProgramTitle+'           Date: '+ZeroPrecedence(Day,2)+'/'+ZeroPrecedence(Month,2)+'/'+ZeroPrecedence(Year,4));
  SaveScreen(1);

  repeat

Redo:
    ClearKeyboardBuffer;
    CursorOff;

    RestoreScreen(1);

(* MAIN MENU *)
    OpenDialog(20,7,60,18,'Main Menu');

    MenuArray[1]:='  Customer Menu...               ';
    MenuArray[2]:='  Stock Menu...                  ';
    MenuArray[3]:='  Invoice Menu...                ';
    MenuArray[4]:='  Re-ordering Menu...            ';
    MenuArray[5]:='';
    MenuArray[6]:='~  Help                           ';
    MenuArray[7]:='  Exit                           ';
    {
      Notes:
      (1) Empty line used as menu separator
      (2) Menu item string that preceded with symbol (~) will be disabled
    }

    Status:=PopUpMenu(MenuArray,7);

    if Status>=7 then
      Break;

    RestoreScreen(1);

(* SUB MENU *)
    case Status of
      1,2,3,4:
      begin
        SelectedMenu:=Status;
        case SelectedMenu of
          1:OpenDialog(28,7,53,17,'Customer Menu');
          2:OpenDialog(28,7,53,17,'Stock Menu');
          3:OpenDialog(28,7,53,17,'Invoice Menu');
          4:OpenDialog(28,7,53,17,'Re-ordering Menu');
        end;

        MenuArray[1]:='  Add...             ';
        MenuArray[2]:='  Amend...           ';
        MenuArray[3]:='  Delete...          ';
        MenuArray[4]:='  Interrogate...     ';
        MenuArray[5]:='';
        MenuArray[6]:='  Back to Main Menu  ';

        Status:=PopUpMenu(MenuArray,6);

        if Status>4 then
          goto Redo;

        ClearKeyboardBuffer;

        case SelectedMenu of
          1:
          begin
            case Status of
              1:AddCustomer;
              2:AmendCustomer;
              3:DeleteCustomer;
              4:ViewCustomer;
            end;
          end;
          2:
          begin
            case Status of
              1:AddStock;
              2:AmendStock;
              3:DeleteStock;
              4:ViewStock;
            end;
          end;
          3:
          begin
            case Status of
              1:AddInvoice;
              2:AmendInvoice;
              3:DeleteInvoice;
              4:ViewInvoice;
            end;
          end;
          4:
          begin
            case Status of
              1:AddOrder;
              2:AmendOrder;
              3:DeleteOrder;
              4:ViewOrder;
            end;
          end;
        end;
      end;

    end;


  until Status=0;

(* SHUT DOWN *)
  CloseDatabase;

  ShutTextScreen;
end.