unit Picture;
{
  PICTURE.TPU (with open source)
  Programmed by Boo Khan Ming

  Internal Revision 2.0

  Provide necessary code to display picture on 320x200 graphics screen
  Simple picture format established without any header signature:

         0-767          Palette Data (768)
         768-64768      Picture Data (64000)

  Need a converter to convert picture from other format for use with this
  unit (sample utility enclosed: PCX2IMG)
}

interface

function LoadPicture(Filename:string):boolean;
procedure ClosePicture;

implementation

uses Crt;

type
  PicType=array [1..64000] of byte;

var
  f:file;
  Pal:array [1..256*3] of byte;

function LoadPicture(Filename:string):boolean;
var
  Pic:^PicType;

begin
  LoadPicture:=False;

  { Determine available memory }
  if MaxAvail<SizeOf(Pic^) then
    Exit;

  { Create new dynamic variable }
  New(Pic);

  {$I-}
  Assign(f,Filename);
  Reset(f,1);

  BlockRead(f,Pal,768);
  BlockRead(f,Pic^,SizeOf(Pic^));

  Close(f);
  {$I+}
  if IOResult<>0 then
    Exit;

  { Setup graphics video mode and palette }
  asm
    mov ax,13h
    int 10h
    mov ax,1012h
    xor bx,bx
    mov cx,256
    mov dx,Offset Pal
    int 10h
  end;

  { Flip from memory to video memory }
  Move(Pic^,Ptr($a000,$0000)^,SizeOf(Pic^));

  { Dispose dynamic variable }
  Dispose(Pic);

  LoadPicture:=True;
end;

procedure ClosePicture;
begin
  TextMode(co80);
end;

end.
