unit screen;

interface
       Procedure Fadeup(time:integer);
       Procedure FadeDown(time:integer);
       Procedure HideCursor;
       Procedure ShowCursor;
       procedure InitSVGA;
       procedure lin(x,y,x1,y1,c,n:integer);
       procedure num(x,y,c2,nu,c:integer;s:real);
       Procedure SetRGB(Num,Red,Green,Blue:Word);
       Procedure GetPal(ColorNo : Byte; Var R,G,B : Byte);
       Procedure Pal(ColorNo : Byte; R,G,B : Byte);

implementation
 uses graph,crt,dos;

 {$F+}
function TestDetect: Integer;
begin
  TestDetect := Detect;   { Default mode = 1 }
end;

procedure InitSVGA;
var
  Driver, Mode,
  TestDriver,
  ErrCode,i: Integer;
  w :string[6];
 {$F-}
begin
  { Install the driver }
  TestDriver := InstallUserDriver('svga256', @TestDetect);
  if GraphResult <> grOk then
  begin
    Writeln('Error installing TestDriver');
    Halt(1);
  end;
  Driver := 16;   { Put in graphics mode }
  InitGraph(Driver, Mode,'svga256');
  ErrCode := GraphResult;
  if ErrCode <> grOk then
  begin
    Writeln('Error during Init: ', GraphErrorMsg(ErrCode));
    Halt(1);
  end;
end;
Procedure Pal(ColorNo : Byte; R,G,B : Byte);
  { This sets the Red, Green and Blue values of a certain color }
Begin
   Port[$3c8] := ColorNo;
   Port[$3c9] := R;
   Port[$3c9] := G;
   Port[$3c9] := B;
End;

Procedure GetPal(ColorNo : Byte; Var R,G,B : Byte);
  { This reads the values of the Red, Green and Blue values of a certain
    color and returns them to you. }
Begin
   Port[$3c7] := ColorNo;
   R := Port[$3c9];
   G := Port[$3c9];
   B := Port[$3c9];
End;


Procedure FadeDown(time:integer);
  { This procedure fades the screen out to black. }
VAR loop1,loop2:integer;
    Tmp : Array [1..3] of byte;
    col,a,b,c:byte;
      { This is temporary storage for the values of a color }
BEGIN
  port[$3c7]:=col;
  a:=port[$3c9];
  b:=port[$3c9];
  c:=port[$3c9];
  For loop1:=1 to 64 do BEGIN
   { WaitRetrace;}delay(time);
    For loop2:=1 to 255 do BEGIN
      Getpal (loop2,Tmp[1],Tmp[2],Tmp[3]);
      If Tmp[1]>0 then dec (Tmp[1]);
      If Tmp[2]>0 then dec (Tmp[2]);
      If Tmp[3]>0 then dec (Tmp[3]);
	{ If the Red, Green or Blue values of color loop2 are not yet zero,
	  then, decrease them by one. }
         Pal (loop2,Tmp[1],Tmp[2],Tmp[3]);
	{ Set the new, altered pallette color. }
    END;
  END;
pal(col,a,b,c);
END;

Procedure Fadeup(time:integer);
VAR loop1,loop2:integer;
    Tmp : Array [1..3] of byte;
    col,a,b,c:byte;

BEGIN
  port[$3c7]:=col;
  a:=port[$3c9];
  b:=port[$3c9];
  c:=port[$3c9];
  For loop1:=1 to 64 do BEGIN
   { WaitRetrace;}delay(time);
    For loop2:=1 to 255 do BEGIN
      Getpal(loop2,Tmp[1],Tmp[2],Tmp[3]);
      If Tmp[1]<A then inc (Tmp[1]);
      If Tmp[2]<B then inc (Tmp[2]);
      If Tmp[3]<C then inc (Tmp[3]);

         Pal (loop2,Tmp[1],Tmp[2],Tmp[3]);

    END;
  END;
pal(col,a,b,c);
END;

  Procedure SetRGB(Num,Red,Green,Blue:Word);
    var
    Reg              : Registers;
     begin
        Reg.Ax:=$1010;
        Reg.Bl:=Num;
        Reg.Dh:=Red;
        Reg.Ch:=Green;
        Reg.Cl:=Blue;
        Intr($10,Reg);
     end;

(* proceduures that not sirees*)
procedure lin(x,y,x1,y1,c,n:integer);
begin
setcolor(c);
SetLineStyle(0, 0, n);
line(x,y,x1,y1);
end;

procedure num(x,y,c2,nu,c:integer;s:real);
var
box :array[1..7]of boolean;
i,n :integer;
begin
if s=0 then n:=1;
for i:=1 to 7 do box[i]:=false;
if (nu mod 2 =0)or(nu=5)or(nu=9)or(nu=3)or(nu=0) then for i:=1 to 7 do box[i]:=true;
case nu of
0:box[3]:=false;
1:begin box[4]:=true;box[7]:=true;end;
6:box[4]:=false;
5:begin box[4]:=false;box[5]:=false;end;
3:begin box[2]:=false;box[5]:=false;end;
4:begin box[1]:=false;box[6]:=false;box[5]:=false;end;
7:begin box[1]:=true;box[4]:=true;box[7]:=true;end;
2:begin box[2]:=false;box[7]:=false;end;
9:box[5]:=false;
end;
if s<0.9 then n:=1 else n:=3;
if box[1] then lin(x+round(2*s),y,x+round(14*s),y,c2,n) else lin(x+round(2*s),y,x+round(14*s),y,c,n);
if box[2] then lin(x,y+round(2*s),x,y+round(20*s),c2,n) else lin(x,y+round(2*s),x,y+round(20*s),c,n);
if box[3] then lin(x+round(2*s),y+round(22*s),x+round(14*s),y+round(22*s),c2,n) else
lin(x+round(2*s),y+round(22*s),x+round(14*s),y+round(22*s),c,n);
if box[4] then lin(x+round(16*s),y+round(2*s),x+round(16*s),y+round(20*s),c2,n) else
lin(x+round(16*s),y+round(2*s),x+round(16*s),y+round(20*s),c,n);
if box[5] then lin(x,y+round(24*s),x,y+round(41*s),c2,n) else lin(x,y+round(24*s),x,y+round(41*s),c,n);
if box[6] then lin(x+round(2*s),y+round(43*s),x+round(14*s),y+round(43*s),c2,n) else
lin(x+round(2*s),y+round(43*s),x+round(14*s),y+round(43*s),c,n);
if box[7] then lin(x+round(16*s),y+round(24*s),x+round(16*s),y+round(41*s),c2,n) else
lin(x+round(16*s),y+round(24*s),x+round(16*s),y+round(41*s),c,n);
end;
  Procedure HideCursor;
  begin
  {$M $4000,0,0 }   { 16K stack, no heap }
  SwapVectors;
  Exec('cursor_h.com','  ');
  SwapVectors;
  end;

  Procedure ShowCursor;
  begin
  {$M $4000,0,0 }   { 16K stack, no heap }
  SwapVectors;
  Exec('cursor_c.com','  ');
  SwapVectors;
  end;


end.