{$G+}
unit screen;

interface
     (* Graphics Procedures *)

       Procedure Fadeup(time:integer);
       Procedure FadeDown(time:integer);
       procedure F_putpixel(x,y : word; col : byte);
       function  F_getpixel(x,y : word) : byte;
       procedure lin(x,y,x1,y1,c,n:integer);
       procedure num(x,y,c2,nu,c:integer;s:real);
       Procedure SetRGB(Num,Red,Green,Blue:Word);
       Procedure GetPal(ColorNo : Byte; Var R,G,B : Byte);
       Procedure Pal(ColorNo : Byte; R,G,B : Byte);

     (* Text Procedures *)

       Procedure HideCursor;
       Procedure ShowCursor;
       Procedure F_Write(S: String; co, ro, at: word);


implementation
 uses graph,crt,dos;

Type
  WordArray = Array[0..65520 DIV 2] of word;
VAR
  Display :^WordArray;
  Crt_Cols: Word ABSOLUTE $40:$4A;
  Crt_Rows: Word ABSOLUTE $40:$84;
  ScreenWidth,
  ScreenHeight : Byte;

procedure checkwidthheight;
begin
  ScreenWidth:=Crt_Cols;
  ScreenHeight:=Succ(Crt_Rows);
end;

Procedure F_Write(S: String; co, ro, at: word); assembler;
asm
  mov ax, ro;
  dec al;
  shl al,1;
  mul screenwidth;
  add ax,co;
  dec ax;
  mov di,word(display);
  add di, ax;
  mov ax,word(Display+2);
  mov es, ax;
  push ds;
  lds si,s;
  xor cx,cx;
  mov cl, [si];
  inc si;
  mov bh, Byte(At)
  @Loop:
    movsb;
    mov es:[di], bh;
    inc di;
  loop @loop;
  pop ds
end;

procedure F_putpixel;assembler;
asm
  mov es,sega000
  mov bx,x
  mov ax,y
  shl ax,6
  add bx,ax
  shl ax,2
  add bx,ax
  mov al,col
  mov es:[bx],al
end;

function F_getpixel;assembler;
asm
  mov es,sega000
  mov bx,x
  mov ax,y
  shl ax,6
  add bx,ax
  shl ax,2
  add bx,ax
  mov al,es:[bx]
end;

 {$F+}
Procedure Pal(ColorNo : Byte; R,G,B : Byte);
  { This sets the Red, Green and Blue values of a certain color }
Begin
   Port[$3c8] := ColorNo;
   Port[$3c9] := R;
   Port[$3c9] := G;
   Port[$3c9] := B;
End;

Procedure GetPal(ColorNo : Byte; Var R,G,B : Byte);
  { This reads the values of the Red, Green and Blue values of a certain
    color and returns them to you. }
Begin
   Port[$3c7] := ColorNo;
   R := Port[$3c9];
   G := Port[$3c9];
   B := Port[$3c9];
End;


Procedure FadeDown(time:integer);
  { This procedure fades the screen out to black. }
VAR loop1,loop2:integer;
    Tmp : Array [1..3] of byte;
    col,a,b,c:byte;
      { This is temporary storage for the values of a color }
BEGIN
  port[$3c7]:=col;
  a:=port[$3c9];
  b:=port[$3c9];
  c:=port[$3c9];
  For loop1:=1 to 64 do BEGIN
   { WaitRetrace;}delay(time);
    For loop2:=1 to 255 do BEGIN
      Getpal (loop2,Tmp[1],Tmp[2],Tmp[3]);
      If Tmp[1]>0 then dec (Tmp[1]);
      If Tmp[2]>0 then dec (Tmp[2]);
      If Tmp[3]>0 then dec (Tmp[3]);
	{ If the Red, Green or Blue values of color loop2 are not yet zero,
	  then, decrease them by one. }
         Pal (loop2,Tmp[1],Tmp[2],Tmp[3]);
	{ Set the new, altered pallette color. }
    END;
  END;
pal(col,a,b,c);
END;

Procedure Fadeup(time:integer);
VAR loop1,loop2:integer;
    Tmp : Array [1..3] of byte;
    col,a,b,c:byte;

BEGIN
  port[$3c7]:=col;
  a:=port[$3c9];
  b:=port[$3c9];
  c:=port[$3c9];
  For loop1:=1 to 64 do BEGIN
   { WaitRetrace;}delay(time);
    For loop2:=1 to 255 do BEGIN
      Getpal(loop2,Tmp[1],Tmp[2],Tmp[3]);
      If Tmp[1]<A then inc (Tmp[1]);
      If Tmp[2]<B then inc (Tmp[2]);
      If Tmp[3]<C then inc (Tmp[3]);

         Pal (loop2,Tmp[1],Tmp[2],Tmp[3]);

    END;
  END;
pal(col,a,b,c);
END;

  Procedure SetRGB(Num,Red,Green,Blue:Word);
    var
    Reg              : Registers;
     begin
        Reg.Ax:=$1010;
        Reg.Bl:=Num;
        Reg.Dh:=Red;
        Reg.Ch:=Green;
        Reg.Cl:=Blue;
        Intr($10,Reg);
     end;

procedure lin(x,y,x1,y1,c,n:integer);
begin
setcolor(c);
SetLineStyle(0, 0, n);
line(x,y,x1,y1);
end;

procedure num(x,y,c2,nu,c:integer;s:real);
var
box :array[1..7]of boolean;
i,n :integer;
begin
if s=0 then n:=1;
for i:=1 to 7 do box[i]:=false;
if (nu mod 2 =0)or(nu=5)or(nu=9)or(nu=3)or(nu=0) then for i:=1 to 7 do box[i]:=true;
case nu of
0:box[3]:=false;
1:begin box[4]:=true;box[7]:=true;end;
6:box[4]:=false;
5:begin box[4]:=false;box[5]:=false;end;
3:begin box[2]:=false;box[5]:=false;end;
4:begin box[1]:=false;box[6]:=false;box[5]:=false;end;
7:begin box[1]:=true;box[4]:=true;box[7]:=true;end;
2:begin box[2]:=false;box[7]:=false;end;
9:box[5]:=false;
end;
if s<0.9 then n:=1 else n:=3;
if box[1] then lin(x+round(2*s),y,x+round(14*s),y,c2,n) else lin(x+round(2*s),y,x+round(14*s),y,c,n);
if box[2] then lin(x,y+round(2*s),x,y+round(20*s),c2,n) else lin(x,y+round(2*s),x,y+round(20*s),c,n);
if box[3] then lin(x+round(2*s),y+round(22*s),x+round(14*s),y+round(22*s),c2,n) else
lin(x+round(2*s),y+round(22*s),x+round(14*s),y+round(22*s),c,n);
if box[4] then lin(x+round(16*s),y+round(2*s),x+round(16*s),y+round(20*s),c2,n) else
lin(x+round(16*s),y+round(2*s),x+round(16*s),y+round(20*s),c,n);
if box[5] then lin(x,y+round(24*s),x,y+round(41*s),c2,n) else lin(x,y+round(24*s),x,y+round(41*s),c,n);
if box[6] then lin(x+round(2*s),y+round(43*s),x+round(14*s),y+round(43*s),c2,n) else
lin(x+round(2*s),y+round(43*s),x+round(14*s),y+round(43*s),c,n);
if box[7] then lin(x+round(16*s),y+round(24*s),x+round(16*s),y+round(41*s),c2,n) else
lin(x+round(16*s),y+round(24*s),x+round(16*s),y+round(41*s),c,n);
end;

  Procedure HideCursor;
  var
  reg:registers;
  begin
  reg.ah:=$01;
  reg.CH:=$20;
  intr($10,reg);
  end;

  Procedure ShowCursor;
  var
  reg:registers;
  begin
  reg.ah:=$01;
  reg.ch:=$06;
  reg.cl:=$07;
  intr($10,reg);
  end;
begin
  CheckWidthHeight;
  if LastMode = 7 then display:=PTR($B000,0)
    else Display:=PTR($B800,0);

end.
