Unit SndStuff;

Interface

Procedure InitSB;
Procedure WriteDsp(data:Byte; freq: word);
Procedure CloseSB;

Implementation

Uses Crt, Dos;

Var
   {de soundblaster ports}
   resetport,
   readport,
   Writeport,
   statusport,
   dac_Write,
   adc_read,
   speaker_on,
   speaker_off : word;

Function ResetDsp(base : word) : Boolean;
Var
   Count, Tport : Byte;
Begin
 ResetDsp := False;
 {de poorten berekenen 1= 210 2= 220, etc)}
 base := base * $10;
 resetport  := base + $206;
 readport   := base + $20A;
 Writeport  := base + $20C;
 statusport := base + $20E;
 dac_Write  := $10;
 adc_read   := $20;
 speaker_on  := $D1;
 speaker_off := $D3;


 Port[resetport] := 1;
  For count := 1 to 6 do
   Tport := Port[StatusPort];
 Port[ResetPort] := 0;
  For Count := 1 to 6 do
   Tport := Port[StatusPort];
 Repeat Until Port[StatusPort] > $80;
  if Port[ReadPort] = $AA then
   ResetDsp := True;
End;

Procedure SpeakerOn;
begin
   Repeat Until Port[WritePort] < $80;
   Port[WritePort] := $D1;
end;

Procedure SpeakerOff;
begin
   Repeat Until Port[WritePort] < $80;
   Port[WritePort] := $D3;
end;

Procedure WriteDsp(data:Byte; freq: word); Assembler;
Asm
   mov   dx,$22C
   mov   cx,6                          { Change either value of CX For }
@1:
   in    al,dx
   loop  @1

   mov   al,10h
   out   dx,al
   mov   cx,freq                         { faster or slower playing. }
@2:
   in    al,dx
   loop  @2

   mov   al,data
   out   dx,al
end;

Function ReadDsp : Byte;
begin
 Repeat Until Port[WritePort] < $80;
  port[WritePort] := $20;
 Repeat Until Port[StatusPort] > $80;
  ReadDsp := Port[ReadPort];
end;

Procedure InitSB;
Var Base, code : word;
    Ch   : char;
Begin
 Writeln;
 Writeln('Enter the base address of your soundcard (1=210, 2=220, etc) : ');

 Repeat
  Ch := Readkey;
  val(ch, base, code);
 Until (base >= 1) and (base <= 9);

 if not ResetDsp(Base) then
  begin
   Writeln('Can''t find a SoundBlaster at : 2',base,'0.');
   Writeln('Try another base address... (220 is most common)');
   halt(1);
  end;
 SpeakerOn;
End;

Procedure CloseSB;
Begin
 SpeakerOff;
End;

Begin
End.