program sorteer; 
{geschreven door erikdj@cybercomm.nl 20 oktober 1997}
{stukken code zijn afkomstig uit *Programming with datastructures* van Kruse}

uses
    crt;

const
  maxlist = 30000;     {Change to suit the requirements of the application.}
  {tot 30000 getest met quicksort geeft bij bestanden (max 5000) toch een
   stackoverflow, niet met nummers of random tekens.}

type
  string30 = string[30];
  listindex = 1..maxlist;
  listcount = 0..maxlist;
  listtype = record
    entry:  array[listindex] of char;
    count:  listcount
  end;
  window = listcount;
  listfile = file of listtype;

var
   teller : integer;
   aantal : integer;
   regel  : listtype;
   lengte : integer;
{__________________________________________________________________________}
FUNCTION Trek(Laag,Hoog : Integer) : Integer;

VAR
  I : Integer;

BEGIN
  REPEAT                      { Blijf vragen om random integers tot }
    I := Random(Hoog + 1);    { er een tussen Laag en Hoog in valt  }
  UNTIL I >= Laag;
  Trek := I
END;
{__________________________________________________________________________}
function OnList (W:window; L:listtype):boolean;
begin
     OnList := (W<>0)
end;
{__________________________________________________________________________}
procedure CreateList(var L: listtype);
{Specifications:
 Pre:  None.
 Post: The list L has been created and is initialized to be empty.
}
begin
  L.count := 0
end;
{__________________________________________________________________________}
function ListSize(var L:listtype):listcount;
{Specifications:
 Pre:  The list L has been created.
 Post: The function returns the number of entries in the list L.
}
begin
  ListSize := L.count
end;
{__________________________________________________________________________}
{_________________SELECTIONSORT PROCS BEGIN________________________________}
function MaxKey(low, high: listindex; var L: listtype):  listindex;
{Specifications:
 Pre:  The contiguous list L has been created; the indices satisfy
       the condition 1 <= low <= high <= L.count.
 Post: The function returns the index of the entry between positions low
       and high with the largest key.
}
var
  maxsofar,                 {index of the largest key found so far}
  current:  listcount;         {scans the list for its largest key}

begin			{function MaxKey}
  with L do
  begin
    maxsofar := low;
    for current := low+1 to high do
      if entry[maxsofar] < entry[current] then
        maxsofar := current;
    MaxKey := maxsofar
  end
end;			{function MaxKey}
{__________________________________________________________________________}
procedure Swap(x, y: listindex; var L: listtype);
{Specifications:
 Pre:  The contiguous list L has been created; the indices x and y are
       between 1 and L.count.
 Post: The entries at positions x and y have been interchanged.
}
var
  t:   char;         {temporary storage}
  balk : integer;
  a : integer;
begin			{procedure Swap}
  with L do
  begin

    gotoxy (12,5);
    t := entry[x];    entry[x] := entry[y];     entry[y] := t
  end
end;			{procedure Swap}
{__________________________________________________________________________}
procedure SelectionSort(var L: listtype);
{Specifications:
 Pre:  The contiguous list L has been created.  The entries of L all
       contain keys.
 Post: The entries of L have been rearranged so that all the keys in the
       entries are sorted into nondecreasing order.
}
var
  current,        {index of place being correctly filled}
  maxremaining: listindex; {index of largest remaining key}
  teller : integer;
  swapteller:integer;
begin					{procedure SelectionSort}
  clrscr;
  gotoxy(17,12);
  writeln('         langzaam sorteren');
  teller:=0;
  swapteller := 0;
  for current := L.count downto 2 do
  begin
  inc(teller);
    gotoxy(19,16);
  write ('        teller  : ',teller);
    maxremaining := MaxKey(1, current, L);
    Swap(maxremaining, current, L)
  end;
  gotoxy(18,14);
  writeln('Klaar met selectionsort (bubblesort)');
  gotoxy(19,16);
  write ('        teller  : ',teller);
  readln;
end;					{procedure SelectionSort}
{___________________________EIND SELECTION (BUBBLE)________________________}
{__________________________________________________________________________}
{_________________________QUICKSORT PROCEDURES_____________________________}
procedure Partition(var L: listtype; low, high: listindex;
                    var pivotlocation: listindex);
{Specifications:
 Pre:  The contiguous list L has been created and indices low and high
       refer to entries of L.
 Post: The center (or left center) entry of L has been chosen as a pivot and
       moved to index pivotlocation.  All entries of L between indices low and
       high, inclusive, have been rearranged so that those with keys less 
       than the pivot come before pivotlocation and the remaining entries come 
       after pivotlocation.
 Uses: procedure Swap(i, j, L), which interchanges the entries in indices
       i and j of contiguous list L.
}
var
  pivot: char;             {will be taken from the center of the list}
  i,                            {used to scan through the list}
  lastsmall: listcount;         {last key less than pivot}
  swapteller : integer;
begin                           {procedure Partition}

  Swap(low, (low + high) div 2, L); {Swap the pivot into the first location.}
  pivot := L.entry[low];
  lastsmall := low;
  for i := low + 1 to high do
    {At the beginning of each iteration of this loop, we have the
     following conditions:
        If low < j <= lastsmall then L.entry[j].key < pivot.
        If lastsmall < j < i then L.entry[j].key >= pivot.
}
    if L.entry[i] < pivot then
    begin
      lastsmall := lastsmall + 1;
      Swap(lastsmall, i, L)
{Move the large entry to the right and the small entry i to the left.}
    end;
  Swap(low, lastsmall, L);      {Put the pivot into its proper position.}
  pivotlocation := lastsmall
end;                            {procedure Partition}
{__________________________________________________________________________}
procedure Sort(var L: listtype; low, high: integer;var teller : integer);
{Specifications:
 Pre:  The contiguous list L has been created, and, if low < high, then
       L contains entries indexed from low to high, inclusive.
 Post: The entries of L between indices low and high, inclusive, have
       been sorted into nondecreasing order according to their keys.
 Uses: Procedure Partition
}
var
  pivotlocation:  listindex;  {location of the pivot after partitioning}
begin
  if low < high then      {If not, then no sorting is needed.}
  begin
    Partition(L, low, high, pivotlocation);
    Sort(L, low, pivotlocation - 1,teller);
    inc (teller);
     gotoxy (19,16);
     writeln ('        teller is ',teller);
    Sort(L, pivotlocation + 1, high,teller)
  end
end; 
{__________________________________________________________________________}
procedure QuickSort(var L:listtype);
{Specifications:
 Pre:  The contiguous list L has been created.  The entries of L all
       contain keys.
 Post: The entries of L have been rearranged so that all the keys in the
       entries are sorted into nondecreasing order.
 Uses: Procedure Sort to do the actual recursive quicksort.
}
var teller : integer;
begin
  clrscr;
  teller := 0;
  gotoxy(17,12);
  writeln('          Snel sorteren');
  Sort(L, 1, L.count,teller);
  gotoxy(18,14);
  writeln('       Klaar met quicksort');
  gotoxy (19,16);
  writeln ('        teller is ',teller);
        readln
end;
{_______________________EIND QUICKSORT PROCEDURES__________________________}
{__________________________________________________________________________}
procedure ReadList(var s: listtype);
{Specifications:
 Pre : Geen.
 Post: The string s has been created and contains characters read from the
       keybord until the end of a line is reached or the string s is full,
       whichever occurs first.
}
begin                         {procedure ReadList}
  with s do
  begin
    count := 0;
    while (not eoln) and (count < maxlist) do
    begin
      count := count + 1;
      read(entry[count])
    end;
    readln
  end
end;                          {procedure ReadList}
{________________________________________________________________}
procedure maakfile(var s: listtype);
{Specifications:
 Pre:  the string s has been created.
 Post: The string s is written to the screen.
}
var
  i: listindex;           {loop control variable}
  IntTekst : Text;
  werknaam : string30;
begin                       {procedure WriteString}
  clrscr;
  with s do
  begin
  Write('> Geef een naam voor het bestand, afsluiten met (enter): ');
  readln (werknaam);
  assign (inttekst,Werknaam);
  rewrite (inttekst);
    for i := 1 to count do
      write(inttekst,entry[i]);
      writeln('Bestand is ',werknaam );
  close (inttekst);
  end;
  readln
end;                        {procedure WriteString}
{__________________________________________________________________________}
procedure writestring(var s: listtype);
{Specifications:
 Pre:  the string s has been created.
 Post: The string s is written to the screen.
}
var
  i: listindex;           {loop control variable}
begin                       {procedure WriteString}
  with s do
    for i := 1 to count do
      write(entry[i]);
      writeln
end;                        {procedure WriteString}
{__________________________________________________________________________}
procedure haalfile (var s: listtype);
var
  i: listindex;           {loop control variable}
  IntTekst : Text;
  werknaam : string30;
  OK : boolean;
  poging : integer;
begin                       {procedure WriteString}
  clrscr;
  with s do
   begin
       count := 0;
       poging:=1;
       repeat
           Write('> Geef de naam van het bestand, afsluiten met (enter): ');
             readln (werknaam);
             assign (inttekst,Werknaam);
        {$I-}reset (inttekst);{$I+}
          if IOresult <> 0 THEN
            begin
                 clrscr;
                 poging :=2;
                 writeln('Poging ',poging);
                 writeln('>>die file bestaat niet, probeer opnieuw.');
                 inc(poging);
                 OK := false;
            end
            else OK:= true
        until OK;
                     while not eof(inttekst) and (count<maxlist) do
                           begin
                              inc (count);
                              read (inttekst,entry[count]);
                           end;
                 close (inttekst);
   end;
end;      {procedure WriteString}
{__________________________________________________________________________}
procedure schrijflijst;
begin
     clrscr;
     Writeln ('De lijst is : ');
     writeln ('   ---------------------------------------------------------------------');
     WriteString (regel);
     writeln ('   ---------------------------------------------------------------------');
     writeln;
     Writeln ('Het aantal tekens ');
     lengte := listsize(regel);
     if lengte < 50 then
          for teller := 1 to lengte do write ('*');
     writeln;
     writeln (lengte);
     writeln;
     readln
end;
{__________________________________________________________________________}
procedure leeslijst;
begin
     clrscr;
     Writeln ('Het maken van een list ');
     write ('Geef een string aub maximaal ',maxlist,' tekens ..... ');
     CreateList (regel);
     ReadList (regel);
end;
{__________________________________________________________________________}
procedure slaop;
begin
 clrscr;
 maakfile(regel);
end;
{__________________________________________________________________________}
procedure selection;
begin
     clrscr;
     selectionsort(regel);
     writeln ('klaar');
     readln;
end;
{__________________________________________________________________________}
procedure quick;
begin
     clrscr;
     writeln ('quick');
     readln;
end;
{__________________________________________________________________________}
procedure initialiseer;
begin
   teller :=0;
   aantal :=0;
   lengte :=0;
   createlist(regel);
end;
{__________________________________________________________________________}
procedure maakran (var s: listtype);
{pre: geen}
{post : de lijst is tot maxlist gevuld met random nummers}
var
   nummer : integer;
begin
clrscr;
writeln ('         Bezig met genereren van ',maxlist,' random ascii tekentjes');
     writeln ('   ---------------------------------------------------------------------');
  with s do
  begin
  randomize;
    count := 0;
    while (count < maxlist) do
    begin
      count := count + 1;
      nummer := trek(33,252);
      write (chr(nummer));
      entry[count]:= chr(nummer);
    end;
  end;
  writeln;
     writeln ('   ---------------------------------------------------------------------');
  writeln;
  writeln ('Klaar, (enter)');
  readln;
end;
{__________________________________________________________________________}
procedure maakrannum (var s: listtype);
{pre: geen}
{post : de lijst is tot maxlist gevuld met random nummers}
var
   nummer : integer;
begin
clrscr;
writeln ('         Bezig met genereren van ',maxlist,' random nummers');
     writeln ('   ---------------------------------------------------------------------');
  with s do
  begin
  randomize;
    count := 0;
    while (count < maxlist) do
    begin
      count := count + 1;
      nummer := trek(48,57);
      write (chr(nummer));
      entry[count]:= chr(nummer);
    end;
  end;
  writeln;
     writeln ('   ---------------------------------------------------------------------');
  writeln;
  writeln ('Klaar, (enter)');
  readln;
end;
{__________________________________________________________________________}
procedure main;
var
   ch: char;
begin
repeat
  clrscr;
  textcolor(10);
     gotoxy(24,2);
     writeln (' ',chr(02),' ',chr(01),' ',chr(02),' Sorteer demo ',chr(01),' ',chr(02),' ',chr(01));
     gotoxy(24,3);
     textcolor (15);
     writeln ('--------------------------');
     gotoxy(24,4);
     writeln ('Wilt u :');
     gotoxy(24,5);
     writeln ('--------------------------');
     gotoxy(24,6);
     textcolor (14);
     writeln ('(H)andmatig invoeren');
     gotoxy(24,7);
     writeln ('(U)it bestand invoeren');
     gotoxy(24,8);
     writeln ('(N)aar bestand');
     gotoxy(24,10);
     writeln ('(T)oon lijst');
     gotoxy(24,12);
     writeln ('(M)aak random teken lijst');
     gotoxy(24,13);
     writeln ('(R)andom nummer lijst');
     gotoxy(24,15);
     writeln ('(S)electionsort op lijst');
     gotoxy(24,16);
     writeln ('(Q)uicksort op lijst');
     gotoxy(24,17);
     textcolor(15);
     writeln ('==========================');
     gotoxy(24,18);
     textcolor(12);
     writeln ('0 = Stop');
     gotoxy(22,20);
     textcolor(9);
     writeln ('   door Erik de Jonge');
     textcolor(15);
     ch := upcase(readkey);
     case ch of
      'H' : leeslijst;
      'U' : Haalfile(regel);
      'N' : Slaop;
      'T' : Schrijflijst;
      'S' : selectionsort(regel);
      'Q' : quicksort(regel);
      'M' : maakran(regel);
      'R' : maakrannum(regel);
     end;
until ch=('0');
end;
{__________________________________________________________________________}
{                        HIER BEGINT HET HOOFDPROGRAMMA                    }
{__________________________________________________________________________}
begin
     initialiseer; {alle integers op 0}
     clrscr; {clear screen}
     main; {hoofdscherm}
end.