Unit U3d2;

{
  Ŀ
   Author     Joris de Gruyter                                         
   Target     Turbo Pascal 7.0, real mode                              
   Use        Graphics without BGIs, and 3D-routines                   
   Contact    e-mail : JorisdG@glo.be                                  
   Future     Joystick-unit, 3D-programs                               
   Available  Games : * "Space Invaders" (SB,mouse)                    
                      * Soon : "Block" (SB?,mouse,multiplayer (serial))
              3D-demos : "JORIS !" ; "BLOCK"                           
  Ĵ
   Created October 1997                                                 
  

  This UNIT is written by Joris de Gruyter, except the following procedures :
       Procedure Pal(Col,R,G,B : Byte);
       Procedure Line(a,b,c,d:integer;col:byte);
       Procedure Poly(x1,y1,x2,y2,x3,y3,x4,y4:integer;color:byte);
  These procedures come from the demo-group ASPHYXIA. I've made some minor
  changes to make it work with my unit.
  My original 3D-unit used BGIs, but, to make it faster, I used the BIOS,
  but my line and poly procedures wouldn't work, so...
}

INTERFACE

Type block  = record  { For use with DrawBlock. DO NOT ROTATE AROUND Z !!}
       x,y,z,x2,y2,z2 : real;
      end; {  (x,y,z),(x,y,z2),(x2,y2,z),(x2,y2,z2) }
Type room = record
      c : Array['x'..'z',1..4] of real; {cordinates}
      h : real; { height }
     end;

Type screentype = Array[-100..99,-160..159] of byte;
Var Screen : screentype absolute $A000:0000;
    coss : Array[-360..360] of real;
    sinn : Array[-360..360] of real;
    graden : integer;

Procedure SetGraph;  { MCGA 320x200x256 }

Procedure SetText;  { text mode 80x25 color }

Procedure Cls(Col : Byte);

Procedure Pal(Col,R,G,B : Byte); { Not written by me. }

Function rad(r : real) : real;

Procedure Putpixel(X,Y : Integer; Col : Byte);

Procedure Line(a,b,c,d:integer;col:byte); { Not written by me. }

Procedure Fix2D(x,y,z : real;Var nx,ny : integer);

Procedure Fix2Dfocus(x,y,z : real;f : integer;Var nx,ny : integer);

Procedure rotateZ(Var x,y,z : real;g : integer);

Procedure rotateX(Var x,y,z : real;g : integer);

Procedure rotateY(Var x,y,z : real;g : integer);

Procedure PivotZ(px,py,pz : real;Var pxx,pyy,pzz : real;g : integer);

Procedure PivotX(px,py,pz : real;Var pxx,pyy,pzz : real;g : integer);

Procedure PivotY(px,py,pz : real;Var pxx,pyy,pzz : real;g : integer);

Procedure Poly(x1,y1,x2,y2,x3,y3,x4,y4:integer;color:byte); { Not written by me. }

Procedure DrawBlock(b : block;f,c : integer);

Procedure Line3D(x1,y1,z1,x2,y2,z2 : real;f, c : integer);

Procedure MakeRoom(k : room; c : integer);

Procedure TurnRoom(Var k : room;g : integer);

IMPLEMENTATION

Procedure TurnRoom(Var k : room;g : integer);
 Begin
  RotateY(k.c['x',1],k.c['y',1],k.c['z',1],g);
  RotateY(k.c['x',2],k.c['y',2],k.c['z',2],g);
  RotateY(k.c['x',3],k.c['y',3],k.c['z',3],g);
  RotateY(k.c['x',4],k.c['y',4],k.c['z',4],g);
 End;

Procedure MakeRoom(k : room; c : integer);
Var X1,X2,X3,X4,Y1,Y2,Y3,Y4 : integer;
 Begin
  Fix2D(k.c['x',1],k.c['y',1],k.c['z',1],X1,Y1);
  Fix2D(k.c['x',2],k.c['y',2],k.c['z',2],X2,Y2);
  Fix2D(k.c['x',3],k.c['y',3],k.c['z',3],X3,Y3);
  Fix2D(k.c['x',4],k.c['y',4],k.c['z',4],X4,Y4);
  Poly(X1,Y1,X2,Y2,X3,Y3,X4,Y4,c);

  Fix2D(k.c['x',1],k.c['y',1]+k.h,k.c['z',1],X1,Y1);
  Fix2D(k.c['x',2],k.c['y',2]+k.h,k.c['z',2],X2,Y2);
  Fix2D(k.c['x',3],k.c['y',3]+k.h,k.c['z',3],X3,Y3);
  Fix2D(k.c['x',4],k.c['y',4]+k.h,k.c['z',4],X4,Y4);
  Poly(X1,Y1,X2,Y2,X3,Y3,X4,Y4,c);
 End;

Procedure Hline (x1,x2,y:word;col:byte;where:word); assembler;
asm
  mov   ax,where
  mov   es,ax
  mov   ax,y
  mov   di,ax
  shl   ax,8
  shl   di,6
  add   di,ax
  add   di,x1

  mov   al,col
  mov   ah,al
  mov   cx,x2
  sub   cx,x1
  shr   cx,1
  jnc   @start
  stosb
@Start :
  rep   stosw
end;

Procedure Line3D(x1,y1,z1,x2,y2,z2 : real;f, c : integer);
Var xx1,yy1,xx2,yy2 : integer;
 Begin
  If (z1<=0) and (z2>0) and (x2=x1) then
   Begin
    y1:=(y2-y1)*((1-z1) / (z1-z2)) + y1;
    z1:=1;
   End;
  If (z1<=0) and (z2>0) and (x2<>x1) then
   Begin
    y1:=(y2-y1)*((1-z1) / (z1-z2)) + y1;
    x1:=(x2-x1)*((1-z1) / (z1-z2)) + x1;
    z1:=1;
   End;
  If (z2<=0) and (z1>0) and (x2=x1) then
   Begin
    y1:=(y2-y1)*((1-z2) / (z1-z2)) + y1;
    z2:=1;
   End;
  If (z2<=0) and (z1>0) and (x2<>x1) then
   Begin
    y1:=(y2-y1)*((1-z2) / (z1-z2)) + y1;
    x2:=(x2-x1)*((1-z2) / (z1-z2)) + x2;
    z2:=1;
   End;
  If (z1>=0) and (z2>=0) then
   Begin
    Fix2Dfocus(x1*10,y1*10,z1*10,f,xx1,yy1);
    Fix2Dfocus(x2*10,y2*10,z2*10,f,xx2,yy2);
    Line(xx1,yy1,xx2,yy2,c);
   End;
 End;

Procedure DrawBlock(b : block;f,c : integer);
Var x1, y1, x2, y2, x3, y3, x4, y4 : integer;
 Begin
  Fix2Dfocus(b.x,b.y,b.z,f,x1,y1);     {= 1   1Ŀ2 }
  Fix2Dfocus(b.x2,b.y,b.z2,f,x2,y2);   {= 2            }
  Fix2Dfocus(b.x2,b.y2,b.z2,f,x3,y3);  {= 3            }
  Fix2Dfocus(b.x,b.y2,b.z,f,x4,y4);    {= 4   43 }
  Poly(x1,y1,x2,y2,x3,y3,x4,y4,c);
{  Line(x1,y1,x2,y2,c);
  Line(x1,y1,x4,y4,c);
  Line(x2,y2,x3,y3,c);
  Line(x4,y4,x3,y3,c);}
 End;


Procedure Poly(x1,y1,x2,y2,x3,y3,x4,y4:integer;color:byte);
{ Thanx to ASPHYXIA }
Var
  x:integer;
  mny,mxy:integer;
  mnx,mxx,yc:integer;
  mul1,div1,
  mul2,div2,
  mul3,div3,
  mul4,div4:integer;

 Begin
  x1:=x1+160; y1:=y1+100;
  x2:=x2+160; y2:=y2+100;
  x3:=x3+160; y3:=y3+100;
  x4:=x4+160; y4:=y4+100;
  mny:=y1; mxy:=y1;
  if y2<mny then mny:=y2;
  if y2>mxy then mxy:=y2;
  if y3<mny then mny:=y3;
  if y3>mxy then mxy:=y3;
  if y4<mny then mny:=y4;
  if y4>mxy then mxy:=y4;

  if mny<0 then mny:=0;
  if mxy>199 then mxy:=199;
  if mny>199 then exit;
  if mxy<0 then exit;

  mul1:=x1-x4; div1:=y1-y4;
  mul2:=x2-x1; div2:=y2-y1;
  mul3:=x3-x2; div3:=y3-y2;
  mul4:=x4-x3; div4:=y4-y3;

  for yc:=mny to mxy do
    begin
      mnx:=320;
      mxx:=-1;
      if (y4>=yc) or (y1>=yc) then
        if (y4<=yc) or (y1<=yc) then
          if not(y4=y1) then
            begin
              x:=(yc-y4)*mul1 div div1+x4;
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;
            end;
      if (y1>=yc) or (y2>=yc) then
        if (y1<=yc) or (y2<=yc) then
          if not(y1=y2) then
            begin
              x:=(yc-y1)*mul2 div div2+x1;
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;
            end;
      if (y2>=yc) or (y3>=yc) then
        if (y2<=yc) or (y3<=yc) then
          if not(y2=y3) then
            begin
              x:=(yc-y2)*mul3 div div3+x2;
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;
            end;
      if (y3>=yc) or (y4>=yc) then
        if (y3<=yc) or (y4<=yc) then
          if not(y3=y4) then
            begin
              x:=(yc-y3)*mul4 div div4+x3;
              if x<mnx then
                mnx:=x;
              if x>mxx then
                mxx:=x;
            end;
      if mnx<0 then
        mnx:=0;
      if mxx>319 then
        mxx:=319;
      if yc<0 then
        yc:=0;
      if yc>199 then
        yc:=199;
      if mnx<=mxx then
        HLine(mnx,mxx,yc,color,seg(screen));
    end;
  End;

Procedure PivotY(px,py,pz : real;Var pxx,pyy,pzz : real;g : integer);
 Begin
  pxx:=pxx-px;
  pyy:=pyy-py;
  pzz:=pzz-pz;
  rotateY(pxx,pyy,pzz,g);
  pxx:=pxx+px;
  pyy:=pyy+py;
  pzz:=pzz+pz;
 End;

Procedure PivotX(px,py,pz : real;Var pxx,pyy,pzz : real;g : integer);
 Begin
  pxx:=pxx-px;
  pyy:=pyy-py;
  pzz:=pzz-pz;
  rotateX(pxx,pyy,pzz,g);
  pxx:=pxx+px;
  pyy:=pyy+py;
  pzz:=pzz+pz;
 End;

Procedure PivotZ(px,py,pz : real;Var pxx,pyy,pzz : real;g : integer);
 Begin
  pxx:=pxx-px;
  pyy:=pyy-py;
  pzz:=pzz-pz;
  rotateZ(pxx,pyy,pzz,g);
  pxx:=pxx+px;
  pyy:=pyy+py;
  pzz:=pzz+pz;
 End;


Procedure rotateZ(Var x,y,z : real;g : integer);
Var xx,yy,zz : real;
 Begin
  If g<0 then g:=360-ABS(g);
  xx:=x*coss[g] - y*sinn[g];
  yy:=x*sinn[g] + y*coss[g];
  x:=xx;
  y:=yy;
 End;

Procedure rotateX(Var x,y,z : real;g : integer);
Var xx,yy,zz : real;
 Begin
  If g<0 then g:=360-ABS(g);
  yy:=y*coss[g] - z*sinn[g];
  zz:=y*sinn[g] + z*coss[g];
  y:=yy;
  z:=zz;
 End;

Procedure rotateY(Var x,y,z : real;g : integer);
Var xx,yy,zz : real;
 Begin
  If g<0 then g:=360-ABS(g);
  xx:=x*coss[g] - z*sinn[g];
  zz:=x*sinn[g] + z*coss[g];
  x:=xx;
  z:=zz;
 End;

Procedure Fix2D(x,y,z : real;Var nx,ny : integer);
 Begin
  If (Round(z)<=0) then nx:=Round(32*x) div 1
   Else nx:=Round(32*x) DIV Round(z);
  If (Round(z)<=0) then ny:=Round(32*y) div 1
   Else ny:=Round(32*y) DIV Round(z);
 End;

Procedure Fix2Dfocus(x,y,z : real;f : integer;Var nx,ny : integer);
 Begin
  If (Round(z)=0) then nx:=Round(f*x) div 1
   Else nx:=Round(f*x) DIV Round(z);
  If (Round(z)=0) then ny:=Round(f*y) div 1
   Else ny:=Round(f*y) DIV Round(z);
 End;

Procedure Line(a,b,c,d:integer;col:byte);
{ Thanx to ASPHYXIA. }

  Function sgn(a:real):integer;
   Begin
    If a>0 then sgn:=+1;
    If a<0 then sgn:=-1;
    If a=0 then sgn:=0;
   End;

Var i,s,d1x,d1y,d2x,d2y,u,v,m,n:integer;
 Begin
  a:=a+160;
  b:=b+100;
  c:=c+160;
  d:=d+100;
  u:=c - a;
  v:=d - b;
  d1x:=SGN(u);
  d1y:=SGN(v);
  d2x:=SGN(u);
  d2y:=0;
  m:= ABS(u);
  n:= ABS(v);
  If not (M>N) then
   Begin
    d2x:=0;
    d2y:=SGN(v);
    m:=ABS(v);
    n:=ABS(u);
   End;
  s:=m shr 1;
  For i := 0 to m do
   Begin
    PutPixel(a-160,b-100,col);
    s:=s + n;
    If not (s<m) then
     Begin
      s:=s - m;
      a:=a + d1x;
      b:=b + d1y;
     End
    Else
     Begin
      a:=a + d2x;
      b:=b + d2y;
     End;
   End;
 End;


Procedure Putpixel(X,Y : Integer; Col : Byte);
 Begin
  If (y<=99) and (y>=-100) and (x<=159) and (x>=-160) then screen[y,x]:=col;
 End;

Function rad(r : real) : real;
 Begin
  rad:=r * pi / 180;
 End;

Procedure Pal(Col,R,G,B : Byte);
{ Thanx to ASHPYXIA. }
 Begin
  asm
   mov    dx,3c8h
   mov    al,[col]
   out    dx,al
   inc    dx
   mov    al,[r]
   out    dx,al
   mov    al,[g]
   out    dx,al
   mov    al,[b]
   out    dx,al
  end;
 End;

Procedure Cls(Col : Byte);
Var d1, d2 : integer;
 Begin
  For d1 := 1 to 200 do
   For d2 := 1 to 320 do screen[d1,d2]:=col;
 End;

Procedure SetGraph;  { 320x200x256 }
 Begin
  asm
   mov        ax,13h
   int        10h
  end;
 End;

Procedure SetText;  { text mode }
Begin
 asm
  mov        ax,0003h
  int        10h
 end;
End;

Begin
 For graden := -360 to 360 do
  Begin
   coss[graden]:=cos(rad(graden));
   sinn[graden]:=sin(rad(graden));
  End;
End.

