UNIT UNIT97;

INTERFACE

procedure BUTTON_OFF(x,y,xx,yy :integer;text :string;color,border :byte;r :boolean);
procedure BUTTON_ON(x,y,xx,yy :integer;text :string;border :byte;r :boolean);
procedure FILL_BAR(x,y,xx,yy :integer;color,raster :byte);
procedure STARS(x,y,xx,yy,number :integer;point :byte);
procedure HOR_LINE(x,y,xx :integer;number,afst,color :byte);
procedure VER_LINE(x,y,yy :integer;number,afst,color :byte);

procedure VIDEO_ON;
procedure WAIT(ms : Word);
procedure CLEAR_BUFFER;
function  READ_KEY_VALUE :word;
procedure CLICK(freq,delay :integer);
procedure TIME(x,y :integer;color :byte);
function  WEEK_DATE :string;
function  DAY_OF_WEEK(Month,Day,Year :word):byte;
function  PRINTER_OK :boolean;
function  ERROR_MSG(ErrorCode :INTEGER):string;
procedure CAPSLOCK_ON;
procedure CAPSLOCK_OFF;
procedure NUMLOCK_ON;
procedure NUMLOCK_OFF;

procedure CURSOR_OFF;
procedure CURSOR_ON;
procedure FAST_WRITE(x,y :Word;MsgText :String;ColorAttr :Byte);

procedure WRITE_TEXT(x,y :integer;text :string;bg,vg,soort,size :byte);
procedure SHADOW_TEXT(x,y :integer;text :string;bg,vg,size :byte);
procedure ASCI_TEXT(x,y: integer; st: string;color :byte);
procedure ABC(x,y :integer;tekens,color,soort :byte);
procedure DISPLAY(x,y :integer;text :string;back,color,size :byte);

procedure FADE_DOWN(speed :byte);
procedure RESET_COLORS;
procedure SWAP_COLORS(col1,col2 :byte);

procedure SCREEN_OFF;
procedure SCREEN_ON;
procedure SCREEN_BORDER(color: byte);
procedure ROTATE_SCREEN(mx,my,mxx,myy :integer);
procedure MIRROR_SCREEN(mx,my,mxx,myy :integer);
procedure SCREEN_TO_BLACK(style,delay :byte);

procedure DEL_FILE(filename :string);
function  EXIST_FILE(FileName : string) : boolean;
function  EXIST_DIR(dir:string):boolean;
procedure GET_FILE_ATTR(fn:string;var Attr:word);
procedure SET_FILE_ATTR(fn :string;Attr:word);
procedure GET_FILE_SIZE(FName :string;var Fsize :longint;var Error :word);
function  FIND_STRING(filename,search :string) :word;

procedure SAVE_IMAGE(X1,Y1,X2,Y2 :Integer;FileNaam :String);
procedure LOAD_IMAGE(X1,Y1 :Integer;FileNaam :String);
procedure SAVE_SCREEN(filename :string);
procedure LOAD_SCREEN(filename :string);
procedure SAVE_ICON(x,y :integer;filenaam :string);
procedure LOAD_ICON(xx,yy :integer;filename :string);
procedure SAVE_PCX(filename :string);
procedure LOAD_PCX(filename :string);
procedure SAVE_BMP(filename :string);
Procedure LOAD_BMP(FileName: String);
procedure DUMP_LASER;
procedure DUMP_MATRIX;

IMPLEMENTATION


uses dos,crt,graph,printer;

Const
  PelAddrRgR  = $3C7;
  PelAddrRgW  = $3C8;
  PelDataReg  = $3C9;


Type
  RGB = Record
        R,
        G,
        B : Byte;
      End;
 Color = Array [0..63] Of RGB;
 DacType = Array[1..256,1..3] of Byte;


var
  x,y,xx,yy,p,pp,q,qq    :integer;
  regs                   :registers;
  dac1,dac2        :DacType;
    Kx,Ky,i,erg,
    gesamt           :Word;
  Col : Color;

procedure BUTTON_OFF(x,y,xx,yy :integer;text :string;color,border :byte;
                                                      r :boolean);
var
  hor,ver :real;

begin
  setcolor(0);if r =true then rectangle(x,y,xx,yy);
  setfillstyle(1,7);bar(x+1,y+1,xx-1,yy-1);
  setcolor(15);
  for p :=0 to border do line(x+p+1,y+p+1,xx-p-1,y+p+1);
  for p :=0 to border do line(xx-p-1,y+p+1,xx-p-1,yy-p-1);
  setcolor(8);
  for p :=0 to border do line(x+p+1,yy-p-1,xx-p-1,yy-p-1);
  for p :=0 to border do line(x+p+1,y+p+1,x+p+1,yy-p-1);
  hor :=((xx-x)/2)+x-(length(text)*8)/2;ver :=((yy-y)/2)+y+2;
  case color of
    0:setcolor(11);
    1:setcolor(11);
    2:setcolor(11);
    3:setcolor(15);
    4:setcolor(14);
    5:setcolor(15);
   11:setcolor(0);
   13:setcolor(0);
   14:setcolor(0);
  end;
  outtextxy(round(hor),round(ver)-6,text);
  setcolor(color);outtextxy(round(hor)+1,round(ver)-5,text);
end;

procedure BUTTON_ON(x,y,xx,yy :integer;text :string;border :byte;r :boolean);

var
  hor,ver :real;

begin
  setcolor(0);if r =true then rectangle(x,y,xx,yy);
  setfillstyle(1,7);bar(x+1,y+1,xx-1,yy-1);
  setcolor(8);
  for p :=0 to border do line(x+p+1,y+p+1,xx-p-1,y+p+1);
  for p :=0 to border do line(xx-p-1,y+p+1,xx-p-1,yy-p-1);
  setcolor(15);
  for p :=0 to border do line(x+p+1,yy-p-1,xx-p-1,yy-p-1);
  for p :=0 to border do line(x+p+1,y+p+1,x+p+1,yy-p-1);
  hor :=((xx-x)/2)+x-(length(text)*8)/2;ver :=((yy-y)/2)+y+3;
  setcolor(0);outtextxy(round(hor)+2,round(ver)-5,text);
  setcolor(7);outtextxy(round(hor)+3,round(ver)-4,text);
end;

procedure FILL_BAR(x,y,xx,yy :integer;color,raster :byte);

const
  soort :array[0..27] of fillpatterntype =
                   (($ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff),
                    (0,$fb,$fb,$fb,0,$df,$df,$df),
                    (0,$10,$28,$44,$28,$10,0,0),
                    ($22,0,$88,0,$22,0,$88,0),
                    ($cc,$33,$cc,$33,$cc,$33,$cc,$33),
                    ($aa,$55,$aa,$55,$aa,$55,$aa,$55),
                    ($94,$84,$48,$30,0,$c1,$22,$14),
                    ($aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa),
                    ($ff,0,$ff,0,$ff,0,$ff,0),
                    ($ff,$1,$7d,$45,$5d,$41,$7f,0),
                    ($01,$82,$44,$28,$10,$20,$40,$80),
                    (0,$3c,$42,$42,$42,$42,$3c,0),
                    (0,$7e,$7e,$7e,$7e,$7e,$7e,0),
                    ($81,$42,$24,$18,$18,$24,$42,$81),
                    (0,$ec,$2a,$2a,$2a,$aa,$ec,0),
                    (0,$08,$18,$3f,$3f,$18,$08,0),
                    (0,0,$7e,$42,$7e,$42,$7e,$42),
                    ($80,$7f,$41,$41,$41,$41,$41,$7f),
                    (0,$5d,$3e,$6b,$7f,$63,$36,$5d),
                    (0,0,$04,$08,$90,$a0,$c0,$f0),
                    ($92,$24,$49,$92,$24,$49,$92,$24),
                    ($b1,$22,$14,$14,$22,$91,$48,$24),
                    ($18,$3c,$3c,$7e,$7e,$3c,$3c,$18),
                    ($e7,$c3,$81,$18,$18,$81,$c3,$e7),
                    ($2,$91,$68,$8,$10,$16,$89,$40),
                    ($ff,$81,$81,$81,$81,$81,$81,$ff),
                    (0,0,$81,$81,$42,$24,$18,$18),
                    ($c3,$42,$5a,$7e,$7e,$5a,$42,$c3));
begin
  if raster < 28 then begin
    setfillpattern(soort[raster],color);
    setfillstyle(12,color);
    bar(x,y,xx,yy);
  end;
end;

procedure STARS(x,y,xx,yy,number :integer;point :byte);

begin
 { randomize;}
  for pp :=0 to point do begin
    for p :=1 to number do begin
      putpixel(random(xx-(x-1))+x,random(yy-(y-1))+y,7);
      putpixel(random(xx-(x-1))+x,random(yy-(y-1))+y,8);
      putpixel(random(xx-(x-1))+x,random(yy-(y-1))+y,15);
    end;
    inc(x,40);inc(y,40);dec(xx,40);dec(yy,40);
  end;
end;

procedure HOR_LINE(x,y,xx :integer;number,afst,color :byte);

begin
  for p :=0 to number-1 do begin
    setcolor(color);
    line(x,y+(p*afst),xx,y+(p*afst));
  end;
end;

procedure VER_LINE(x,y,yy :integer;number,afst,color :byte);

begin
  for p :=0 to number-1 do begin
    setcolor(color);
    line(x+(p*afst),y,x+(p*afst),yy);
  end;
end;

Procedure WAIT(ms : Word); Assembler;
Asm
  mov ax, 1000;
  mul ms;
  mov cx, dx;
  mov dx, ax;
  mov ah, $86;
  int $15;
end;

procedure CLEAR_BUFFER;

begin
  memw[$0000:$041C] :=memw[$0000:$041A];
end;

procedure WRITE_TEXT(x,y :integer;text :string;bg,vg,soort,size :byte);

begin
  settextstyle(soort,0,size);
  setcolor(bg);outtextxy(x,y,text);
  setcolor(vg);outtextxy(x+1,y+1,text);
  settextstyle(0,0,0);
end;

procedure SHADOW_TEXT(x,y :integer;text :string;bg,vg,size :byte);

var
  pal :byte;
  pos :integer;

begin
  if (size <2) or (size >10) then exit;
  settextstyle(0,0,size);
  setcolor(bg);outtextxy(x,y,text);
  setcolor(vg);outtextxy(x+1,y+1,text);
  settextstyle(0,0,0);
  p :=length(text)*(size*8);
  pos :=0;
  for yy :=y to y+(size*8) do begin
    for xx :=x to x+p do begin
      pal :=getpixel(xx,yy);
      if pal =bg then putpixel(xx,yy+(size*8)+pos,7);
      if pal =vg then putpixel(xx,yy+(size*8)+pos,8);
    end;
    inc(pos);
  end;
end;

procedure ASCI_TEXT(x,y: integer; st: string;color :byte);

var
  regs :registers;

begin
  regs.ah:=$13;
  regs.al:=$01;
  regs.bl:=color;
  regs.bh:=$00;
  regs.cx:=Length(St);
  regs.dl:=x;
  regs.dh:=y;
  regs.es:=Seg(St[1]);
  regs.bp:=Ofs(St[1]);
  Intr(16,regs)
end;

function READ_KEY_VALUE :word;

var
  Value : word;

begin
  repeat until KeyPressed;
  Value := Ord(ReadKey);
  if Value = 0
  then Value := Ord(ReadKey) + 256;
  Read_Key_Value := Value;
end;

procedure CLICK(freq,delay :integer);

begin
  sound(freq);wait(delay);nosound;
end;

procedure TIME(x,y :integer;color :byte);

var h,m,s,hund :word;
  st :string[10];

function leading(w :word) :string;

begin
  str(w:0,st);
  if length(st) =1 then st :='0' +st;
  leading :=st;
end;
begin
  gettime(h,m,s,hund);
  asci_text(x,y,leading(h)+':'+leading(m)+':'+leading(s),color);
end;

function WEEK_DATE :string;

type
  WeekDays = Array[0..6]  Of STRING[9];
  Months   = Array[1..12] Of STRING[9];

const
  DayNames   : WeekDays  = ('Sunday','Monday','Tuesday','Wednesday',
                              'Thursday','Friday','Saturday');
  MonthNames : Months    = ('January','February','March','April','May',
                              'June','July','August','September',
                              'October','November','December');
var
  Y,M,D,DayOfWeek :WORD;
  Year      :STRING;
  Day       :STRING;

begin
  GetDate(Y,M,D,DayofWeek);
  Str(Y,Year);
  Str(D,Day);
  Week_Date :=DayNames[DayOfWeek]+' '+MonthNames[M]+' '+Day+', '+Year;
end;

function Day_Of_Week(Month,Day,Year :WORD):byte;

var
  ivar1,ivar2 :Integer;

begin
  IF (Day > 0) AND (Day < 32) AND (Month > 0) AND (Month < 13) then begin
    ivar1 := ( Year MOD 100 );
    ivar2 := Day + ivar1 + ivar1 DIV 4;
    CASE Month OF
        4, 7    : ivar1 := 0;
        1, 10   : ivar1 := 1;
        5       : ivar1 := 2;
        8       : ivar1 := 3;
        2,3,11  : ivar1 := 4;
        6       : ivar1 := 5;
        9,12    : ivar1 := 6;
    END;
    ivar2 := ( ivar1 + ivar2 ) MOD 7;
    IF ( ivar2 = 0 ) THEN ivar2 := 7;
  END
  ELSE
    ivar2 := 0;
    Day_Of_Week := BYTE( ivar2 );
end;

function PRINTER_OK :boolean;

begin
  If (Port[$379]) And (16) <> 16 Then
     Printer_OK := False
  Else
     Printer_OK := True;
end;

function ERROR_MSG(ErrorCode :INTEGER):STRING;

begin
  case ErrorCode OF
          0: Error_Msg := 'No Error';
          2: Error_Msg := 'File Not Found';
          3: Error_Msg := 'Path Not Found';
          4: Error_Msg := 'Too Many Open Files';
          5: Error_Msg := 'File Access Denied';
          6: Error_Msg := 'Invalid File Handle';
         12: Error_Msg := 'Invalid File Access Code';
         15: Error_Msg := 'Invalid Drive Number';
         16: Error_Msg := 'Cannot Remove Current Directory';
         17: Error_Msg := 'Cannot Rename Across Drives';
         18: Error_Msg := 'File access error';
        100: Error_Msg := 'Disk Read Error';
        101: Error_Msg := 'Disk Write Error';
        102: Error_Msg := 'File Not Assigned';
        103: Error_Msg := 'File Not Open';
        104: Error_Msg := 'File Not Open For Input';
        105: Error_Msg := 'File Not Open For Output';
        106: Error_Msg := 'Invalid Numeric Format';
        150: Error_Msg := 'Disk Is Write-Protected';
        151: Error_Msg := 'Unknown Unit';
        152: Error_Msg := 'Drive Not Ready';
        153: Error_Msg := 'Unknown Command';
        154: Error_Msg := 'CRC Error In Data';
        155: Error_Msg := 'Bad Drive Request Structure Length';
        156: Error_Msg := 'Disk Seek Error';
        157: Error_Msg := 'Unknown Media Type';
        158: Error_Msg := 'Sector Not Found';
        159: Error_Msg := 'Printer Out Of Paper';
        160: Error_Msg := 'Device Write Fault';
        161: Error_Msg := 'Device Read Fault';
        162: Error_Msg := 'Hardware Failure';
  end;
end;

Procedure CAPSLOCK_ON;Assembler;
ASM
  SUB    AX,AX
  MOV    ES,AX
  MOV    AL,64
  OR     ES:[417h],AL
  RET
end;

Procedure CAPSLOCK_OFF;Assembler;
ASM
  SUB   AX,AX
  MOV   ES,AX
  MOV   AL,10111111b
  AND   ES:[417h],AL
  RET
end;

Procedure NUMLOCK_ON;Assembler;
ASM
  SUB    AX,AX
  MOV    ES,AX
  MOV    AL,32
  OR     ES:[417h],AL
  RET
end;

Procedure NUMLOCK_OFF;Assembler;
ASM
  SUB   AX,AX
  MOV   ES,AX
  MOV   AL,11011111b
  AND   ES:[417h],AL
  RET
end;

procedure CURSOR_OFF;

begin
  regs.ax :=$0100;regs.cx :=$2607;intr(16,regs);
end;

procedure CURSOR_ON;

begin
  regs.ax :=$0100;regs.cx :=$0506;intr(16,regs);
end;

Procedure FAST_WRITE(x,y :Word;MsgText :String;ColorAttr :Byte);
Assembler;
  Asm
    dec   x
    dec   y
    mov   ax,y
    mov   cl,5
    shl   ax,cl
    mov   di,ax
    mov   cl,2
    shl   ax,cl
    add   di,ax
    shl   x,1
    add   di,x
    mov   ax,0b800h     { 0b000h for mono }
    mov   es,ax
    xor   ch,ch
    push  ds
    lds   si,MsgText
    lodsb
    mov   cl,al
    mov   ah,ColorAttr
    jcxz  @@End
@@L1:
    lodsb
    stosw
    loop  @@L1
@@End:
    pop   ds
End;

procedure ABC(x,y :integer;tekens,color,soort :byte);

const
  lt :array[1..48,0..9] of byte =
                    { A }   ((28,62,119,99,99,127,127,99,99,99),
                    { B }   (124,126,102,102,124,127,99,99,127,126),
                    { C }   (30,63,99,96,96,96,96,99,63,30),
                    { D }   (124,126,103,99,99,99,99,103,126,124),
                    { E }   (127,127,96,96,124,124,96,96,127,127),
                    { F }   (127,127,96,96,124,124,96,96,96,96),
                    { G }   (62,127,96,96,96,103,103,99,127,62),
                    { H }   (99,99,99,99,127,127,99,99,99,99),
                    { I }   (126,126,24,24,24,24,24,24,126,126),
                    { J }   (127,127,3,3,3,3,99,103,127,62),
                    { K }   (97,99,103,110,124,120,124,110,103,99),
                    { L }   (96,96,96,96,96,96,96,96,127,127),
                    { M }   (99,119,127,127,107,99,99,99,99,99),
                    { N }   (99,115,115,123,123,111,111,103,103,99),
                    { O }   (62,127,99,99,99,99,99,99,127,62),
                    { P }   (124,126,103,99,103,126,124,96,96,96),
                    { Q }   (31,63,115,99,115,63,31,3,3,3),
                    { R }   (124,126,103,99,103,126,124,110,103,99),
                    { S }   (30,63,115,112,60,30,7,103,126,60),
                    { T }   (126,126,24,24,24,24,24,24,24,24),
                    { U }   (99,99,99,99,99,99,99,119,127,28),
                    { V }   (99,99,99,99,99,119,54,62,28,8),
                    { W }   (99,99,99,99,99,107,127,127,54,34),
                    { X }   (99,99,54,54,28,28,54,54,99,99),
                    { Y }   (99,99,99,99,99,119,62,28,28,28),
                    { Z }   (127,127,7,7,14,28,56,112,127,127),
               { spatie }   (0,0,0,0,0,0,0,0,0,0),
                    { 1 }   (12,28,60,12,12,12,12,12,63,63),
                    { 2 }   (62,127,103,7,14,28,56,112,127,127),
                    { 3 }   (60,126,103,7,30,30,7,103,126,60),
                    { 4 }   (14,28,56,112,96,102,127,127,6,6),
                    { 5 }   (127,127,96,96,126,127,3,99,127,62),
                    { 6 }   (62,127,96,96,126,127,99,99,127,62),
                    { 7 }   (127,127,7,7,14,28,56,112,96,96),
                    { 8 }   (62,127,99,99,62,62,99,99,127,62),
                    { 9 }   (62,127,99,99,127,63,3,3,127,62),
                    { 0 }   (28,62,99,99,99,99,99,99,62,28),
                    { . }   (0,0,0,0,0,0,0,0,24,24),
                    { , }   (0,0,0,0,0,0,0,24,24,48),
                    { - }   (0,0,0,0,63,63,0,0,0,0),
                    { + }   (0,0,12,12,63,63,12,12,0,0),
                    { ( }   (24,56,112,96,96,96,96,112,56,24),
                    { ) }   (12,14,7,3,3,3,3,7,14,12),
                    { / }   (7,6,14,12,28,24,56,48,112,96),
                    { \ }   (112,48,56,24,28,12,14,6,7,3),
                    { = }   (0,0,63,63,0,0,63,63,0,0),
                    { ? }   (62,127,103,7,14,28,28,0,28,28),
                    { % }   (103,102,14,12,28,24,56,48,115,99));

var
  getal         :integer;
  schuin,reg    :byte;

begin
  schuin :=5;
  for reg :=0 to 9 do begin
    getal :=lt[tekens,reg];

    if (soort =1) and (odd(reg)=true) then dec(schuin);
    if (soort =2) then inc(y);
    if (soort =3) and (odd(reg)=true) then begin
      dec(schuin);inc(y);
    end;

    if getal >63 then begin
      putpixel(x+schuin,y+reg,color);dec(getal,64);
    end;
    if getal >31 then begin
      putpixel(x+1+schuin,y+reg,color);dec(getal,32);
    end;
    if getal >15 then begin
      putpixel(x+2+schuin,y+reg,color);dec(getal,16);
    end;
    if getal >7  then begin
      putpixel(x+3+schuin,y+reg,color);dec(getal,8);
    end;
    if getal >3  then begin
      putpixel(x+4+schuin,y+reg,color);dec(getal,4);
    end;
    if getal >1  then begin
      putpixel(x+5+schuin,y+reg,color);dec(getal,2);
    end;
    if getal >0  then begin
      putpixel(x+6+schuin,y+reg,color);dec(getal,1);
    end;
  end;
end;

procedure DISPLAY(x,y :integer;text :string;back,color,size :byte);

const
  lijn :array[0..26] of string[5] =

        ('     ',     { 0}   '',     { 1}      ' ',     { 2}
         ' ',     { 3}   '  ',     { 4}      '  ',     { 5}
         '  ',     { 6}   '   ',     { 7}      '   ',     { 8}
         '   ',     { 9}   '   ',     {10}      '    ',     {11}
         '    ',     {12}   '    ',     {13}      '    ',     {14}
         '    ',     {15}   '   ',     {16}      '   ',     {17}
         '  ',     {18}   '  ',     {19}      ' ',     {20}
         '  ',     {21}   '   ',     {22}      '  ',     {23}
         '   ',     {24}   '   ',     {25}      '   ');    {26}

  letter :array[1..49,0..6] of byte =

    {A} ((5,16,16,1,16,16,16),           {B} (2,16,16,2,16,16,2),
    {C} (5,16,11,11,11,16,5),            {D} (2,16,16,16,16,16,2),
    {E} (1,11,11,4,11,11,1),             {F} (1,11,11,4,11,11,11),
    {G} (5,16,11,11,18,16,5),            {H} (16,16,16,1,16,16,16),
    {I} (5,13,13,13,13,13,5),            {J} (6,14,14,14,14,17,8),
    {K} (16,17,22,7,22,17,16),           {L} (11,11,11,11,11,11,1),
    {M} (16,20,21,16,16,16,16),          {N} (16,23,21,18,16,16,16),
    {O} (5,16,16,16,16,16,5),            {P} (2,16,16,2,11,11,11),
    {Q} (5,16,16,16,21,18,5),            {R} (2,16,16,2,22,17,16),
    {S} (5,16,11,5,15,16,5),             {T} (1,13,13,13,13,13,13),
    {U} (16,16,16,16,16,16,5),           {V} (16,16,16,16,24,24,13),
    {W} (16,16,16,16,21,24,24),          {X} (16,16,24,13,24,16,16),
    {Y} (16,16,16,24,13,13,13),          {Z} (1,15,14,13,12,11,1),
    { } (0,0,0,0,0,0,0),

    {1} (13,8,13,13,13,13,5),            {2} (5,16,14,13,12,11,1),
    {3} (5,16,15,14,15,16,5),            {4} (17,17,17,1,14,14,14),
    {5} (1,11,11,2,15,15,2),             {6} (5,16,11,2,16,16,5),
    {7} (1,16,15,14,13,12,12),           {8} (5,16,16,5,16,16,5),
    {9} (5,16,16,3,15,16,5),             {0} (5,16,16,16,16,16,5),

    {.} (0,0,0,0,0,8,8),                 {,} (0,0,0,0,0,14,13),
    {-} (0,0,0,5,0,0,0),                 {+} (0,13,13,1,13,13,0),
    {(} (13,12,11,11,11,12,13),          {)} (13,14,15,15,15,14,13),
    {/} (0,15,14,13,12,11,0),            {\} (0,11,12,13,14,15,0),
    {=} (0,0,5,0,5,0,0),                 {?} (5,16,16,14,13,13,13),
    {%} (7,23,14,13,12,18,10),           {:} (0,13,13,0,13,13,0));

var
  ver,hor,xx,q :integer;
  pal          :byte;
  s            :string;

begin
  if (size =0) or (size =1) or (size =2) then begin
    size :=size+3;
    for p :=1 to length(text) do text[p] :=upcase(text[p]);
    for p :=1 to length(text) do begin
      if size =3 then fill_bar(x-2,y-2,x+16,y+22,0,0);
      if size =4 then fill_bar(x-2,y-2,x+19,y+28,0,0);
      if size =5 then fill_bar(x-2,y-2,x+24,y+34,0,0);
      setcolor(8);
      for ver :=0 to 6 do for hor :=0 to 4 do begin
       { vul_vlak(x+(hor*gr)-1,y+(ver*gr)-1,x+3+(hor*gr),y+3+(ver*gr),0,0);}
        line(x+(hor*size),y+(ver*size),x+2+(hor*size),y+2+(ver*size));
      end;

      s :=copy(text,p,1);
      if s ='A' then pal :=1;
      if s ='B' then pal :=2;
      if s ='C' then pal :=3;
      if s ='D' then pal :=4;
      if s ='E' then pal :=5;
      if s ='F' then pal :=6;
      if s ='G' then pal :=7;
      if s ='H' then pal :=8;
      if s ='I' then pal :=9;
      if s ='J' then pal :=10;
      if s ='K' then pal :=11;
      if s ='L' then pal :=12;
      if s ='M' then pal :=13;
      if s ='N' then pal :=14;
      if s ='O' then pal :=15;
      if s ='P' then pal :=16;
      if s ='Q' then pal :=17;
      if s ='R' then pal :=18;
      if s ='S' then pal :=19;
      if s ='T' then pal :=20;
      if s ='U' then pal :=21;
      if s ='V' then pal :=22;
      if s ='W' then pal :=23;
      if s ='X' then pal :=24;
      if s ='Y' then pal :=25;
      if s ='Z' then pal :=26;

      if s =' ' then pal :=27;
      if s ='1' then pal :=28;
      if s ='2' then pal :=29;
      if s ='3' then pal :=30;
      if s ='4' then pal :=31;
      if s ='5' then pal :=32;
      if s ='6' then pal :=33;
      if s ='7' then pal :=34;
      if s ='8' then pal :=35;
      if s ='9' then pal :=36;
      if s ='0' then pal :=37;

      if s ='.' then pal :=38;
      if s =',' then pal :=39;
      if s ='-' then pal :=40;
      if s ='+' then pal :=41;
      if s ='(' then pal :=42;
      if s =')' then pal :=43;
      if s ='/' then pal :=44;
      if s ='\' then pal :=45;
      if s ='=' then pal :=46;
      if s ='?' then pal :=47;
      if s ='%' then pal :=48;
      if s =':' then pal :=49;

      for ver :=0 to 6 do begin
        xx :=x-2;
        for q :=1 to 5 do begin
          s :=copy(lijn[letter[pal,ver]],q,1);
          setcolor(back);outtextxy(xx-1,(y+(ver*size))-3,s);
          setcolor(color);outtextxy(xx,(y+(ver*size))-2,s);
          inc(xx,size);
        end;
      end;
      inc(x,(5*size)+3);
    end;
  end;
end;

{--------------- PALETTE PROCEDURES ------------------}

procedure WaitRetrace; assembler;

label
  l1, l2;
asm
    mov dx,3DAh
l1:
    in al,dx
    and al,08h
    jnz l1
l2:
    in al,dx
    and al,08h
    jz  l2
end;

Procedure GetPal(ColorNo : Byte; Var R,G,B : Byte);

Begin
   Port[$3c7] := ColorNo;
   R := Port[$3c9];
   G := Port[$3c9];
   B := Port[$3c9];
End;

Procedure SetPal(ColorNo : Byte; R,G,B : Byte);

Begin
   Port[$3c8] := ColorNo;
   Port[$3c9] := R;
   Port[$3c9] := G;
   Port[$3c9] := B;
End;

Procedure Fade_Down(speed :byte);

VAR loop1,loop2:integer;
    Tmp : Array [1..3] of byte;

BEGIN
  For loop1:=1 to 64 do BEGIN
    for p :=0 to speed do waitretrace;
    For loop2:=0 to 255 do BEGIN
      Getpal (loop2,Tmp[1],Tmp[2],Tmp[3]);
      If Tmp[1]>0 then dec (Tmp[1]);
      If Tmp[2]>0 then dec (Tmp[2]);
      If Tmp[3]>0 then dec (Tmp[3]);
      SetPal (loop2,Tmp[1],Tmp[2],Tmp[3]);
    END;
  END;
END;

procedure RESET_COLORS;

const
  org_kleur :array[0..15,1..4] of byte =

              (( 0, 0, 0, 0),     { 0 = zwart }
               ( 1, 0, 0,42),     { 1 = blauw }
               ( 2, 0,42, 0),     { 2 = groen }
               ( 3, 0,42,42),     { 3 = turkoois }
               ( 4,42, 0, 0),     { 4 = rood }
               ( 5,42, 0,42),     { 5 = paars }
               (20,42,21, 0),     { 6 = bruin }
               ( 7,42,42,42),     { 7 = lichtgrijs }
               (56,21,21,21),     { 8 = donkergrijs }
               (57,21,21,63),     { 9 = lichtblauw }
               (58,21,63,21),     {10 = lichtgroen }
               (59,21,63,63),     {11 = lichtturkoois }
               (60,63,21,21),     {12 = lichtrood }
               (61,63,21,63),     {13 = lichtpaars }
               (62,63,63,21),     {14 = geel }
               (63,63,63,63));    {15 = wit }

Procedure RGB(Color,wr,wg,wb : Byte);

begin
  Port[$3C8]:=Color;
  Port[$3C9]:=wr;
  Port[$3C9]:=wg;
  Port[$3C9]:=wb;
end;

begin
  for p :=0 to 15 do rgb(org_kleur[p,1],org_kleur[p,2],
                                org_kleur[p,3],org_kleur[p,4]);
end;

procedure SWAP_COLORS(col1,col2 :byte);

var
  r1,g1,b1,
  r2,g2,b2 :byte;

begin
  if (col1 in[0..15]) and (col2 in[0..15]) then begin
    getpal(col1,r1,g1,b1);
    getpal(col2,r2,g2,b2);
    setpal(col1,r2,g2,b2);
    setpal(col2,r1,g1,b1);
  end;
end;

procedure SCREEN_OFF;

var
  regs :registers;

begin
  regs.ah := $12;                    { 12 = vgahi 640 x 480 }
  regs.al := ord(1);                 { 0 = on, 1 = off }
  regs.bl := $36;                    { Subfunction }
  intr($10, regs);                   { Call BIOS }
end;

procedure SCREEN_ON;

var
  regs :registers;

begin
  regs.ah := $12;                    { 12 = vgahi 640 x 480 }
  regs.al := ord(0);                 { 0 = on, 1 = off }
  regs.bl := $36;                    { Subfunction }
  intr($10, regs);                   { Call BIOS }
end;

procedure SCREEN_BORDER(color: byte);

var
  regs :registers;

begin
  regs.ah:=$10;
  regs.al:=$01;
  regs.bh:=color;
  Intr(16,regs)
end;

procedure ROTATE_SCREEN(mx,my,mxx,myy :integer);

var
  mq   :array[0..479] of integer;
  nr   :integer;

begin
  if (mx <0) or (my <0) or (mxx >639) or (myy >479) then exit;
  sound(300);wait(10);nosound;
  for x :=mx to mxx do begin
    nr :=0;
    for y :=my to myy do begin mq[nr] :=getpixel(x,y);inc(nr);end;
    nr :=0;
    for y :=myy downto my do begin putpixel(x,y,mq[nr]);inc(nr);end;
  end;
  sound(500);wait(10);nosound;
end;

procedure MIRROR_SCREEN(mx,my,mxx,myy :integer);

var
  mq   :array[0..639] of integer;
  nr   :integer;

begin
  if (mx <0) or (my <0) or (mxx >639) or (myy >479) then exit;
  sound(300);wait(10);nosound;
  for y :=my to myy do begin
    nr :=0;
    for x :=mx to mxx do begin mq[nr] :=getpixel(x,y);inc(nr);end;
    nr :=0;
    for x :=mxx downto mx do begin putpixel(x,y,mq[nr]);inc(nr);end;
  end;
  sound(500);wait(10);nosound;
end;

procedure SCREEN_TO_BLACK(style,delay :byte);

var
  pal   :boolean;
  q     :word;
  kleur :byte;

begin
  setcolor(0);
  case style of
   1:begin
       q :=0;for y :=479 downto 0 do begin
         for x :=639 downto 0 do begin
           pal :=odd(q);if pal =true then putpixel(x,y,0);inc(q);
         end;
         wait(delay);
       end;
       q :=1;for y :=0 to 479 do begin
         for x :=0 to 639 do begin
           pal :=odd(q);if pal =false then putpixel(x,y,0);inc(q);
         end;
         wait(delay);
       end;
     end;
   2:begin
       q :=0;for x :=639 downto 0 do begin
         for y :=479 downto 0 do begin
           pal :=odd(q);if pal =true then putpixel(x,y,0);inc(q);
         end;
         wait(delay);
       end;
       q :=1;for x :=0 to 639 do begin
         for y :=0 to 479 do begin
           pal :=odd(q);if pal =false then putpixel(x,y,0);inc(q);
         end;
         wait(delay);
       end;
     end;
   3:begin
       for y :=0 to 479 do begin
         line(0,0,639,y);line(639,479,0,479-y);wait(delay);
       end;
     end;
   4:begin
       for y :=0 to 479 do begin
         line(319,0,0,y);line(320,0,639,y);wait(delay);
       end;
       for x :=0 to 319 do begin
         line(319,0,x,479);line(320,0,639-x,479);wait(delay);
       end;
     end;
   5:begin
       for y :=0 to 479 do begin
         if odd(y) =true then line(0,0,639,y)
           else line(639,479,0,479-y);
         wait(delay);
       end;
       for x :=0 to 639 do begin
         line(0,0,639-x,479);line(639,479,x,0);wait(delay);
       end;
     end;
   6:begin
       x :=319;y :=239;xx :=321;yy :=241;
       for p :=1 to 319 do begin
         fill_bar(x,y,xx,yy,0,0);dec(x);dec(y);inc(xx);inc(yy);wait(delay);
       end;
     end;
   7:begin
       x :=319;y :=239;xx :=0;setfillstyle(0,0);
       for p :=1 to 80 do begin
         fillellipse(x,y,xx,xx);inc(xx,5);wait(delay);
       end;
     end;
   8:begin
       x :=0;y :=0;xx :=639;yy :=479;
       for p :=1 to 240 do begin
         rectangle(x,y,xx,yy);inc(x);inc(y);dec(xx);dec(yy);
         wait(delay);
       end;
     end;
   9:begin
       for x :=0 to 639 do begin
         for y :=0 to 479 do begin
           if odd(y) =true then putpixel(x,y,0)
             else putpixel(639-x,y,0);
         end;
         wait(delay);
       end;
     end;
  10:begin
       x :=0;y :=0;xx :=639;yy :=479;
       for x :=0 to 319 do begin
         line(319,239,x,0);line(320,239,639-x,0);
         line(320,240,639-x,479);line(319,240,x,479);wait(delay);
       end;
       for y :=0 to 239 do begin
         line(319,239,0,y);line(320,239,639,y);
         line(320,240,639,479-y);line(319,240,0,479-y);wait(delay);
       end;
     end;
  11:begin
       x :=0;y :=0;
       for p :=1 to 320 do begin
         rectangle(0,0,x,y);rectangle(639,0,639-x,y);
         rectangle(0,479,x,479-y);rectangle(639,479,639-x,479-y);
         wait(delay);inc(x);inc(y);
       end;
     end;
  12:begin
       for x :=0 to 639 do begin
         line(x,0,x,79);line(639-x,80,639-x,159);
         line(x,160,x,239);line(639-x,240,639-x,319);
         line(x,320,x,399);line(639-x,400,639-x,479);wait(delay);
       end;
     end;
  13:begin
       for x :=0 to 639 do if odd(x) =true then begin
         line(320,240,x,0);wait(delay);end;
       for y :=0 to 479 do if odd(y) =true then begin
         line(320,240,639,y);wait(delay);end;
       for x :=639 downto 0 do if odd(x) =true then begin
         line(320,240,x,479);wait(delay);end;
       for y :=479 downto 0 do if odd(y) =true then begin
         line(320,240,0,y);wait(delay);end;
       x :=0;y :=0;
       for p :=0 to 200 do begin
         rectangle(x,y,639-x,479-y);inc(x);inc(y);wait(delay);
       end;
     end;
  14:begin
       q :=0;
       for pp :=1 to 2 do begin
         for p :=0 to 319 do if odd(p+q) =true then begin
           line(159,119,p,0);line(479,119,p+320,0);
           line(159,359,p,240);line(479,359,p+320,240);
           wait(delay);
         end;
         for p :=0 to 239 do if odd(p+q) =true then begin
           line(159,119,319,p);line(479,119,639,p);
           line(159,359,319,p+240);line(479,359,639,p+240);
           wait(delay);
         end;
         for p :=319 downto 0 do if odd(p+q) =true then begin
           line(159,119,p,239);line(479,119,p+320,239);
           line(159,359,p,479);line(479,359,p+320,479);
           wait(delay);
         end;
         for p :=239 downto 0 do if odd(p+q) =true then begin
           line(159,119,0,p);line(479,119,320,p);
           line(159,359,0,p+240);line(479,359,320,p+240);
           wait(delay);
         end;q :=1;
       end;
     end;
  15:begin
       q :=0;
       for pp :=1 to 2 do begin
         for y :=0 to 239 do if odd(y+q) =true then begin
           line(0,0,319,y);line(320,0,639,y);
           line(0,240,319,y+240);line(320,240,639,y+240);
           line(319,239,0,239-y);line(639,239,320,239-y);
           line(319,479,0,479-y);line(639,479,320,479-y);
           wait(delay);
         end;q :=1;
       end;
     end;
  end;
end;

procedure DEL_FILE(filename :string);

var
  f :file;

begin
  assign(f,filename);
  {$I-} reset(f); {$I+}
  if ioresult =0 then begin
    close(f);
    erase(f);
  end;
end;

function EXIST_FILE(FileName : string) : boolean;

var
  sr : SearchRec;

begin
  FindFirst(FileName, AnyFile, sr);
  Exist_File := (DosError = 0);
end;

function EXIST_DIR(dir:string):boolean;

var
  AktDir :string;

begin
  IF Dir[Length(Dir)]='\' THEN Delete(Dir,Length(dir),1);
  GetDir(0,AktDir);
  {$I-} ChDir(Dir); {$I+}
  Exist_Dir:=(IoResult=0);
  ChDir(AktDir);
end;

procedure Get_File_Attr(fn:string;var Attr:word);

var
  Reg : Registers;

begin
  fn:=fn+#0;
  Reg.AX:=$4300;
  Reg.DS:=Seg(fn[1]);
  Reg.DX:=Ofs(fn[1]);
  Intr($21,Reg);
  Attr:=Reg.CX;
  IF Odd(Reg.Flags) THEN
    DosError:=Reg.AX
  else
    DosError:=WORD(0);
end;

procedure Set_File_Attr(fn :string;Attr:word);

var
  Reg : Registers;

begin
  fn:=fn+#0;
  Reg.AX:=$4301;
  Reg.CX:=Attr;
  Reg.DS:=Seg(fn[1]);
  Reg.DX:=Ofs(fn[1]);
  Intr($21,Reg);
  IF Odd(Reg.Flags) THEN
    DosError:=Reg.AX
  else
    DosError:=WORD(0);
end;

procedure Get_File_Size(FName :string;var Fsize :longint;var Error :word);

var
  SR    : SearchRec;

begin
  {$I-}
  FindFirst(FName,Archive,SR);
  Error := DosError;
  {$I+}
  if Error = 0 then
    FSize := SR.Size
  else
    FSize := 0;
end;

function  FIND_STRING(filename,search :string) :word;

var
  f      :text;
  s,ss   :string;
  teller :word;

begin
  teller :=0;
  assign(f,filename);
  {$I-} reset(f); {$I+}
  if ioresult =0 then begin
    repeat
      readln(f,s);
      p :=pos(search,s);
      if p <>0 then inc(teller);
    until eof(f);
    close(f);
    find_string :=teller;
    exit;
  end;
  sound(500);wait(100);sound(600);wait(100);nosound;
end;

{----------------------------------------------------------}

Procedure SAVE_IMAGE(X1,Y1,X2,Y2 :Integer;FileNaam :String);

Var
   F            : File;
   PointImage   : Pointer;
   Size         : Word;

Begin
  Assign(F, FileNaam);
  Size := ImageSize(X1, Y1, X2, Y2);
  ReWrite(F, Size);
  GetMem(PointImage, Size);
  GetImage(X1, Y1, X2, Y2, PointImage^);
  BlockWrite(F, PointImage^, 1);
  FreeMem(PointImage, Size);
  Close(F);
End;

Procedure LOAD_IMAGE(X1,Y1 :Integer;FileNaam :String);

Var
   F            : File;
   PointImage   : Pointer;
   Size         : Word;

Begin
  Assign(f, FileNaam);
  {$I-} Reset(F, 1); {$I+}
  if ioresult =0 then begin
    Size := filesize(f);
    GetMem(PointImage, Size);
    BlockRead(F, PointImage^,size);
    PutImage(X1,Y1, PointImage^, CopyPut);
    FreeMem(PointImage, Size);
    Close(F);
  end;
end;

procedure SAVE_SCREEN(filename :string);

var
  s1   :word;
  s3   :longint;
  icon :pointer;
  f    :file;

begin
  s3 :=0;x :=0;
  for p :=1 to 4 do begin
    s1 :=imagesize(0,x,639,x+119);
    getmem(icon,s1);
    assign(f,filename);
    {$I-} reset(f,1); {$I+}
    if ioresult <>0 then rewrite(f,1);
    seek(f,s3);
    getimage(0,x,639,x+119,icon^);
    blockwrite(f,icon^,s1);
    close(f);
    freemem(icon,s1);
    inc(s3,38406);
    inc(x,120);
  end;
end;

procedure LOAD_SCREEN(filename :string);

var
  s1   :word;
  s3   :longint;
  icon :pointer;
  f    :file;

begin
  s3 :=0;x :=0;
  for p :=1 to 4 do begin
    assign(f,filename);
    {$I-} reset(f,1); {$I+}
    if ioresult <>0 then begin
      sound(500);delay(500);nosound;
      exit;
    end;
    seek(f,s3);
    s1 :=38406;
    getmem(icon,s1);
    blockread(f,icon^,s1);
    close(f);
    putimage(0,x,icon^,0);
    freemem(icon,s1);
    inc(s3,38406);
    inc(x,120);
  end;
end;

procedure SAVE_ICON(x,y :integer;filenaam :string);

const
  iconkop :array[1..126] of byte =
          (0,0,1,0,1,0,32,32,16,0,0,0,0,0,232,2,0,0,22,0,0,
           0,40,0,0,0,32,0,0,0,64,0,0,0,1,0,4,0,0,0,0,0,
           128,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    { 0}   0,0,0,0,
    { 1}   170,0,0,0,  
    { 2}   0,170,0,0,
    { 3}   170,170,0,0,
    { 4}   0,0,170,0,              { 0 t/m 15 are the 16 colours }
    { 5}   170,0,170,0,
    { 6}   0,85,170,0,
    { 7}   170,170,170,0,
    { 8}   85,85,85,0,
    { 9}   255,0,0,0,
    {10}   0,255,0,0,
    {11}   255,255,0,0,
    {12}   0,0,255,0,
    {13}   255,0,255,0,
    {14}   0,255,255,0,
    {15}   255,255,255,0);

var
  f        :file;
  r,rr,pal   :byte;
  p,xx,yy    :integer;

begin
  assign(f,filenaam);
  rewrite(f,1);
  for p :=1 to 126 do blockwrite(f,iconkop[p],1);
  for yy :=y+31 downto y do begin
    for xx :=x to x+31 do begin
      r :=getpixel(xx,yy);
      rr :=getpixel(xx+1,yy);
      pal :=(r*16)+rr;
      blockwrite(f,pal,1);
      inc(xx);
    end;
  end;
  xx :=0;
  for p :=1 to 128 do blockwrite(f,xx,1);
  close(f);
end;

procedure LOAD_ICON(xx,yy :integer;filename :string);

var
  r,rr :byte;
  f    :text;
  ch   :char;

begin
  x :=xx;y :=yy;
  assign(f,filename);
  {$I-} reset(f); {$I+}
  if ioresult =0 then begin
    for p :=1 to 766 do begin
      read(f,ch);q :=ord(ch);
      if (p >126) and (p <639) then begin
        r :=q shr 4;rr :=q-r div 16;
        putpixel(x,y,r);putpixel(x+1,y,rr);
        inc(x,2);
        if x =xx+32 then begin
          x :=xx;dec(y);
        end;
      end;
    end;
    close(f);
  end;
end;

{************************ SAVE PCX ***************************}

procedure get_rgb(color : integer; var r,g,b : integer);

begin
  r:=(((color and $20) shr 5) or ((color and $04) shr 1))*84;
  g:=(((color and $10) shr 4) or ((color and $02)      ))*84;
  b:=(((color and $08) shr 3) or ((color and $01) shl 1))*84;
end;

procedure SAVE_PCX(filename :string);

type header_rec =
         record
           pcx_id  : byte;     { 0) 0x0a = ZSoft .PCX file          }
           pcx_ver : byte;     { 1) 0x05 = PC PaintBrush 3.0        }
           encode  : byte;     { 2) 0x01 = RLE                      }
           bpp     : byte;     { 3) 0x01 = bits/pixel why VGA16=1?  }
           left    : word;     { 4-5) Window Left                   }
           top     : word;     { 6-7) Window Top                    }
           right   : word;     { 8-9) Window Right                  }
           bott    : word;     { 10-11) Window Bottom               }
           xres    : word;     { 12-13) Horizontal resolution       }
           yres    : word;     { 14-15) Vertical resolution         }
           rgb     : array[0..15,1..3] of byte;    { (R-G-B) values }
           resv    : byte;     { 64) Reserved                       }
           bplanes : byte;     { 65) Number of bit planes, VGA16=4  }
           bpl     : word;     { 66-67) # of bytes/line, VGA16=80   }
           ptype   : word;     { 68-69) palette type, color=1       }
           unused  : array[70..127] of byte;
         end;

const BUFSIZE = 256;

var
  header : header_rec;
  pal    : palettetype;
  r,g,b  : integer;
  i,y,j  : integer;
  f      : file;
  data   : array[0..319] of byte;
  buf    : array[1..BUFSIZE] of byte;
  bi     : integer;
  dta    : byte;
  index  : integer;
  count  : integer;

label done;

procedure flushit;

begin
  blockwrite(f,buf,bi);
  bi:=0;
end;

procedure get_bitplane_info_at_scan_line(plane,scanline :word;var address);

begin
  asm
    cld
    mov   bx,ds
    mov   ax,0a000h
    mov   ds,ax
    mov   ax,80
    mul   scanline
    mov   si,ax
    mov   dx,03ceh
    mov   ax,0005h
    out   dx,ax
    mov   ax,plane
    mov   ah,al
    mov   al,04h
    out   dx,ax
    mov   cx,40         { 40 words = 80 bytes = 1 scan line }
    les   di,address
    rep   movsw
    mov   ax,1005h
    out   dx,ax
    mov   ax,0004h
    out   dx,ax
    mov   ds,bx
  end;
end;

begin
  if filename ='' then exit;
  fillchar(header,sizeof(header),#0);
  with header do
  begin
    pcx_id  := $0A;
    pcx_ver := $05;
    encode  := $01;
    bpp     := $01;
    left    := 0;
    top     := 0;
    right   := 639;
    bott    := 479;
    xres    := 640;
    yres    := 480;
    getpalette(pal);
    for i:=0 to 15 do
    begin
      get_rgb(pal.colors[i],r,g,b);
      rgb[i,1]:=r;  rgb[i,2]:=g;  rgb[i,3]:=b;
    end;
    bplanes :=  4;
    bpl     :=  80;   { bytes per line }
    ptype   :=  1;
  end;

  assign(f,filename);
  {$i-} rewrite(f,1); {$i+}
  if ioresult<>0 then
  begin
    sound(200); delay(2000); nosound;
    sound(50); delay(2000); nosound;
    exit;
  end;
  blockwrite(f,header,sizeof(header));
  bi:=0;      { buffer index }
  for y:=0 to 479 do
  begin
    get_bitplane_info_at_scan_line(0,y,data[0]);
    get_bitplane_info_at_scan_line(1,y,data[80]);
    get_bitplane_info_at_scan_line(2,y,data[160]);
    get_bitplane_info_at_scan_line(3,y,data[240]);
    index:=0;
    repeat
      count:=0;
      dta:=data[index];
      repeat
        inc(index); inc(count);
        if count>$3F then
        begin
          if bi=BUFSIZE then flushit; inc(bi); buf[bi]:=$FF;
          if bi=BUFSIZE then flushit; inc(bi); buf[bi]:=dta;
          count:=1;
        end;
      until (index>319) or (data[index]<>dta);
      done:
      if count>1 then
      begin
        if bi=BUFSIZE then flushit; inc(bi); buf[bi]:=$C0 or count;
        if bi=BUFSIZE then flushit; inc(bi); buf[bi]:=dta;
      end
      else
      begin
        if (dta and $C0)=$C0 then
        begin
          if bi=BUFSIZE then flushit; inc(bi); buf[bi]:=$C1;
          if bi=BUFSIZE then flushit; inc(bi); buf[bi]:=dta;
        end
        else
        begin
          if bi=BUFSIZE then flushit; inc(bi); buf[bi]:=dta;
        end;
      end;
    until index=320;
  end;
  if bi>0 then flushit;
  close(f);
end;

{*************************** LOAD PCX *************************}

procedure LOAD_PCX (filename: string);

const
   max_width    = 4000;
   compress_num = $C0;
   max_block    = 4096;
   red          = 0;
   green        = 1;
   blue         = 2;

type
   file_buffer = array [0..127] of byte;
   block_array = array [0..MAX_BLOCK] of byte;
   pal_array   = array [0..255, RED..BLUE] of byte;
   ega_array   = array [0..16] of byte;
   line_array  = array [0..MAX_WIDTH] of byte;

   pcx_header = record

      Manufacturer   : byte;
      Version        : byte;
      Encoding       : byte;
      Bits_per_pixel : byte;
      Xmin           : integer;
      Ymin           : integer;
      Xmax           : integer;
      Ymax           : integer;
      Hdpi           : integer;
      Vdpi           : integer;
      ColorMap       : array [0..15, RED..BLUE] of byte;
      Reserved       : byte;
      Nplanes        : byte;
      Bytes_per_line : integer;
      PaletteInfo    : integer;
      HscreenSize    : integer;
      VscreenSize    : integer;
      Filler         : array [74..127] of byte;
  end;

var
  f            :file;              { file for reading block data }
  BlockData    :block_array;       { 4k data buffer }
  Header       :pcx_header;        { PCX file header }
  Palette256   :pal_array;         { place to put 256 color palette }
  PaletteEGA   :ega_array;         { place to put 17 EGA palette values }
  PCXline      :line_array;        { place to put uncompressed data }
  Ymax         :integer;           { maximum Y value on screen }
  NextByte     :integer;           { index into file buffer in ReadByte }
  Index        :integer;           { PCXline index - where to put Data }
  Data         :byte;              { PCX compressed data byte }
  PictureMode  :integer;           { Graphics mode number }
  Reg          :Registers;         { Register set - used for int 10 calls }
  k,kmax       :integer;

procedure ShowEGA (Y: integer);

var
  i,j,l,m,t :integer;
  EGAplane  :integer;
  EGAscreen :array [0..32000] of byte absolute $A000:$0000;

begin
  EGAplane := $0100;
  PortW [$3CE] := $0005;
  t := (Header.Xmax - Header.Xmin + 1);
  m := t and 7;
  l := (t + 7) shr 3;
  if (l >= 80) then begin
    l := 80;
    m := 0;
  end;
  if (m <> 0) then m := $FF shl (8 - m)
    else m := $FF;
  for i := 0 to Header.Nplanes-1 do
  begin
    j := i * Header.Bytes_per_line;
    t := j + l - 1;
    PCXline [t] := PCXline [t] and m;
    PortW [$3C4] := EGAplane + 2;
    Move (PCXline [j], EGAscreen [Y * 80], l);
    EGAplane := EGAplane shl 1;
  end;
  PortW [$3C4] := $0F02;
end;

procedure VGA16palette;

var
  i :integer;

begin
  for i := 0 to 15 do PaletteEGA [i] := i;
  PaletteEGA [16] := 0;                { border color }
  Reg.ah := $10;                       { Set Palette Call }
  Reg.al := $02;                       { set a block of palette registers }
  Reg.dx := ofs (PaletteEGA);          { offset of block }
  Reg.es := seg (PaletteEGA);          { segment of block }
  intr ($10, Reg);                     { call interrupt }
  for i := 0 to 15 do begin                                          { R, G, and B must be 0..63 }
    Palette256 [i, RED]   := Header.ColorMap [i, RED]   shr 2;
    Palette256 [i, GREEN] := Header.ColorMap [i, GREEN] shr 2;
    Palette256 [i, BLUE]  := Header.ColorMap [i, BLUE]  shr 2;
  end;
  Reg.ah := $10;                       { Set DAC Call }
  Reg.al := $12;                       { set a block of DAC registers }
  Reg.bx := 0;                         { first DAC register number }
  Reg.cx := 255;                       { number of registers to update }
  Reg.dx := ofs (Palette256);          { offset of block }
  Reg.es := seg (Palette256);          { segment of block }
  intr ($10, Reg);                     { call interrupt }
end;

procedure ReadHeader;

begin
  BlockRead (f, Header, 128);
  if (Header.Manufacturer <> 10) or (Header.Encoding <> 1) then close(f);
  if (Header.Nplanes = 4) and (Header.Bits_per_pixel = 1) then begin
    PictureMode := VGA;
    Ymax := 479;
  end;
  Index    := 0;
  NextByte := MAX_BLOCK;
end;

procedure ReadByte;

var
   NumBlocksRead: integer;

begin
  if NextByte = MAX_BLOCK then begin
    BlockRead (f, BlockData, MAX_BLOCK, NumBlocksRead);
    NextByte := 0;
  end;
  data := BlockData [NextByte];
  inc (NextByte);
end;

procedure Read_PCX_Line;

var
  count: integer;
  bytes_per_line: integer;

begin
  bytes_per_line := Header.Bytes_per_line * Header.Nplanes;
  if Index <> 0 then FillChar (PCXline [0], Index, data);
  while (Index < bytes_per_line) do begin
    ReadByte;
    if (data and $C0) = compress_num then begin
      count := data and $3F;
      ReadByte;
      FillChar (PCXline [Index], count, data);
      inc (Index, count);
    end
    else begin
      PCXline [Index] := data;
      inc (Index);
    end;
  end;
  Index := Index - bytes_per_line;
end;

label naar_einde;

begin
  assign (f, filename);
  {$I-} reset(f,1); {$I+}
  if ioresult =0 then begin
    ReadHeader;
    if Header.Bits_per_pixel <> 1 then goto naar_einde; { ALS HET EEN 256 }
    if Header.Version = 5 then vga16Palette;         { KLEUREN PLAATJE IS }
    kmax := Header.Ymin + Ymax;
    if Header.Ymax < kmax then kmax :=Header.ymax;
    if PictureMode =VGA then for k :=Header.Ymin to kmax do begin
      Read_PCX_Line;
      ShowEGA (k);
    end;
    close (f);
  end
  else begin
    naar_einde:
    sound(500);wait(50);sound(700);wait(50);nosound;
  end;
end;

{************************ SAVE BMP *******************************}

procedure SAVE_BMP(filename :string);

const
  bmphead :array[1..118] of byte =

  { BM } (66,77,
          118,
          8,
          0,
          0,0,0,0,0,
          118,0,0,0,40,
          0,0,0,
  { br }  128,2,         { (2x256)+128 = 640 pixels }
          0,0,
  { ho }  223,1,         { (1x256)+150 = 406 pixels }
          0,0,1,0,4,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   { 0}   0,0,0,0,
   { 1}   170,0,0,0,
   { 2}   0,170,0,0,
   { 3}   170,170,0,0,
   { 4}   0,0,170,0,           { dit zijn de 16 kleuren(colors) }
   { 5}   170,0,170,0,         { die gelden voor de standaard }
   { 6}   0,85,170,0,          { pascal vga scherm }
   { 7}   170,170,170,0,
   { 8}   85,85,85,0,
   { 9}   255,0,0,0,
   {10}   0,255,0,0,
   {11}   255,255,0,0,
   {12}   0,0,255,0,
   {13}   255,0,255,0,
   {14}   0,255,255,0,
   {15}   255,255,255,0);

var
  f          :file;
  x,y,p,xx   :integer;
  r,rr,pal   :byte;

begin
  assign(f,filename);
  rewrite(f,1);
  for p :=1 to 118 do blockwrite(f,bmphead[p],1);
  for y :=479 downto 0 do begin
    for x :=0 to 639 do begin
      r :=getpixel(x,y);
      rr :=getpixel(x+1,y);
      pal :=(r*16)+rr;
      blockwrite(f,pal,1);
      inc(x);
    end;
  end;
  close(f);
end;

Procedure LOAD_BMP(FileName: String);

Type
 TBitMapHeader =
  Record
   bfType :             Word;
   bfSize :             LongInt;
   bfReserved :         LongInt;     {Moet 0 zijn}
   bfOffBits :          LongInt;
   biSize :             LongInt;
   biWidth :            LongInt;
   biHeight :           LongInt;
   biPlanes :           Word;        {Moet 1 zijn}
   biBitCount :         Word;        {1,4,8,24}
   biCompression :      LongInt;
   biSizeImage :        LongInt;     {in bytes}
   biXPelsPerMeter :    LongInt;
   biYPelsPerMeter :    LongInt;
   biClrUsed :          LongInt;
   biClrImportant :     LongInt;
  End;

  TRGBQuad = Record
    rgbBlue,
    rgbGreen,
    rgbRed,
    rgbReserved : Byte;
  End;

  TByteArray = Array[0..50000] of byte;

Var
  f            : File;
  BitMapHeader : TBitMapHeader;


Procedure Display4 (Var f : File; BitMapHeader : TBitMapHeader);

Var
  i,j      : Integer;
  RGBQuad  : TRGBQuad;
  TwoPixel : Byte;
  Black    : Byte;
  Line     : ^TByteArray;
  number   : Word;
  BeginX,
  BeginY,
  EindY    : Integer;
  CurrentX : Integer;

Begin
  Black := 16;
  With BitMapHeader do begin
    For i:= 0 to 15 do Begin
      BlockRead(f,RGBQuad,SizeOf(RGBQuad));
      If (LongInt(RGBQuad)=0) then Black := i;
      With RGBQuad do
        SetRGBPalette(i, rgbRed shr 2, rgbGreen shr 2, rgbBlue shr 2);
      SetPalette(i,i);
    End;

    Number := (biWidth div 2 + 3) and not 3;
    BeginX := (GetMaxX - biWidth) div 2;
    BeginY := GetMaxY - (GetMaxY - biHeight) div 2;
    EindY := BeginY+1-biHeight;
  End;

  GetMem (Line,number+1);
  For j:=BeginY downto EindY do Begin
    BlockRead(f,Line^[1],number);
    CurrentX := BeginX;
    For i:=1 to number do Begin
      TwoPixel := Line^[i];
      If TwoPixel shr 4 <> Black then PutPixel(CurrentX,j,TwoPixel shr 4);
      Inc(CurrentX);
      If TwoPixel and 15 <> Black then PutPixel(CurrentX,j,TwoPixel and 15);
      Inc(CurrentX);
    end;
  end;
  FreeMem (Line,number+1);
end;

Begin
  Assign(f,FileName);
  {$I-} Reset(f,1); {$I+}
  If ioresult <>0 Then Begin
    sound(500);wait(50);sound(700);wait(50);nosound;
    Exit;
  End;

  BlockRead(f,BitMapHeader,SizeOf(BitMapHeader));
  With BitMapHeader do
  Begin
    If (bfType<>19778) or (bfReserved<>0) or (biPlanes<>1) then Begin
      sound(500);wait(50);sound(700);wait(50);nosound;
      Close(f);
      Exit;
    End;
    If biCompression<>0 Then Begin
      sound(500);wait(50);sound(700);wait(50);nosound;
      Close(f);
      Exit;
    End;
    ClearDevice;
    Display4(f,BitMapHeader);
  End;
  Close(f);
End; { end of load_bmp }

procedure DUMP_LASER;

Const d = 'l';

Var
  MaxX, MaxY     : Integer;
  ymax,bbyt,b2   : Byte;
  psf            : File of Byte;
  regs           : Registers;
  b,reg,kol      : Word;

Procedure out(ch : Char);

begin
  regs.ax := ord(ch);
  regs.dx := 0;
  intr($17, regs);
end;

begin
  MaxX := 640;
  MaxY := 480;
  assign(psf, 'lpt1');
  reWrite(psf);
  Write(lst, chr(27), 'E');
  Write(lst, chr(27), '*t100R', chr(27), '*r0A');
  For reg := 0 to maxx do begin
    Write(lst, chr(27), '*b', (maxy + 1) div 8, 'W');
    For kol := ((maxy + 1) div 8) - 1 downto 0 do begin
      bbyt := 0;
      For b := 0 to 7 do begin
        if getpixel(reg, kol * 8 + b) in[0] then    { 0 = zwart }
          b2 := 0
        else
          b2 := 1;
        bbyt := bbyt or (b2 shl b);
      end;
      out(chr(bbyt));
    end;
  end;
  Write(lst, chr(27), '*rB');
  Write(lst, chr(12));
  Write(lst, chr(27), 'E');
  close(psf);
end;

procedure DUMP_MATRIX;

{ print alle kleuren in grijswaarden behalve zwart }

const
  maxprinter = 816;
  maxx       = 640;
  maxy       = 480;

var
  graphwidth,graphheight,printerwidth,printerheight: integer;
  n1,n2,sx,sy,x,y,y2,pixcolr: integer;
  widthratio,heightratio: real;
  blank: boolean;
  bitloc,bits: byte;
  bytes: array [1..maxprinter] of byte;
  lst: text;

begin
  assign(lst,'lpt1');
  rewrite(lst);

  graphwidth:= getmaxy+1;
  graphheight:= getmaxx+1;
  printerwidth:= graphwidth;
  printerheight:= graphheight;

  n2:= printerwidth div 256;
  n1:= printerwidth mod 256;
  write (lst,chr(27),'A',chr(8));
  widthratio:= printerwidth/graphwidth;
  heightratio:= printerheight/graphheight;
  y:= 0;
  while y < printerheight do begin
    blank:= true;
    for x:= 1 to printerwidth do begin
      sx:= trunc ((x-1)/widthratio);
      bits:= 0;
      bitloc:= $80;
      for y2:= y to y+7 do begin
        sy:= trunc(y2/heightratio);
        if sy < graphheight then begin
          pixcolr:= getpixel (sy,sx);
          if pixcolr in[1..15] then bits:= bits or bitloc;  { colors 1..15 }
        end;
        bitloc:= bitloc shr 1;
      end;
      bytes [printerwidth-x+1]:= bits;
      if bits > 0 then blank:= false;
    end;
    if not blank then begin
      write (lst,chr(27),'K',chr(n1),chr(n2));
      for x:= 1 to printerwidth do write (lst,chr(bytes[x]));
    end;
    writeln (lst);
    y:= y+8;
  end;
  write (lst,chr(12));
  write (lst,chr(27),'@');
  close(lst);
end;

{-------------------------------------------------------}

procedure vgadriver;external;

{$L egavga.obj }

procedure VIDEO_ON;

var
  x,y,resultaat :integer;

begin
  resultaat :=registerbgidriver(@vgadriver);
  x :=vga;y :=vgahi;initgraph(x,y,'resultaat');
end;

{ ******** DE VOLGENDE PROCEDURE ALLEEN VOOR MIJN NAAM ******** }

Procedure loadChar;

Type
  ByteArray  = Array[0..15] of Byte;
  CharArray  = Array[1..29] of Record
    CharNum  : Byte;
    CharData : ByteArray;
  end;

Const newChars : CharArray =

      ((CharNum : 218;CharData :
      (0,0,7,15,28,56,48,48,48,48,48,48,48,48,48,48)),           {}
      (CharNum : 194;CharData:
      (0,0,255,255,0,0,0,0,0,0,0,0,0,0,0,0)),                    {}
      (CharNum : 191;CharData:
      (0,0,224,240,56,28,12,12,12,12,12,12,12,12,12,12)),        {}
      (CharNum : 195;CharData:
      (48,48,48,48,48,48,48,48,48,48,48,48,48,48,48,48)),        {}
      (CharNum : 180;CharData:
      (12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12)),        {}
      (CharNum : 192;CharData:
      (48,48,48,48,48,48,48,48,48,48,56,28,15,7,0,0)),           {}
      (CharNum : 193;CharData:
      (0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0)),                    {}
      (CharNum : 217;CharData:
      (12,12,12,12,12,12,12,12,12,12,28,56,240,224,0,0)),        {}

  {J} (CharNum : 210;CharData :
      ($1E,$1E,$0C,$0C,$0C,$0C,$0C,$0C,$CC,$CC,$CC,$CC,$78,$78,$00,$00)),
  {O} (Charnum : 190;CharData :
      ($38,$38,$6C,$6C,$C6,$C6,$C6,$C6,$C6,$C6,$6C,$6C,$38,$38,$00,$00)),
  {S} (Charnum : 141;CharData :
      ($7C,$7C,$C6,$C6,$E0,$E0,$78,$78,$0E,$0E,$C6,$C6,$7C,$7C,$00,$00)),
  {D} (Charnum : 159;CharData :
      ($F8,$F8,$6C,$6C,$66,$66,$66,$66,$66,$66,$6C,$6C,$F8,$F8,$00,$00)),
  {I} (Charnum : 241;CharData :
      ($78,$78,$30,$30,$30,$30,$30,$30,$30,$30,$30,$30,$78,$78,$00,$00)),
  {C} (Charnum : 226;CharData :
      ($3C,$3C,$66,$66,$C0,$C0,$C0,$C0,$C0,$C0,$66,$66,$3C,$3C,$00,$00)),
  {K} (Charnum : 171;CharData :
      ($E6,$E6,$66,$66,$6C,$6C,$78,$78,$6C,$6C,$66,$66,$E6,$E6,$00,$00)),
  {M} (Charnum : 156;CharData :
      ($C6,$C6,$EE,$EE,$FE,$FE,$FE,$FE,$D6,$D6,$C6,$C6,$C6,$C6,$00,$00)),
  {A} (Charnum : 243;CharData :
      ($30,$30,$78,$78,$CC,$CC,$CC,$CC,$FC,$FC,$CC,$CC,$CC,$CC,$00,$00)),
  {N} (Charnum : 250;CharData :
      ($C6,$C6,$E6,$E6,$F6,$F6,$DE,$DE,$CE,$CE,$C6,$C6,$C6,$C6,$00,$00)),
  {F} (CharNum : 161;CharData :
      ($FE,$FE,$62,$62,$68,$68,$78,$78,$68,$68,$60,$60,$F0,$F0,$00,$00)),
  {T} (Charnum : 254;CharData :
      ($FC,$FC,$B4,$B4,$30,$30,$30,$30,$30,$30,$30,$30,$78,$78,$00,$00)),
  {W} (Charnum : 130;CharData :
      ($C6,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$D6,$D6,$FE,$FE,$6C,$6C,$00,$00)),
  {R} (Charnum : 172;CharData :
      ($FC,$FC,$66,$66,$66,$66,$7C,$7C,$6C,$6C,$66,$66,$E6,$E6,$00,$00)),
  {E} (Charnum : 253;CharData :
      ($FE,$FE,$62,$62,$68,$68,$78,$78,$68,$68,$62,$62,$FE,$FE,$00,$00)),
  {c} (Charnum : 199;CharData :
      ($00,$00,$00,$00,$78,$78,$CC,$CC,$C0,$C0,$CC,$CC,$78,$78,$00,$00)),
  {(} (Charnum : 247;CharData :
      ($18,$18,$30,$30,$60,$60,$60,$60,$60,$60,$30,$30,$18,$18,$00,$00)),
  {)} (Charnum : 233;CharData :
      ($60,$60,$30,$30,$18,$18,$18,$18,$18,$18,$30,$30,$60,$60,$00,$00)),
  {1} (Charnum : 248;CharData :
      ($30,$30,$70,$70,$30,$30,$30,$30,$30,$30,$30,$30,$FC,$FC,$00,$00)),
  {9} (Charnum : 223;CharData :
      ($78,$78,$CC,$CC,$CC,$CC,$7C,$7C,$0C,$0C,$18,$18,$70,$70,$00,$00)),
  {7} (Charnum : 242;CharData :
      (254,254,198,198,12,12,24,24,48,48,48,48,48,48,0,0)));

Var
  i : Byte;

begin
  for i := 1 to 29 do With regs do begin
    ah := $11;
    al := $0;
    bh := $10;
    bl := 0;
    cx := 1;
    dx := NewChars[i].CharNum;
    es := seg(NewChars[i].CharData);
    bp := ofs(NewChars[i].CharData);
    intr($10,regs);
  end;
end;

begin
  loadchar;
  clrscr;
  regs.ax :=$0100;regs.cx :=$2607;intr(16,regs);  { cursoruit }
  textcolor(13);
  gotoxy(24,11);write('¿');
  gotoxy(24,12);write('                                ');
  gotoxy(24,13);write('');
  gotoxy(26,12);textcolor(12);writeln('Ҿ ⫝̸  ');
  gotoxy(52,12);textcolor(9);write('');

  { 210=J / 190=O / 141=S / 159=D / 241=I / 226=C / 171=K / 156=M / 243=A }
  { 250=N / 161=F / 254=T / 130=W / 172=R / 253=E / 247=( / 199=c / 233=) }
  { 248=1 / 223=9 / 242=7 }

  wait(1200);
end.