program warp_dog;
{*******************************
*  author: Benny Hauk          *
*  Email:  hauk@nashville.net  *
*******************************}

uses graph, crt, bgidriv;

const

{**************************}
{}   SPEED = 9;  {9 max.} {}
{}   NO_OF_STARS = 500;   {}
{**************************}


   real_speed = 10 - SPEED;
type
   point_r = record
      X, Y, speed :integer;
   end;
   point_a = array[1..NO_OF_STARS] of point_r;


var i :integer;


procedure InitPoint(var point :point_r);
begin
   point.X := random(GetMaxX) +1;
   point.Y := random(GetMaxY) +1;
   point.speed := 1;
end;



procedure Initialize(var star :point_a);
begin
   randomize;
   for i := 1 to NO_OF_STARS do begin
      InitPoint(star[i]);
   end;
end;


procedure ShowStars(var star :point_a);
begin
   for i := 1 to NO_OF_STARS do
      putpixel(star[i].X, star[i].Y, white);
end;


procedure CopyStars(star :point_a; var starCopy :point_a);
begin
   for i := 1 to NO_OF_STARS do
      starCopy[i] := star[i];
end;


procedure FigureNewPoints(var star :point_a; timeCounter :integer);
var theta :real;
slope :real;
begin
   for i := 1 to NO_OF_STARS do begin
      if (star[i].X > GetMaxX) or (star[i].Y > GetMaxY) or (star[i].X < 1) or (star[i].Y < 1)
         then InitPoint(star[i])
      else begin

         if (star[i].X < (GetMaxX div 2)) and (star[i].Y < (GetMaxY div 2))
            then begin
               slope := ((getMaxY div 2) - star[i].Y) / ((getMaxX div 2) - star[i].X);
               star[i].X := star[i].X - star[i].speed;
               star[i].Y := round((GetMaxY div 2) - (slope * ((GetMaxX div 2) - star[i].X)));
            end
         else if (star[i].X > (GetMaxX div 2)) and (star[i].Y < (GetMaxY div 2))
            then begin
               slope := ((getMaxY div 2) - star[i].Y) / ((getMaxX div 2) - star[i].X);
               star[i].X := star[i].X + star[i].speed;
               star[i].Y := round((GetMaxY div 2) - (slope * ((GetMaxX div 2) - star[i].X)));
            end
         else if (star[i].X > (GetMaxX div 2)) and (star[i].Y > (GetMaxY div 2))
            then begin
               slope := ((getMaxY div 2) - star[i].Y) / ((getMaxX div 2) - star[i].X);
               star[i].X := star[i].X + star[i].speed;
               star[i].Y := round((GetMaxY div 2) - (slope * ((GetMaxX div 2) - star[i].X)));
            end
         else if (star[i].X < (GetMaxX div 2)) and (star[i].Y > (GetMaxY div 2))
            then begin
               slope := ((getMaxY div 2) - star[i].Y) / ((getMaxX div 2) - star[i].X);
               star[i].X := star[i].X - star[i].speed;
               star[i].Y := trunc((GetMaxY div 2) - (slope * ((GetMaxX div 2) - star[i].X)));
            end
         else if (star[i].X = (GetMaxX div 2)) and (star[i].Y - (GetMaxY div 2) < 0) then
            star[i].Y := star[i].Y - star[i].speed
         else if (star[i].X = (GetMaxX div 2)) and (star[i].Y - (GetMaxY div 2) > 0) then
            star[i].Y := star[i].Y + star[i].speed
         else if (star[i].Y = (GetMaxY div 2)) and (star[i].X - (GetMaxX div 2) < 0) then
            star[i].X := star[i].X - star[i].speed
         else if (star[i].Y = (GetMaxY div 2)) and (star[i].X - (GetMaxX div 2) > 0) then
            star[i].X := star[i].X + star[i].speed
         else star[i].X := GetMaxX + 1; {find new point}
      end;
      if timeCounter mod REAL_SPEED = 0 then inc(star[i].speed);
   end;
end;


procedure CleanUpStars(star :point_a);
begin
   for i := 1 to NO_OF_STARS do
      putpixel(star[i].X, star[i].Y, black);
end;



var
 Gd, Gm : Integer;
 stars, oldStars :point_a;
 timeCounter :integer;

begin
   RegisterBGIdriver(@EGAVGADriverProc);
   Gd := Detect;
   InitGraph(Gd, Gm, ' ');
   if GraphResult <> grOk then
   Halt(1);
   Initialize(stars);
   ShowStars(stars);
   timeCounter := 0;
   repeat
      inc(timeCounter);
      if timeCounter = 10 then timeCounter := 0;
      CopyStars(stars, oldStars);
      FigureNewPoints(stars, timeCounter);
      ShowStars(stars);
      CleanUpStars(oldStars);
   until keypressed;
   closegraph;
end.