program The_Coolest_Screen_Saver;
{*******************************
*  author: Benny Hauk          *
*  Email:  hauk@nashville.net  *
*******************************}

uses graph, crt, bgidriv;
const
{
  Best Setup:  high lines, low gaps, low speed    OR
               low lines, higher gaps, higher speed
            (The numbers in french braces are two good settings)
}
   MAXLINES = 32;  {Just the number of lines appearing on the screen}
             {100}
             {50}
   GAP = 25;    { NO LOWER THAN 9.  It's the gap in between each line, but }
        {9}     { it also affects speed a little.  That's why the 9 thing. }
        {20}
   SPEED = 10;  {The lower the number, the faster the speed ==> delay(SPEED)}
          {0}
          {25}
   MAX_RADIUS = 30;

type
   Coord_a = array[1..(MAXLINES+1)] of integer;

var

 grDriver: Integer;
 grMode: Integer;
 ErrCode: Integer;
 x1,y1,x2,y2 :Coord_a;
 counter, counter2, count :integer;
 addX1, addY1, addX2, addY2 :boolean;
 color :word;

begin
   RegisterBGIdriver(@EGAVGADriverProc);
   randomize;
   grDriver := Detect;
   InitGraph(grDriver, grMode,' ');
   ErrCode := GraphResult;
   if ErrCode = grOk then
   begin  { Do graphics }
      x1[1] := random(GetMaxX);
      y1[1] := random(GetMaxY);
      x2[1] := random(MAX_RADIUS);
      y2[1] := random(GetMaxY);
      repeat
{line 1} inc(count);
         if (x1[1] >= GetMaxX)
            then addX1 := false
            else if x1[1] <=0
               then addX1 := true;
         if addX1 then x1[1] := x1[1] + GAP div 7 else x1[1] := x1[1] - GAP div 8;

         if (y1[1] >= GetMaxY)
            then addY1 := false
            else if y1[1] <=0
               then addY1 := true;
         if addY1 then y1[1] := y1[1] + GAP div 6 else y1[1] := y1[1] - GAP div 5;

         if (x2[1] >= MAX_RADIUS)
            then addX2 := false
            else if x2[1] <=0
               then addX2 := true;

         if addX2 then x2[1] := x2[1] + GAP div 10 else x2[1] := x2[1] - GAP div 10;

         if (y2[1] >= GetMaxY)
            then addY2 := false
            else if y2[1] <=0
               then addY2 := true;
         if addY2 then y2[1] := y2[1] + GAP div 2 else y2[1] := y2[1] - GAP div 1;

{rest of lines}
         for counter := (MAXLINES +1) downto 2 do
            begin
               x1[counter] := x1[counter -1];
               y1[counter] := y1[counter -1];
               x2[counter] := x2[counter -1];
               y2[counter] := y2[counter -1];
            end;
         counter := 0;
         setfillstyle(emptyfill, white);
         repeat
            inc(counter);
            {fillellipse(x1[counter],y1[counter], x2[counter],y2[counter]);}
            fillellipse(x1[counter],y1[counter], x2[counter], x2[counter]);
         until counter = MAXLINES;
         delay(SPEED);
{repeat until keypressed;
while keypressed do readkey;}
         setcolor(black);
         setfillstyle(emptyfill, black);
{         fillellipse(x1[MAXLINES +1], y1[MAXLINES +1], x2[MAXLINES +1], y2[MAXLINES +1]);}
         fillellipse(x1[MAXLINES +1], y1[MAXLINES +1], x2[MAXLINES +1], x2[MAXLINES +1]);
         setcolor(color);

         if x2[counter] < 2
            then color := random(15) +1;
      until keypressed;
      CloseGraph;
   end
   else begin
   Writeln('Graphics error:', GraphErrorMsg(ErrCode)); readln; end;
   while keypressed do readkey;
end.


