
 Program WinDemo;

   Uses Crt, Graph, Mouse, Windows;

   Var I      : integer;
       Answer : byte;
       R      : real;
       Key    : char;
       S      : string;
       Shown  : Boolean;

   Procedure WaitKey;
     Begin
       Repeat Until ReadKey2<>Empty { Keyboard or mouse key }
     End;

   Procedure WriteTitle (Title:string);
     Var Shown : Boolean;
       Begin
         Shown:=Visible;           { Always, when drawing something, hide  }
         If Shown then HideCursor; { mouse cursor to prevent from garbage. }
         SetFillStyle (SolidFill,White);
         Bar (0,0,MaxX,MaxY);
         SetColor (LightRed);
         SetTextJustify (CenterText,CenterText);
         OutTextXY (MaxX div 2,30,Title);
         Line (0,35,MaxX,35);
         If Shown then ShowCursor        { Restore mouse cursor }
       End;

   Procedure Center (Title:string);
     Var Shown : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         SetFillStyle (SolidFill,White);
         Bar (0,MaxY div 2-5,MaxX,MaxY div 2+5);
         SetColor (Black);
         SetTextJustify (CenterText,CenterText);
         OutTextXY (MaxX div 2,MaxY div 2,Title);
         If Shown then ShowCursor        { Restore mouse cursor }
       End;

     Begin
       OpenWindow (0,0,0,MaxX+1,MaxY+1,DontSave,BorderOn,'Windows Unit Demo');
       WriteTitle ('You can open up to 10 windows (or more if you change MaxWindow constant).');
       Randomize;
       Shown:=Visible;
       If Shown then HideCursor;
       For I:=1 to MaxWindow do
         Begin
           Str (I,S);
           OpenWindow (I,20+Random (300),70+Random (200),100+Random (200),50+Random (150),Save,BorderOn,'Window #'+S);
           SetColor (I);
           Line (0,0,MaxX,MaxY);
           Line (MaxX,0,0,MaxY);
           Delay (100)
         End;
       SetColor (Black);
       SetTextJustify (CenterText,CenterText);
       Center ('Any key...');
       If Shown then ShowCursor;
       WaitKey;
       For I:=1 to MaxWindow do
         Begin
           CloseWindow;
           Delay (100)
         End;
       WriteTitle ('ActiveWindow and SetActiveBar demo...');
       OpenWindow (1,10,70,300,100,Save,BorderOn,'Window #1');
       OpenWindow (2,330,70,300,100,Save,BorderOn,'Window #2');
       OpenWindow (3,10,200,300,100,Save,BorderOn,'Window #3');
       OpenWindow (4,330,200,300,100,Save,BorderOn,'Window #4');
       For I:=1 to 5 do
         Begin
           ActiveWindow ((I-1) mod 4+1);
           SetActiveBar;
           Center ('I''m active...');
           WaitKey;
           Center ('')
         End;
       ActiveWindow (4);
       For I:=1 to 4 do
         CloseWindow;
       WriteTitle ('Here is some buttons. Just click at them...');
       MakeButton (40,100,110,20,'Button #1',9);
       MakeButton (190,100,110,20,'Button #2',9);
       MakeButton (340,100,110,20,'Button #3',9);
       MakeButton (490,100,110,20,'Continue',1);
       MarkButton (490,100,110,20); { Mark "Continue" button }
         Repeat
           Key:=UpCase (InKey);
           If LeftButton then
             Begin
               If ButtonClicked (40,100,110,20) then
                 Key:='1';
               If ButtonClicked (190,100,110,20) then
                 Key:='2';
               If ButtonClicked (340,100,110,20) then
                 Key:='3';
               If ButtonClicked (490,100,110,20) then
                 Key:='C'
             End;
             Case Key of
               '1'     : Center ('Button #1');
               '2'     : Center ('Button #2');
               '3'     : Center ('Button #3')
             End
         Until Key in ['C',CR,ESC];
       WriteTitle ('Menu demo');
       OpenMenu (100,100,LeftUp,'An item,Also an item,One more',Answer);
       If Answer<>0 then
         Begin
           OpenMenu (120,110+13*Answer,LeftUp,'New first option,New second option,New third option',Answer);
           CloseTemp
         End;
       CloseTemp;
       Shown:=Visible;
       If Shown then HideCursor;
         Case Answer of
           0 : Center ('You choosed nothing...');
           1 : Center ('You choosed first option...');
           2 : Center ('You choosed second option...');
           3 : Center ('You choosed third option...')
         End;
       If Shown then ShowCursor;
       WaitKey;
       WriteTitle ('ReadStr example...');
       MoveTo (100,200);
       ReadStr ('Input string, please: ',S,20);
       If InputIntr then
         Center ('You have interrupted the input of the string!')
                    else
         Center ('You have entered: "'+S+'"');
       WaitKey;
       WriteTitle ('ReadReal example...');
       MoveTo (100,200);
       ReadReal ('Input a real number, please: ',R,10);
       Str (R:0:2,S);
       If InputIntr then
         Center ('You have interrupted the input of the number!')
                    else
         Center ('You have entered: '+S);
       WaitKey;
       WriteTitle ('ReadInt example...');
       MoveTo (100,200);
       ReadInt ('Input an integer number, please: ',I,10);
       Str (I,S);
       If InputIntr then
         Center ('You have interrupted the input of the number!')
                    else
         Center ('You have entered: '+S);
       WaitKey;
       WriteTitle ('Box demo...');
       OpenBox (200,240,240,100,LeftUp);
       Shown:=Visible;
       If Shown then HideCursor;
       OutTextXY (102,30,'Exit');
       If Shown then ShowCursor;
       MakeButton (265,300,110,20,'OK',0);
       MarkButton (265,300,110,20);
       Repeat Until ButtonClicked (265,300,110,20) or (Inkey in [CR,ESC]);
       CloseTemp;
       CloseGraph
     End.
