
 Unit Windows;
{
             
             ۱
                                                   ۱
              Graphics windows (Windows 3.1x like) ۱
                                                   ۱
                        Aleksandar Dlabac          ۱
               (C)1993-1995. Dlabac Bros. Company  ۱
                 ------------------------------    ۱
                   adlabac@urcpg.urc.cg.ac.yu      ۱
                   adlabac@urcpg.pmf.cg.ac.yu      ۱
                                                   ۱
             ۱
             ۱
               
}
   Interface

   Const MaxWindow     = 10;
         MaxDepth      =  5;
         MaxOpt        = 20;
         Save          = True; DontSave         = False;
         BorderOn      = True; BorderOff        = False;
         LeftUp        = 0;    RightUp          = 1;
         LeftDown      = 2;    RightDown        = 3;
         ActivW        : byte = 0;
         Empty = #255; ESC  = #27; CR   = #13; BCKSP = #8;
         Up    = #72;  Down = #80; Left = #75; Right = #77;
         PgUp  = #73;  PgDn = #81; Del  = #83; GoUp = #128;

   Var   MaxX, MaxY         : integer;
         InputIntr, MovedUp : Boolean;
         TempDir            : string;
         WinDat             : array [0..MaxWindow] of Record
                                                        Open, SaveFlag, WBorder : Boolean;
                                                        Xw, Yw, Ww, Hw, Xr, Yr,
                                                        MX, MY, Xcur, Ycur      : integer;
                                                        AddrBit                 : pointer;
                                                        PrevWind                : byte;
                                                        WName                   : string
                                                      End;

   Procedure ClearKeyboardBuffer;
   { ClearKeyboardBuffer empties keyboard buffer }

   Function  AvailableWindow : byte;
   { AvailableWindow returns Number of first available window handle }

   Procedure OpenWindow (Wn:byte; X,Y,W,H:integer; SaveFlg,Border:Boolean; Name:string);
   { OpenWindow opens a new window. Parameters are:
       Wn      - window handle (0-MaxWindow) of new window. There must not be
                 another window with same handle. Recomended use od
                 AvailableWindow function.
       X, Y    - Coordinates of upper left corner of window in pixels.
       W, H    - Width and height of window in pixels.
       SaveFlg - If set to True content of screen will be restored after
                 closing this window.
       Border  - If set to True, five pixels wide (Windows like) border will
                 be used, otherwise one pixel border is used.
       Name    - Window title. In case of empty string window will not have
                 title bar, otherwise Window will have the same title bar
                 like in Windows, with blue backgroung and white title text,
                 centered on bar. }

   Procedure ActiveWindow (Wn:byte);
   { ActiveWindow sets active window to window which handle is Ws.
     WARNING: Should not be used if there is overlaped windows (except 0).
              Should be used for latest opened window only.}

   Procedure SetActiveBar;
   { SetActiveBar sets color of title bars of inactive windows to gray, so
     only the active window (and window with handle 0) will have blue title.
     WARNING: should not be used if there is overlaped windows (except 0). }

   Procedure CloseWindow;
   { CloseWindow closes active window }

   Procedure MoveWindow (Wn:byte; X,Y:integer);
   { MoveWindow moves window Wn to new coordinate (X,Y) }

   Procedure MakeButton (X,Y,W,H:integer; Str:string; HotKey:byte);
   { Make button draws button. Parameters are:
       X, Y   - Coordinates of upper left corner of button in pixels.
       W, H   - Width and height of button in pixels.
       Str    - Button caption.
       HotKey - If greated than zero, letter on that position in caption
                will be underlined.}

   Procedure MarkButton (X,Y,W,H:integer);
   { MarkButton draws black border arround button defined bu X, Y, W, H,
     so it looks like default button in Windows. }

   Function ButtonClicked (X,Y,W,H:integer) : Boolean;
   { ButtonClicked animates button click. Should be used when button is
     clicked by mouse. If Mouse pointer is not in button area when left
     button is depressed False is returned, otherwise True will be returnes.
     I invented new "click technique" which I called "RealClick", which is
     more realistic than in Windows. Parameters are the same as in MarkButton
     procedure. }

   Procedure PushButton (X,Y,W,H:integer);
   { PushButton animates button click. Should be used for unconditional
     click - button is automatically depressed after 0.2 seconds.
     Function ButtonClicked should be used instead of this procedure.
     Possible use of this pocedure is if you want to animate a button when
     button is activated by keyboard. }

   Function  InKey : char;
   { InKey is similar to ReadKey, but do not wait if key is not pressed, in
     which case returns value "Empty" (#255). }

   Function  InBox (X,Y,X1,Y1,W,H:integer) : Boolean;
   { InBox returns True if coordinates (X,Y) belonges to rectangle degfined
     with (X1,Y1,W,H), otherwise is False. Used for mouse click detection. }

   Procedure OpenMenu (X,Y:integer; Corn:byte; Menu:string; var Answer:byte);
   { OpenMenu opens a menu. Parameters are:
       X, Y   - Coordinates of one corner in pixels.
       Corn   - Defines which corner is given by (X,Y). Values of Corn can be
                LeftUp, RightUp, LeftDown, RightDown.
       Menu   - String containing menu items. Items should be separated by
                comma (","). Maximum "MaxOpt" (20) options allowed. For
                example if Menu='First,Second,tHird', menu on screen will
                have three options:
                    First
                    Second
                    tHird
                First upper case in option is hotkey. Pressing "H" key when
                  menu is oppened will cause selecting of third option.
       Answer - If nonzero returns Number of selecter option, otherwise
                ESC taster is pressed, or clicked outside of the menu. }

   Procedure OpenBox (X,Y,W,H:integer; Corn:byte);
   { Opens a temporary window (for messages, for example) with single border.
     Parameters are:
       X, Y, Corn - Same like in OpenMenu.
       W, H       - Width and height of box in pixels. }

   Procedure CloseTemp;
   { Closes temporary window }

   Function  ReadKey2 : char;
   { Same as ReadKey, but also will return CR (Enter, #13) if left mouse
     button is pressed, and ESC (#27) if right mouse button is pressed. }

   Procedure ReadStr (Prompt:string; var S:string; NumChars:byte);
   { Reads a string at current position, with maximum NumChars characters.
     Value is returned in S. If Prompt is not empty string, then it will
     be written before cursor. }

   Procedure ReadReal (Prompt:string; var Number:real; NumDigits:byte);
   { Reads a real Number at current position, with maximum NumDigits digits.
     Value is returned in Number. If Prompt is not empty string, then it will
     be written before cursor. }

   Procedure ReadInt (Prompt:string; var Number:integer; NumDigits:byte);
   { Reads an integer Number at current position, with maximum NumDigits digits.
     Value is returned in Number. If Prompt is not empty string, then it will
     be written before cursor. }


   Implementation

   Uses Graph, Crt, Dos, Mouse; { Mouse unit from the same author }

   Const Depth  : shortint = -1; Active = Blue; NotActive = LightGray;

   Var   Gd, Gm    : integer;
         I, B      : byte;
         Numerical : Boolean;

   Procedure ClearKeyboardBuffer;
     Var Key : char;
       Begin
         While KeyPressed do
           Key:=ReadKey
       End;

   Function AvailableWindow : byte;
     Var Temp : byte;
       Begin
         Temp:=1;
         While (Temp<=MaxWindow) and WinDat [Temp].Open do Inc (Temp);
         If Temp>MaxWindow then Temp:=0;
         AvailableWindow:=Temp
       End;

   Procedure GetScrPart (W,H:integer; var P:pointer);
     Var Size  : word;
         Shown : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         Size:=ImageSize (0,0,W,H);
         If (Size=0) or (Size>MaxAvail) then
           P:=Nil
                                      else
           Begin
             GetMem (P,Size);
             GetImage (0,0,W,H, P^)
           End;
         If Shown then ShowCursor
       End;

   Procedure SaveScrPart (N,W,H:integer; var P:pointer);
     Var Size  : word;
         F     : file;
         Shown : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         Size:=ImageSize (0,0,W,H);
         If (Size=0) or (Size>MaxAvail) then
           P:=Nil
                                      else
           Begin
             Assign (F,TempDir+'TEMP.WN'+Chr (N+47));
             Rewrite (F,1);
             GetMem (P,Size);
             GetImage (0,0,W,H, P^);
             BlockWrite (F,P^,Size);
             Close (F);
             FreeMem (P,Size)
           End;
         If Shown then ShowCursor
       End;

   Procedure PutScrPart (W,H:integer; P:pointer);
     Var Shown : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         If P=Nil then
           Begin
             SetFillStyle (SolidFill,White);
             Bar (0,0,W,H)
           End
                  else
           Begin
             PutImage (0,0, P^, CopyPut);
             FreeMem (P,ImageSize (0,0,W,H))
           End;
         If Shown then ShowCursor
       End;

   Procedure LoadScrPart (N,W,H:integer; P:pointer);
     Var Size  : word;
         F     : file;
         Shown : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         If (P=Nil) or (Size>MaxAvail) then
           Begin
             SetFillStyle (SolidFill,White);
             Bar (0,0,W,H)
           End
                  else
           Begin
             Size:=ImageSize (0,0,W,H);
             Assign (F,TempDir+'TEMP.WN'+Chr (N+47));
             Reset (F,1);
             GetMem (P,Size);
             BlockRead (F,P^,Size);
             Close (F);
             Erase (F);
             PutImage (0,0, P^, CopyPut);
             FreeMem (P,Size)
           End;
         If Shown then ShowCursor
       End;

   Procedure OpenWindow (Wn:byte; X,Y,W,H:integer; SaveFlg,Border:Boolean; Name:string);
     Var Shown : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         If Wn<=MaxWindow then
           With WinDat [Wn] do
             Begin
               With WinDat [ActivW] do
                 Begin
                   Xcur:=GetX; Ycur:=GetY
                 End;
               PrevWind:=ActivW;
               ActivW:=Wn;
               If W<0 then
                 Begin
                   W:=-W; Dec (X,W)
                 End;
               If H<0 then
                 Begin
                   H:=-H; Dec (Y,H)
                 End;
               Xr:=1; Yr:=1;
               MaxX:=W-1; MaxY:=H-1; Xw:=X; Yw:=Y; Hw:=H; Ww:=W;
               Xcur:=0; Ycur:=0;
               SaveFlag:=SaveFlg;
               Open:=True;
               SetViewPort (X,Y,X+W,Y+H,ClipOn);
               If SaveFlag then SaveScrPart (Wn,Ww,Hw,AddrBit);
               WName:=Name;
               Wborder:=Border
             End;
         SetLineStyle (SolidLn,7,NormWidth);
         SetFillStyle (SolidFill,White);
         Bar (0,0,MaxX+1,MaxY+1);
         SetColor (Black);
         Rectangle (0,0,MaxX+1,MaxY+1);
         If Border then
           Begin
             SetColor (LightGray);
             Rectangle (1,1,MaxX,MaxY);
             Rectangle (2,2,MaxX-1,MaxY-1);
             Rectangle (3,3,MaxX-2,MaxY-2);
             SetColor (Black);
             Rectangle (4,4,MaxX-3,MaxY-3);
             If Name<>'' then
               Begin
                 SetFillStyle (SolidFill,Active);
                 Bar (5,5,MaxX-4,22);
                 SetFillStyle (SolidFill,White);
                 Line (0,22,MaxX,22);
                 SetViewPort (X+7,Y+7,X+W-7,Y+20,ClipOn);
                 SetColor (White);
                 SetTextJustify (CenterText,CenterText);
                 OutTextXY (MaxX div 2-7,7,Name);
                 SetColor (Black);
                 SetViewPort (X+5,Y+23,X+W-5,Y+H-5,ClipOn);
                 MaxX:=W-10; MaxY:=H-28;
                 With WinDat [Wn] do
                   Begin
                     Xr:=5; Yr:=23
                   End
               End
                         else
               Begin
                 SetViewPort (X+5,Y+5,X+W-5,Y+H-5,ClipOn);
                 MaxX:=W-10; MaxY:=H-10;
                 With WinDat [Wn] do
                   Begin
                     Xr:=5; Yr:=5
                   End
               End
           End
                   else
         SetViewPort (X+1,Y+1,X+W-1,Y+H-1,ClipOn);
         With WinDat [Wn] do
           Begin
             MX:=MaxX; MY:=MaxY
           End;
         SetTextJustify (LeftText,TopText);
         If Shown then ShowCursor
       End;

   Procedure ActiveWindow (Wn:byte);
     Begin
       If Wn<=MaxWindow then
         Begin
           With WinDat [ActivW] do
             Begin
               Xcur:=GetX; Ycur:=GetY
             End;
           With WinDat [Wn] do
             If Open then
               Begin
                 ActivW:=Wn;
                 SetViewPort (Xw+Xr,Yw+Yr,Xw+MX+Xr,Yw+MY+Yr,ClipOn);
                 MaxX:=MX; MaxY:=MY;
                 MoveTo (Xcur,Ycur)
               End
         End
     End;

   Procedure SetActiveBar;
     Var I     : integer;
         Shown : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         For I:=1 to MaxWindow do
           With WinDat [I] do
             If Open and WBorder and (WName<>'') then
               Begin
                 SetViewPort (Xw,Yw,Xw+Ww,Yw+Hw,ClipOn);
                 SetFillStyle (SolidFill,NotActive);
                 SetColor (Black);
                 Bar (5,5,Ww-5,22);
                 SetFillStyle (SolidFill,White);
                 Line (0,22,Ww-1,22);
                 SetViewPort (Xw+7,Yw+7,Xw+Ww-7,Yw+20,ClipOn);
                 SetTextJustify (CenterText,CenterText);
                 OutTextXY (MX div 2-3,7,WName)
               End;
         With WinDat [ActivW] do
           If Open and WBorder and (WName<>'') then
             Begin
               SetViewPort (Xw,Yw,Xw+Ww,Yw+Hw,ClipOn);
               SetFillStyle (SolidFill,Active);
               SetColor (Black);
               Bar (5,5,Ww-5,22);
               SetFillStyle (SolidFill,White);
               Line (0,22,Ww-1,22);
               SetViewPort (Xw+7,Yw+7,Xw+Ww-7,Yw+20,ClipOn);
               SetTextJustify (CenterText,CenterText);
               SetColor (White);
               OutTextXY (MX div 2-3,7,WName);
               SetColor (Black)
             End;
         SetTextJustify (LeftText,TopText);
         ActiveWindow (ActivW);
         If Shown then ShowCursor
       End;

   Procedure CloseWindow;
     Var Shown : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         With WinDat [ActivW] do
           If (ActivW>0) and Open then
             Begin
               Open:=False;
               Xcur:=GetX; Ycur:=GetY;
               SetViewPort (Xw,Yw,Xw+Ww,Yw+Hw,ClipOn);
               SetFillStyle (SolidFill,White);
               If SaveFlag then LoadScrPart (ActivW,Ww,Hw,AddrBit)
                                else Bar (0,0,Ww,Hw);
               If WinDat [PrevWind].Open then ActiveWindow (PrevWind)
                                         else ActiveWindow (0)
             End;
         If Shown then ShowCursor
       End;

   Procedure MoveWindow (Wn:byte; X,Y:integer);
     Var P          : Pointer;
         Shown      : Boolean;
         View       : ViewPortType;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         If (Wn>0) and (Wn<=MaxWindow) then
           With WinDat [Wn] do
             If Open then
               Begin
                 SetViewPort (Xw,Yw,Xw+Ww,Yw+Hw,ClipOn);
                 GetScrPart (Ww,Hw,P);
                 SetFillStyle (SolidFill,White);
                 If SaveFlag then LoadScrPart (ActivW,Ww,Hw,AddrBit)
                             else Bar (0,0,Ww,Hw);
                 Xw:=X; Yw:=Y;
                 SetViewPort (X,Y,X+Ww,Y+Hw,ClipOn);
                 If SaveFlag then SaveScrPart (ActivW,Ww,Hw,AddrBit);
                 PutScrPart (Ww,Hw,P);
                 SetViewPort (X+Xr,Y+Yr,X+Xr+MaxX,Y+Yr+MaxY,ClipOn)
               End;
       If Shown then ShowCursor
     End;

   Procedure MakeButton (X,Y,W,H:integer; Str:string; HotKey:byte);
     Var Shown : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         SetColor (Black);
         SetViewPort (0,0,639,479,ClipOn);
         Line (X+1,Y,X+W-1,Y);
         Line (X+1,Y+H,X+W-1,Y+H);
         Line (X,Y+1,X,Y+H-1);
         Line (X+W,Y+1,X+W,Y+H-1);
         SetColor (LightGray);
         SetFillStyle (SolidFill,LightGray);
         Bar (X+3,Y+3,X+W-3,Y+H-3);
         SetColor (White);
         Line (X+1,Y+1,X+W-1,Y+1);
         Line (X+2,Y+2,X+W-2,Y+2);
         Line (X+1,Y+1,X+1,Y+H-1);
         Line (X+2,Y+2,X+2,Y+H-2);
         SetColor (DarkGray);
         Line (X+1,Y+H-1,X+W-1,Y+H-1);
         Line (X+2,Y+H-2,X+W-2,Y+H-2);
         Line (X+W-1,Y+H-1,X+W-1,Y+1);
         Line (X+W-2,Y+H-2,X+W-2,Y+2);
         SetColor (Black);
         SetTextJustify (CenterText,CenterText);
         OutTextXY (X+W div 2,Y+H div 2+1,Str);
         If HotKey in [1..Length (Str)] then
           Line (X+W div 2-TextWidth (Str) div 2+(HotKey-1)*8,Y+H div 2+5,
                 X+W div 2-TextWidth (Str) div 2+(HotKey-1)*8+8,Y+H div 2+5);
         ActiveWindow (ActivW);
         SetTextJustify (LeftText,TopText);
         If Shown then ShowCursor
       End;

   Procedure MarkButton (X,Y,W,H:integer);
     Var Shown : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         SetViewPort (0,0,639,479,ClipOn);
         SetColor (White);
         SetWriteMode (XORPut);
         Rectangle (X-1,Y-1,X+W+1,Y+H+1);
         Line (X,Y,X,Y);
         Line (X+W,Y,X+W,Y);
         Line (X,Y+H,X,Y+H);
         Line (X+W,Y+H,X+W,Y+H);
         SetWriteMode (NormalPut);
         SetColor (Black);
         ActiveWindow (ActivW);
         If Shown then ShowCursor
       End;

   Procedure PressButton (X,Y,W,H:integer);
     Var P     : pointer;
         Shown : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         SetViewPort (0,0,639,479,ClipOn);
         SetWriteMode (NormalPut);
         If MaxAvail<ImageSize (0,0,W,H) then
           Begin
             SetColor (DarkGray);
             Line (X+1,Y+1,X+W-1,Y+1);
             Line (X+2,Y+2,X+W-2,Y+2);
             Line (X+1,Y+1,X+1,Y+H-1);
             Line (X+2,Y+2,X+2,Y+H-2);
             SetColor (White);
             Line (X+1,Y+H-1,X+W-1,Y+H-1);
             Line (X+2,Y+H-2,X+W-2,Y+H-2);
             Line (X+W-1,Y+H-1,X+W-1,Y+1);
             Line (X+W-2,Y+H-2,X+W-2,Y+2)
           End
                                         else
           Begin
             SetFillStyle (SolidFill,DarkGray);
             GetMem (P,ImageSize (0,0,W,H));
             GetImage (X+3,Y+3,X+W-3,Y+H-3,P^);
             Bar (X+1,Y+1,X+W-1,Y+H-1);
             SetColor (White);
             Line (X+3,Y+3,X+W-2,Y+3);
             Line (X+3,Y+3,X+3,Y+H-2);
             PutImage (X+4,Y+4,P^,NormalPut);
             FreeMem (P,ImageSize (0,0,W,H))
           End;
         SetColor (Black);
         ActiveWindow (ActivW);
         If Shown then ShowCursor
       End;

   Procedure UnPressButton (X,Y,W,H:integer);
     Var P     : pointer;
         Shown : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         SetViewPort (0,0,639,479,ClipOn);
         SetWriteMode (NormalPut);
         If MaxAvail<ImageSize (0,0,W,H) then
           Begin
             SetColor (White);
             Line (X+1,Y+1,X+W-1,Y+1);
             Line (X+2,Y+2,X+W-2,Y+2);
             Line (X+1,Y+1,X+1,Y+H-1);
             Line (X+2,Y+2,X+2,Y+H-2);
             SetColor (DarkGray);
             Line (X+1,Y+H-1,X+W-1,Y+H-1);
             Line (X+2,Y+H-2,X+W-2,Y+H-2);
             Line (X+W-1,Y+H-1,X+W-1,Y+1);
             Line (X+W-2,Y+H-2,X+W-2,Y+2)
           End
                                         else
           Begin
             SetFillStyle (SolidFill,DarkGray);
             GetMem (P,ImageSize (0,0,W,H));
             GetImage (X+4,Y+4,X+W-2,Y+H-2,P^);
             PutImage (X+3,Y+3,P^,NormalPut);
             SetColor (White);
             Line (X+1,Y+1,X+W-1,Y+1);
             Line (X+2,Y+2,X+W-2,Y+2);
             Line (X+1,Y+1,X+1,Y+H-1);
             Line (X+2,Y+2,X+2,Y+H-2);
             SetColor (DarkGray);
             Line (X+1,Y+H-1,X+W-1,Y+H-1);
             Line (X+2,Y+H-2,X+W-2,Y+H-2);
             Line (X+W-1,Y+H-1,X+W-1,Y+1);
             Line (X+W-2,Y+H-2,X+W-2,Y+2);
             SetFillStyle (SolidFill,White);
             FreeMem (P,ImageSize (0,0,W,H))
           End;
         SetColor (Black);
         ActiveWindow (ActivW);
         If Shown then ShowCursor
       End;

   Function ButtonClicked (X,Y,W,H:integer) : Boolean;
     Var MX, MY  : integer;
         Pressed : Boolean;
       Begin
         Pressed:=False;
         If Inbox (GetMouseX,GetMouseY,X,Y,W,H) then
           While LeftButton do
             Begin
               MX:=GetMouseX;
               MY:=GetMouseY;
               If not InBox (MX,MY,X,Y,W,H) and Pressed then
                 Begin
                   UnpressButton (X,Y,W,H);
                   Pressed:=False
                 End;
               If InBox (MX,MY,X,Y,W,H) and not Pressed then
                   Begin
                     PressButton (X,Y,W,H);
                     Pressed:=True
                   End
             End;
         If Pressed then
           UnpressButton (X,Y,W,H);
         ButtonClicked:=Pressed
       End;

   Procedure PushButton (X,Y,W,H:integer);
     Begin
       PressButton (X,Y,W,H);
       Delay (200);
       UnpressButton (X,Y,W,H)
     End;

   Function InKey : char;
     Var T : char;
       Begin
         If KeyPressed then T:=ReadKey else T:=Empty;
         InKey:=T
       End;

   Function InBox (X,Y,X1,Y1,W,H:integer) : Boolean;
     Begin
       InBox:=(X>=X1) and (X<=X1+W) and (Y>=Y1) and (Y<=Y1+H)
     End;

   Procedure OpenMenu (X,Y:integer; Corn:byte; Menu:string; var Answer:byte);
     Const Hg = 13; 
     Var Posib : array [1..MaxOpt] of Record
                                        Beg, Wid : byte
                                      End;
         Options        : string [MaxOpt];
         I, Nopt, Width : byte;
         W, H           : integer;
         Shown          : Boolean;

       Procedure GetPossib;
         Var I, J, K : byte;
           Begin
             Options:='';
             I:=0; Width:=0; Nopt:=0;
             Repeat
               J:=Pos (',',Menu);
               If J>0 then
                 Begin
                   Inc (Nopt);
                   Menu [J] := ';';
                   Posib [Nopt].Beg := I+1;
                   Posib [Nopt].Wid := J-I-1;
                   K:=I;
                   Repeat
                     Inc (K);
                     If Menu [K] in ['A'..'Z'] then Options:=Options+Menu [K];
                   Until (K=J) or (menu [K] in ['A'..'Z']);
                   If K=J then Options:=Options+' ';
                   With Posib [Nopt] do If Wid>Width then Width:=Wid;
                 End;
               I:=J
             Until (I=0) or (Nopt=MaxOpt)
           End;

       Procedure MakeChoice;
         Var I          : byte;
             Xm, Ym     : integer;
             Key, Ctrl  : char;
           Begin
             Y:=0;
             SetColor (White);
             SetWriteMode (XorPut);
               Repeat
                 HideCursor;
                 For I:=Y+5 to Y+Hg+2 do Line (1,I,MaxX-2,I);
                 ShowCursor;
                   Repeat
                     Key:=Upcase (InKey);
                     If RightButton then Key:=ESC;
                     If LeftButton then
                       Begin
                         With WinDat [ActivW] do
                           Begin
                             Xm:=GetMouseX-Xw;
                             Ym:=GetMouseY-Yw;
                             If not InBox (Xm,Ym,0,0,Ww,Hw) then Key:=ESC
                           End;
                         For I:=1 to Nopt do
                           If InBox (Xm,Ym,1,5+(I-1)*Hg,MaxX-3,10) then
                             Begin
                               Key:=CR;
                               Y:=(I-1)*Hg
                             End
                       End;
                   Until (Pos (Key,CR+ESC+Options)>0) or (Key=#0);
                 HideCursor;
                 For I:=Y+5 to Y+Hg+2 do Line (1,I,MaxX-2,I);
                 ShowCursor;
                 If Key=#0 then
                   Begin
                     Ctrl:=ReadKey;
                     If (Ctrl=Down) and (Y div Hg+1 < Nopt) then Inc (Y,Hg)
                                                            else
                                     If (Ctrl=Up) and (Y>0) then Dec (Y,Hg);
                   End;
               Until Key>#0;
             If Key=CR then Answer:=Y div Hg+1 else Answer:=Pos (Key,Options);
             Y:=(Answer-1)*Hg;
             HideCursor;
             If Y>0 then For I:=Y+5 to Y+Hg+2 do Line (1,I,MaxX-2,i);
             ShowCursor;
             With WinDat [ActivW] do MoveTo (Xw+15,Yw+Y+Hg+3);
             SetWriteMode (NormalPut)
           End;

       Begin
         Shown:=Visible;
         If Depth<MaxDepth-1 then
           Begin
             Menu:=Menu+',';
             Inc (Depth);
             GetPossib;
             H:=10+Nopt*Hg; W:=Width*8+11;
             If Corn>RightUp then H:=-H;
             If (Corn=RightUp) or (Corn=RightDown) then W:=-W;
             OpenWindow (MaxWindow-Depth,X,Y,W,H,Save,BorderOff,'');
             SetTextJustify (LeftText,TopText);
             SetColor (Black);
             If Shown then HideCursor;
             For I:=1 to Nopt do
               With Posib [I] do
                 OutTextXY (6,7+(I-1)*Hg, Copy (Menu,Beg,Wid));
               Repeat Until not LeftButton and not RightButton;
             ShowCursor;
             MakeChoice
           End;
         SetColor (Black);
         If not Shown then HideCursor;
         Repeat Until not LeftButton and not RightButton
       End;

   Procedure OpenBox (X,Y,W,H:integer; Corn:byte);
     Var Wsgn, Hsgn : integer;
         Shown      : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         If Depth<MaxDepth-1 then
           Begin
             Inc (Depth);
             If Corn>RightUp then Hsgn:=-1 else Hsgn:=1;
             If (Corn=RightUp) or (Corn=RightDown) then Wsgn:=-1 else Wsgn:=1;
             OpenWindow (MaxWindow-Depth,X,Y,Wsgn*W,Hsgn*H,Save,BorderOn,'')
           End;
         If Shown then ShowCursor
       End;

   Procedure CloseTemp;
     Var Actual : byte;
         Shown  : Boolean;
       Begin
         Shown:=Visible;
         If Shown then HideCursor;
         If Depth>-1 then
             Begin
               If ActivW<>MaxWindow-Depth then
                 Begin
                   Actual:=ActivW;
                   ActiveWindow (MaxWindow-Depth);
                   CloseWindow;
                   ActiveWindow(Actual)
                 End
                                          else
                 CloseWindow;
               Dec (Depth);
             End;
         If Shown then ShowCursor
       End;

   Function  ReadKey2 : char;
     Var Temp : char;
         L, R : Boolean;
       Begin
           Repeat
             L:=LeftButton;
             R:=RightButton;
             Temp:=InKey;
           Until (Temp<>Empty) or L or R;
         If L then Temp:=CR;
         If R then Temp:=ESC;
         Repeat Until not LeftButton and not RightButton;
         ReadKey2:=Temp
       End;

   Procedure ReadStr (Prompt:string; var S:string; NumChars:byte);
     Var C     : char;
         Hgh   : byte;
         Shown : Boolean;
         Info  : TextSettingsType;
       Begin
         Hgh:=TextHeight ('M');
         SetFillStyle (SolidFill,White);
         Bar (GetX,GetY,GetX+TextWidth ('m')*NumChars-1,GetY+Hgh-1);
         SetColor (Black);
         Shown:=Visible;
         If Shown then HideCursor;
         SetTextJustify (LeftText,TopText);
         OutText (Prompt);
         S:='';
         ClearKeyboardBuffer;
           Repeat
             SetFillStyle (SolidFill,LightGray);
             Bar (GetX,GetY,GetX+TextWidth ('m')-1,GetY+Hgh-1);
               Repeat
                 C:=InKey;
                 If Numerical then C:=UpCase (C);
                 If RightButton then C:=ESC
               Until C<>Empty;
             Repeat Until not LeftButton and not RightButton;
             SetFillStyle (SolidFill,White);
             Bar (GetX,GetY,GetX+TextWidth('m')-1,GetY+Hgh-1);
             If ((C in ['0'..'9','.','E','+','-']) or (not Numerical and (C in [' '..'z']))) and
                (Length (S)<NumChars) then
               Begin
                 S:=S+C;
                 OutText (C)
               End
                                      else
               If (C=BCKSP) and (Length (S)>0) then
                 Begin
                   MoveRel (-TextWidth (S [Length(S)] ),0);
                   Delete (S,Length(S),1)
                 End
                                               else
                 If C=#0 then
                   C:=ReadKey
           Until C in [CR,ESC,GoUp];
         If C=ESC then S:='';
         MovedUp:=C=GoUp;
         InputIntr:=C=ESC;
         MoveTo (1,GetY+TextHeight(S));
         If Shown then ShowCursor
       End;

   Procedure ReadReal (Prompt:string; var Number:real; NumDigits:byte);
     Var Err, X, Y : integer;
         Input     : string;
       Begin
         X:=GetX;
         Y:=GetY;
           Repeat
             MoveTo (X,Y);
             Numerical:=True;
             ReadStr (Prompt,Input,NumDigits);
             Numerical:=False;
             If Input<>'' then Val (Input,Number,Err) else Number:=0
           Until (Number>=0) or InputIntr
       End;

   Procedure ReadInt (Prompt:string; var Number:integer; NumDigits:byte);
     Var Err, X, Y : integer;
         Input     : string;
       Begin
         X:=GetX;
         Y:=GetY;
           Repeat
             MoveTo (X,Y);
             Numerical:=True;
             ReadStr (Prompt,Input,NumDigits);
             Numerical:=False;
             If Input<>'' then Val (Input,Number,Err) else Number:=0
           Until (Number>=0) or InputIntr
       End;

   Begin
     TempDir:=GetEnv ('TEMP');
     If TempDir<>'' then
       TempDir:=TempDir+'\';
     Gd:=VGA;
     Gm:=VGAHi;
     InitGraph (Gd,Gm,'');
     Gd:=GraphResult;
     Writeln (GraphErrorMsg (Gd));
     If GraphResult<>0 then
       Begin
         Writeln;
         Writeln ('Error initiating graphics mode.');
         Halt
       End;
     For I:=0 to MaxWindow do WinDat [I].Open:=False;
     MaxX:=GetMaxX;
     MaxY:=GetMaxY;
     Numerical:=False;
     ResetMouse;
     ShowCursor
   End.
