{$R-,S-}
{$M 1024,0,655360}
Program SampleEditor;

Uses Dos, Crt, Graph, Bmouse, SndStuff;


Const
   {plaats van midden sample op scherm, het y-coordinaat duz}
   baseline   : word = 50;
   {kleur instellingen}
   TxtColor   : word = 1;
   PixelColor : word = 10;
   BgColor    : word = 7;
   BtLight    : word = 15;
   BtDark     : word = 8;
   SelLine    : word = 13;
   Labels     : word = 8;
   Version    : string = 'v1.0';
   MaxPointer : word = 32000;
   MaxPointerStr : string = '32000 bytes';
Var
   Fname           : String[12];
   Fsize     : Integer;
   Start, Stop,             {begin en eind selectie}
   Clipsize        : word;  {grootte van pointer clipboard}
   ch              : Char;
   buf, Clipboard       : Pointer;
   {buf                  : Array [0..65533] of byte;}
   Freq    : word;
   {loadsample}
   ProgDir         : String;
   NumFiles        : Word;
   FileList        : Array[1..500] of String[12]; {abcdefgh.123}
   {detect drives}
   Drv             : array[1..3] of byte;
   Fcb             : array[1..37] of byte;
   Reg             : registers;
   SaveSampleDir   : String; {dir van geladen sample in staat. voor Saven}


Procedure InitScreen;
Var
   Driver, Mode : Integer;

Begin
 ClrScr;
 Driver := Detect;
 InitGraph(Driver, Mode, '');
 If GraphResult <> grOk then
  begin
   ClrScr;
   Writeln('Something went wrong initialing your graphic adapter...');
   Writeln('Probable cause: EGAVGA.BGI is corrupt or missing!');
   Halt;
  end;
End;

Function Installed_Diskettes : byte;
{ Jose Almeida. P.O.Box 4185. 1504 Lisboa Codex. Portugal.}
{ detecteerd het aantal diskette stations}
Begin
 Installed_Diskettes := Succ((MemW[$0000:0410] shl 8) shr 14);
end;

Procedure DetectDrives;
{uit SWAG, gemodificeerd voor eigen gebruik}
Var DriveStr     : String[12];
    Diskettes, i : Word;
    Skip         : Boolean;

begin
 Diskettes := Installed_Diskettes; {het aantal diskette stations}
  for i:=1 to 26 do         {Try drives A..Z}
  begin
    drv[1]:=i+64;           {A=ASCII 65, etc}
    drv[2]:=ord(':');
    drv[3]:=0;
    reg.ax:=$2906;          {DOS function 29h = Parse Filename}
    reg.si:=ofs(drv[1]);    {Point to drive string}
    reg.di:=ofs(fcb[1]);    {Point to File Control Block}
    reg.ds:=dseg;
    reg.es:=dseg;
    msdos(reg);             {DOS Interrupt}
    Skip:=False;
    if (Chr(i+64) = 'B') and (Diskettes = 1) then Skip:=True;
    if (reg.al<>$ff) and (Skip= False) then
    begin
     Inc(NumFiles);
     DriveStr:='['+Chr(i+64)+':]';  {+64 maakt i een hoofdletter}
     Repeat DriveStr := DriveStr + ' ' Until Length(DriveStr)=12;
     FileList[NumFiles]:=DriveStr;
    end;
  end;
end;

(*
   GRAFISCHE ROUTINES
*)

Procedure DrawInBox(x1, y1, x2, y2: word);
Var
   Dummy, Border : word;

Begin
 SetFillStyle(SolidFill, 0);
 Bar(x1, y1, x2, y2);
 Border := 1; {0-2 = 3}
 For Dummy := 0 to Border do
  Begin
   SetColor(BtDark);
    Line(x1+dummy, y1+dummy, x2-dummy, y1+dummy);
    Line(x1+dummy, y1+dummy, x1+dummy, y2-dummy);
   SetColor(BtLight);
    Line(x1+dummy,y2-dummy, x2-dummy, y2-dummy);
    Line(x2-dummy, y1+dummy, x2-dummy, y2-dummy);
  End;
End;


Procedure DrawButton(x1, y1, x2, y2: word; Info : string);
Var
   Dummy, Border,
   TextX, TextY  : word;

Begin
 SetFillStyle(SolidFill, BgColor);
 Bar(x1, y1, x2, y2);
 Border := 1; {0-2 = 3}
 For Dummy := 0 to Border do
  Begin
   SetColor(BtLight);
    Line(x1+dummy, y1+dummy, x2-dummy, y1+dummy);
    Line(x1+dummy, y1+dummy, x1+dummy, y2-dummy);
   SetColor(BtDark);
    Line(x1+dummy,y2-dummy, x2-dummy, y2-dummy);
    Line(x2-dummy, y1+dummy, x2-dummy, y2-dummy);
  End;
 If Info = '' then Exit; {extra snelheid... ha!}
 SetColor(TxtColor);
 SetTextJustify(CenterText, CenterText);
 TextX := (x2 - x1) div 2 + x1;
 TextY := (y2 - y1) div 2 + y1;
 OutTextXY(TextX,TextY, Info);
End;



Procedure SetupDataScreen;
Var
   Border, Dummy        : Word;
Begin
 Border := 1; {0-2 = 3}
 For Dummy := 0 to Border do
  Begin
   SetColor(BtDark);
    Line(10-border-1+dummy, BaseLine-border-1+dummy, 632+border+1-dummy, BaseLine-border-1+dummy);
    Line(10-border-1+dummy, BaseLine-border-1+dummy, 10-border-1+dummy, BaseLine+255+1-dummy);
   SetColor(BtLight);
    Line(10-border-1+dummy,BaseLine+255+1-dummy, 632+border+1-dummy, BaseLine+255+1-dummy);
    Line(632+border+1-dummy, BaseLine-border-1+dummy, 632+border+1-dummy, BaseLine+255+1-dummy);
  End;
 SetFillStyle(SolidFill, 0);
 Bar(10, BaseLine, 632, BaseLine+255);
End;

Procedure ShowData;
Var
   Data, Index,
   Index2,Optel,
   Divider,
   xMouse, yMouse,
   bState         : word;
   tempstr     : string;
Begin
 if fsize <= 0 then exit;
 Divider := fsize div 620;
 if divider <= 0 then {verkeerde/te weinig data?}
  Begin
   Ms_hide;
   fsize := 0;          { sample lozen}
   freemem(buf, fsize); { sample lozen}
   { gebruiker waarschuwen, sample te klein}
   sound(620);
   delay(100);
   sound(320);
   delay(100);
   nosound;
   DrawButton(100, 100, GetMaxX-100, 150, 'WARNING: too little data found');
   Delay(300);
    Repeat
     MS_Read(xMouse,yMouse, bState);
    Until bState <> 0;
   Ms_show;
   Delay(200);
   SetFillStyle(SolidFill, 0);
   Bar(10, BaseLine, 632, BaseLine+255);
   Exit;
  End;

  optel := 0;
  for index := 1 to 619 do
   begin
    for index2 := 0 to divider do
     begin
      Data := (mem[seg(buf^):ofs(buf^)+index2+optel]);
      PutPixel(10 + index, BaseLine + 255 - Data, PixelColor);
     end;
    inc(optel, divider);
   end;
 {eerst de oude weghalen}
 SetFillStyle(SolidFill,7);
 Bar(10, 309, GetMaxX-10, 331);
 {de filesize}
 str(fsize, tempstr);
 SetColor(PixelColor);
 SetTextJustify(LeftText, CenterText);
 OutTextXY(20, 320, 'samplesize (bytes) : ' + tempstr);
 str(freq, tempstr);
 OutTextXY(250, 320, 'sampling frequency : ' + tempstr);
 OutTextXY(460, 320, 'sample : ' + fname);
End;

Procedure SetupScreen;
Var
   Dummy : word;
   sel   : pointer;
   f     : file;
   Lsize : word;

Begin
 SetFillStyle(SolidFill, BgColor);
 SetTextStyle(DefaultFont, HorizDir,1);
 DrawButton(0,0,GetMaxX,GetMaxY, '');
 {logo}
 DrawButton(530, 375, 600, 420, '');
 Assign(f,ProgDir+'\XPLOGO.XGF');
 Reset(f,1);
 Lsize:=FileSize(F);
 GetMem(Sel,Lsize);
 BlockRead(f,Sel^,Lsize);
 Close(f);
 PutImage(540, 380,Sel^,NormalPut);
 FreeMem(Sel,Lsize);
 {titel}
 DrawButton(40, 10, 600, 40, 'X-Pression Sample Editor ' + version + ' by E. Wenners, a.k.a. elmo');
 {kolom1}
 DrawButton(20, 360, 100, 380, 'load');
 DrawButton(20, 390, 100, 410, 'save');
 DrawButton(20, 420, 100, 440, 'save as');
 DrawButton(20, 450, 100, 470, 'save sel.');
 {kolom2}
 DrawButton(120, 360, 200, 380, 'play all');
 DrawButton(120, 390, 200, 410, 'play sel.');
 DrawButton(120, 420, 200, 440, 'pause');
 DrawButton(120, 450, 200, 470, 'stop');
 {kolom3}
 DrawButton(265, 360, 300, 380, 'end');
 DrawButton(220, 360, 265, 380, 'begin');
 DrawButton(220, 390, 300, 410, 'copy');
 DrawButton(220, 420, 300, 440, 'cut');
 DrawButton(220, 450, 300, 470, 'paste');
 {kolom4}
 DrawButton(320, 360, 400, 380, 'reverse');
 DrawButton(320, 390, 400, 410, 'silence');
 DrawButton(320, 420, 400, 440, 'fade in');
 DrawButton(320, 450, 400, 470, 'fade out');
 {kolom5}
 DrawButton(420, 360, 500, 380, 'refresh');
 DrawButton(420, 390, 500, 410, 'frequency');
 DrawButton(420, 450, 500, 470, 'exit');
 SetColor(Labels);
 OutTextXY(60, 350, 'Sample');
 OutTextXY(160, 350, 'Play');
 OutTextXY(260, 350, 'Selection');
 OutTextXY(360, 350, 'Fx');
 OutTextXY(460, 350, 'General');
End;


Procedure Refresh;
Begin
 Ms_hide;
 SetupScreen;
 SetupDataScreen;
 if fsize > 0 then ShowData;
 Ms_show;
End;

Procedure Warning(warnstr : string);
Var
   xMouse, yMouse,
   bState          : word;

Begin
 Ms_hide;
 sound(620);
 delay(100);
 sound(320);
 delay(100);
 nosound;
 DrawButton(100, 100, GetMaxX-100, 150, 'WARNING: '+warnstr);
 Delay(300);
 Repeat
  MS_Read(xMouse,yMouse, bState);
 Until bState <> 0;
 Refresh;
 Ms_show;
 Delay(200);
End;

(*
  SAMPLE DATA ROUTINES
*)

Procedure PlayData(start, stop : word);
Var
   index, data, dummy,
   xMouse, yMouse,
   bState          : word;

Begin
 if fsize = 0 then
  begin
   Warning('load a sample first');
   exit;
  end;
 For index := Start to Stop do
  Begin
   WriteDsp(mem[seg(buf^):ofs(buf^)+index], freq);
   MS_Read(xMouse,yMouse, bState);
   If bState <> 0 then
    begin
     if (yMouse >= 420) and (yMouse <= 440) then
      begin
       Delay(200);{voor releasen knop}
       Repeat
        MS_Read(xMouse,yMouse, bState);
       Until bState <> 0;
      end;
     if (yMouse >= 450) and (yMouse <= 470) then Exit;
    end;
  End;
End;



Function LoadFile(Var buffer:Pointer; Filename:String) : Word;
Var
   fromf : File;
   size : LongInt;
begin
   assign(fromf,Filename);
   {$I-}
   reset(fromf,1);
   {$I+}
   if IOresult = 0 then
   begin
      size := Filesize(fromf);
      if size <= 0 then
       begin
        Warning('no sample data found!');
        size := 0;
        exit;
       end;
      if size > MaxPointer then
       begin
        Warning('sample cut of at '+ MaxPointerStr);
        size := MaxPointer;
       end;
      getmem(buffer,size);
      blockread(fromf,buffer^,size);
   end
   else
    begin
     Warning('can''t load this sample!');
     size := 0;
    end;
   loadFile := size;
   close(fromf);
end;

Procedure LoadSample;
Var
   dummy, hlite,
   count, page,
   maxpage,
   oldpage,
   xMouse, yMouse,
   bState        : word;
   DirInfo       : SearchRec;
   DirStr        : String;
   Select        : Boolean;

Begin
 DrawButton(220, 20, 420, 350, '');
 DrawInBox(240, 40, 380, 306);
 DrawButton(240, 320, 315, 340, 'Ok');
 DrawButton(325, 320, 400, 340, 'Cancel');
 DrawButton(390, 160, 410, 180, '<');
 DrawButton(390, 180, 410, 200, '<<');
 DrawButton(390, 200, 410, 220, '>>');
 DrawButton(390, 220, 410, 240, '>');
 SetColor(TxtColor);
 SetTextJustify(CenterText, CenterText);
 OutTextXY(320, 31, 'SAMPLE BROWSER');
Repeat
 {oude data na dir change weghalen}
 For Dummy := 1 to NumFiles do
  FileList[Dummy] := '';

 DrawInBox(240, 40, 380, 306);
 GetDir(0,DirStr);

 if (Copy(DirStr, 3, 1)='\') and (Copy(DirStr, 4, 1)<>'') then
  Begin
   NumFiles := 2;
   FileList[1] := '..';
   FileList[2] := '\';
  End
 else
  Begin
   NumFiles := 1;
   FileList[1] := '<THE ROOT>';
  End;

 DetectDrives;

 FindFirst('*.*', anyfile, dirinfo ); {directorie}
  While DosError = 0 do
    Begin
     if (DirInfo.Attr = $10) and (DirInfo.Name <> '.')
     and (DirInfo.Name <> '..') then
      Begin
       FileList[NumFiles] := Dirinfo.name;
       Inc(NumFiles);
      End;
     FindNext(Dirinfo);
    End;

 FindFirst('*.*', $20, dirinfo); {sample}
  While DosError = 0 do
   Begin
    FileList[NumFiles] := Dirinfo.name;
    FindNext(Dirinfo);
    Inc(NumFiles);
   End;

 Hlite := 1;
 Page := 0; {26 files per page}
 maxPage := Numfiles div 26;
 Select := False;

 SetTextJustify(LeftText, CenterText);

 if numfiles < 26 then count := numfiles
 else count := 26;

 For Dummy := (page * 26) to (page * 26 + 26) do
  Begin
   if Hlite = Dummy then SetColor(15)
   else
   begin
    FindFirst(FileList[Dummy], anyfile, dirinfo );
    if DirInfo.attr <> $20 then SetColor(10) {dir}
    else SetColor(9);                      {file}
   end;
   OutTextXY(245, 40 + (dummy * 10), FileList[Dummy]);
  End;

  Repeat
   Ms_Show;{muis weergeven}
   Repeat
    MS_Read(xMouse,yMouse, bState);
   Until bState <> 0;
   Ms_hide;{bij schermupdates, muis hiden}
   delay(100);
   OldPage := Page;

   if (xMouse >= 390) and (xMouse <= 410) then
    Begin

     if (yMouse >= 160) and (yMouse <= 180) then
      Begin {1 omhoog}
       if page > 0 then
        Begin
         if hLite - 1 > 0 then Dec(hLite,1)
         else
          begin
           dec(page,1);
           hlite := 26;
          end;
        end
       else if hLite - 1 > 0 then Dec(hLite,1);
      end;

     if (yMouse >= 181) and (yMouse <= 200) then {25 omhoog}
       if page > 0 then
        begin
         dec(page,1);
         hlite := 26;
        end;

     if (yMouse >= 201) and (yMouse <= 220) then {25 omlaag}
       if page <> maxpage then
        begin
         inc(page,1);
         hlite := 1;
        end;

     if (yMouse >= 221) and (yMouse <= 240) then  {1 omlaag}
      begin {1 omlaag}
       if page <> maxPage then
        Begin
         if hLite + 1 < 27 then Inc(hLite)
         else
          begin
           hlite := 1;
           inc(page);
          end;
        end
       else if (Page * 26) + hLite +1 < NumFiles then Inc(hLite);
      end;

    End;

   if (yMouse >= 40) and (yMouse <= 306)
   and (xMouse >= 240) and (xMouse <= 380) then {een bestand aangeklikt}
    begin
     fname := FileList[(page*26)+ ((yMouse-33) div 10)];
     GetDir(0 ,SaveSampleDir);
     Select := True;
    end;

   if (yMouse >= 320) and (yMouse <= 340) then
    begin
     if (xMouse >= 240) and (xMouse <= 315) then {OK}
      begin
       fname := FileList[(page*26)+hLite];
       GetDir(0 ,SaveSampleDir);
       Select := True;
      end;
     if (xMouse >= 325) and (xMouse <= 400) then {CANCEL}
      begin
       MouseOn;
       SetupScreen;
       SetupDataScreen;
       ShowData;
       exit;
      end;
    end;

  If OldPage <> Page then DrawInBox(240, 40, 380, 306);
  For Dummy := 1 to 26 do
   Begin
    if Hlite = Dummy then SetColor(15)
   else
    begin
     FindFirst(FileList[(page*26)+Dummy], anyfile, dirinfo );
     if DirInfo.attr <> $20 then SetColor(10) {dir}
     else SetColor(9);                      {file}
    end;
    OutTextXY(245, 40 + (dummy * 10), FileList[(page*26)+dummy]);
   End;
  Until Select;

 Select := False;
 FindFirst(fname, anyfile, dirinfo );
 if fname = '<THE ROOT>' then Select := False {doe nix}
 else if (fname = '\') or (fname = '..') then Chdir(fname) {cd\ of cd..}
 else if copy(fname ,3 ,1) = ':' then Chdir(copy(fname ,2 ,2)) {change drive}
 else if DirInfo.attr <> $20 then Chdir(fname) {change dir}
 else Select := True; {select sample}
Until Select;
  {doorgeven aan loadile}
  dispose(buf);
  fsize := LoadFile(buf,fname);
  Start := 0;
  Stop := 0;
  MouseOn;
  Refresh;
End;

(*
  GELUIDS EFFECTEN
*)

Procedure ReverseData;
Var
   Oindex, Nindex : word;
   sel : pointer;

Begin
 if fsize = 0 then
  begin
   Warning('load a sample first');
   exit;
  end;
 if start = stop then
  begin
   Warning('first make a selection, then press REVERSE');
   exit;
  end;
 GetMem(sel, fsize);
 Nindex := stop;
  for Oindex := start to stop do
   begin
    (mem[seg(sel^):ofs(sel^)+Nindex]) := (mem[seg(buf^):ofs(buf^)+Oindex]);
    Dec(Nindex);
   end;
 Nindex := 0;
  for Nindex := start to stop do
   (mem[seg(buf^):ofs(buf^)+Nindex]) := (mem[seg(sel^):ofs(sel^)+Nindex]);

 Freemem(sel, fsize);
 SetupDataScreen;
 ShowData;
End;

Procedure Cut;
Var
   dummy, dif : word;
   sel : pointer;

Begin
 if (Start = 0) and (Stop = fsize) then
  begin
   Warning('cutting the entire sample is quite useless');
   exit;
  end;
 if fsize = 0 then
  begin
   Warning('load a sample first');
   exit;
  end;
 if start = stop then
  begin
   Warning('first make a selection, then press CUT');
   exit;
  end;
 Dif := stop - start;
  for dummy := 0 to fsize-stop do
  (mem[seg(buf^):ofs(buf^)+start+dummy]) := (mem[seg(buf^):ofs(buf^)+stop+dummy]);
 fsize := fsize - dif;
 Getmem(sel, fsize);
  for dummy := 0 to fsize do
  (mem[seg(sel^):ofs(sel^)+dummy]) := (mem[seg(buf^):ofs(buf^)+dummy]);
 Dispose(buf);
 GetMem(buf, fsize);
 buf:=sel;
 Freemem(sel, fsize);

 SetupDataScreen;
 ShowData;
 Start := 0;
 Stop := fsize;
End;

Procedure Copy;
Var
   dummy, dif : word;

Begin
 if fsize = 0 then
  begin
   Warning('load a sample first');
   exit;
  end;
 if start = stop then
  begin
   Warning('first make a selection, then press COPY');
   exit;
  end;
 {Dispose(ClipBoard);}
 Freemem(ClipBoard, ClipSize);
 dif := stop - start;
 GetMem(ClipBoard, dif);

  for dummy := 0 to dif do
  (mem[seg(clipboard^):ofs(clipboard^)+dummy]) := (mem[seg(buf^):ofs(buf^)+start+dummy]);
 Clipsize := dif;
End;

Procedure Paste;
Var
   Dummy : word;
   sel : pointer;

Begin
 if clipsize = 0 then
  begin
   Warning('no clipboard, make a selection and press COPY');
   exit;
  end;
 if fsize >= MaxPointer then   {eerst checken of fsize al Max is}
  begin
   Warning('the sample is '+MaxPointerStr+', you can''t make it larger');
   exit;
  end;
 if fsize + clipsize > MaxPointer then
  begin
   Warning(MaxPointerStr+' limit reached, sample will be cut of');
   clipsize := MaxPointer-fsize
  end;
 GetMem(sel,(fsize + clipsize));
  for dummy := 0 to start do
  (mem[seg(sel^):ofs(sel^)+dummy]) := (mem[seg(buf^):ofs(buf^)+dummy]);

  for dummy := 0 to clipsize do
  (mem[seg(sel^):ofs(sel^)+start+dummy]) := (mem[seg(clipboard^):ofs(clipboard^)+dummy]);

  for dummy := 0 to fsize-start do
  (mem[seg(sel^):ofs(sel^)+start+clipsize+dummy]) := (mem[seg(buf^):ofs(buf^)+start+dummy]);

  fsize := fsize+clipsize;
  GetMem(buf, fsize);
  buf := sel;
  Freemem(sel, fsize);
  SetupDataScreen;
  ShowData;
  Start := 0;
  Stop := fsize;
End;

Procedure FadeOut;
Var
   Dummy, dif,
   data, aantal,
   eraf, optel,
   Gem    : Word;

Begin
 if fsize = 0 then
  begin
   Warning('load a sample first');
   exit;
  end;
 if start = stop then
  begin
   Warning('first make a selection, then press FADE OUT');
   exit;
  end;
 {de gemiddelde data grootte uitrekenen}
 dif := stop - start;
{ gem := 0;
 For Dummy := 1 to dif do
  Gem := Gem + (mem[seg(buf^):ofs(buf^)+start+dummy]);
 gem := gem div dif;}
 aantal := dif div {gem}128;
 if aantal <=0 then exit;
 eraf := 0;
 optel := 0;

 For Dummy := 1 to dif do
  Begin
   inc(optel);
   if optel = aantal then optel := 0;
   if optel = 0 then inc(eraf);
   data := (mem[seg(buf^):ofs(buf^)+start+dummy]);
   if data > 128 then
    begin
     if data - eraf >= 128 then dec(data, eraf)
     else data := 128;
    end
   else
    begin
     if data + eraf <= 128 then inc(data, eraf)
     else data := 128;
    end;
   (mem[seg(buf^):ofs(buf^)+start+dummy]) := data;
  End;
 SetupDataScreen;
 ShowData;
End;

{Procedure FadeOut;
var divider, getal : real;
   data,Dummy, dif : word;

Begin
 dif := stop - start;
 divider := 128 div dif;
 For Dummy := 1 to dif do
  Begin
   data := (mem[seg(buf^):ofs(buf^)+start+dummy]);
   if data > 128 then
    begin
     data := data - 128;
     getal := data;
     getal := getal * (divider * Dummy);
     data := getal;
     data := data + 128;
   (mem[seg(buf^):ofs(buf^)+start+dummy]) := data;
    end
   else
    begin
     getal := data;
     getal := getal * (divider * Dummy);
     data := getal;
     data := data + 128;
   (mem[seg(buf^):ofs(buf^)+start+dummy]) := data;
    end;
  end;
 SetupDataScreen;
 ShowData;
End;}

Procedure FadeIn;
Var
   Dummy, dif : word;
  data, aantal, eraf, optel  : word;

Begin
 if fsize = 0 then
  begin
   Warning('load a sample first');
   exit;
  end;
 if start = stop then
  begin
   Warning('first make a selection, then press FADE IN');
   exit;
  end;
 dif := stop - start;
 aantal := dif div 128;
 if aantal <=0 then exit;
 eraf := 128;
 optel := 0;

 For Dummy := 1 to dif do
  Begin
   inc(optel);
   if optel = aantal then optel := 0;
   if optel = 0 then dec(eraf);
   data := (mem[seg(buf^):ofs(buf^)+start+dummy]);
   if data > 128 then
    begin
     if data - eraf >= 128 then dec(data, eraf)
     else data := 128;
    end
   else
    begin
     if data + eraf <= 128 then inc(data, eraf)
     else data := 128;
    end;
   (mem[seg(buf^):ofs(buf^)+start+dummy]) := data;
  End;
 SetupDataScreen;
 ShowData;
End;


Procedure SelectBegin;
Var
   Divider,
   xMouse, yMouse,
   bState          : word;
 
Begin
 Delay(200); {releasen muisknop}
 if fsize = 0 then
  begin
   Warning('load a sample first');
   exit;
  end;
 Divider := Fsize div 620;
  Repeat
   MS_Read(xMouse,yMouse, bState);
  Until (bState <> 0);
    Ms_hide;
     if (yMouse >= 50) and (yMouse <= 255+50)
     and (xMouse >= 10) and (xMouse <= 632) then
      Begin
       SetColor(0);
       Line((Start div Divider)+10, 50, (Start div Divider)+10, 255+50);
       Line((Stop div Divider)+10, 50, (Stop div Divider)+10, 255+50);
       if (xMouse-10) * divider >= stop then Stop := 620 * divider;
       ShowData;
       SetColor(SelLine);
       Line(xMouse, 50, xMouse, 255+50);
       Line((Stop div Divider)+10, 50, (Stop div Divider)+10, 255+50);
       Start := (xMouse-10) * divider;
      End;
    Ms_show;
End;

Procedure SelectEnd;
Var
   Divider,
   xMouse, yMouse,
   bState          : word;

Begin
 Delay(200); {releasen muisknop}
 if fsize = 0 then
  begin
   Warning('load a sample first');
   exit;
  end;
 Divider := Fsize div 620;
  Repeat
   MS_Read(xMouse,yMouse, bState);
  Until (bState <> 0);
   Ms_hide;
    if bState <> 0 then
     if (yMouse >= 50) and (yMouse <= 255+50)
     and (xMouse >= 10) and (xMouse <= 632) then
      Begin
       SetColor(0);
       Line((Start div Divider)+10, 50, (Start div Divider)+10, 255+50);
       Line((Stop div Divider)+10, 50, (Stop div Divider)+10, 255+50);
       if (xMouse-10) * divider <= start then start := divider * 1;
       ShowData;
       SetColor(SelLine);
       Line((Start div Divider)+10, 50, (Start div Divider)+10, 255+50);
       Line(xMouse, 50, xMouse, 255+50);
       Stop := (xMouse-10) * divider;
      End;
   Ms_show;
End;

Procedure Silence;
Var
   dummy : word;

Begin
 if fsize = 0 then
  begin
   Warning('load a sample first');
   exit;
  end;
 if start = stop then
  begin
   Warning('first make a selection, then press FADE IN');
   exit;
  end;
  for dummy := start to stop do
  (mem[seg(buf^):ofs(buf^)+dummy]) := 128;
  SetupDataScreen;
  ShowData;
End;

(*
  DE SAVE SAMPLE ROUTINE
*)

Procedure SaveSample(SaveAs, SaveSel : Boolean);
Var
   tof        : File;
   errcode,
   dummy      : word;
   GiveName   : string;
   ch         : char;
   SelSize    : integer;
   sel        : pointer;

begin
 if fsize = 0 then
  begin
   Warning('load a sample first');
   exit;
  end;
 if (SaveSel) and (start = stop) then
  begin
   Warning('first make a selection, then press SAVE SEL.');
   exit;
  end;
 GiveName := '';
 if not SaveAs then assign(tof,SaveSampleDir +'\' +fname)
 else
  Begin
   SetTextJustify(LeftText, CenterText);
   SetColor(Labels);
   OutTextXY(130 ,335 ,'Enter filename');

   Repeat
    DrawInBox(250, 327, 370, 343);
    SetColor(15);
    OutTextXY(260, 335, GiveName);
     Repeat Until Keypressed;
     ch := Readkey;
     if ch = #8 then Delete(GiveName ,length(GiveName) ,1)
     else if (ch <> #13) and (ch <> '.') then
     if (length(GiveName) < 8)
      then GiveName := GiveName + ch
     else
      begin
       sound(220);
       delay(100);
       nosound;
      end;
    {ff tjekken of de naam correct is!}
   Until ch = #13;
   GiveName := GiveName + '.RAW'; {extensie}
   assign(tof,GiveName);
  End;

  if not SaveSel then
   begin
    GetMem(sel, fsize);
    Sel := Buf;
    SelSize := fsize;
   end
  else
   begin
    GetMem(sel, Stop - Start);
    SelSize := Stop - Start;
     for dummy := Start to Stop do
      mem[seg(sel^):ofs(sel^)+dummy] := mem[seg(buf^):ofs(buf^)+start+dummy];
   end;
 {$I-}
 rewrite(tof,1);
 {$I+}
 if ioresult <> 0 then
  begin
   Warning('error when saving '+givename);
   exit;
  end;
 blockwrite(tof,sel^,SelSize);
 close(tof);
 Freemem(sel, SelSize);
 refresh;
end;

(*
  ALGEMENE ROUTINES
*)

Procedure Xpression;
Var
   xMouse, yMouse,
   bState          : word;

Begin
 Ms_hide;
 Delay(200);
 DrawButton(0,50,GetMaxX,275, '');
 DrawInBox(5,55,GetMaxX-5, 265);
 SetColor(9);
 SetTextJustify(LeftText, CenterText);
 OutTextXY(10,65,'Hi there!');
 OutTextXY(10,85,'Thanx for using X-SAMEDiT');
 OutTextXY(10,95,'When composing s3m''s with Scream Tracker, i often had the need for a small');
 OutTextXY(10,105,'DOS-based sample editor. i decided to make my own in Turbo Pascal 7.0.');
 OutTextXY(10,115,'I added all the basic features, like cut, copy, reverse and silence.');
 OutTextXY(10,135,'I have some space left, so here are some greetz:');
 OutTextXY(10,155,'Tall B/x-Pression, YOost, the DESPRiT4, Steven Boks, Maurice,');
 OutTextXY(10,165,'SpeedyD/Gabber Maniacs, Miz, RvO/MxM, Casper, Jan de Rooij (CyberOpa),');
 OutTextXY(10,175,'Muis, and my girlfriend: Moniek!');
 OutTextXY(10,195,'anti-greetz fly to: Bob "the WANNABE hacker" !!!');
 OutTextXY(10,215,'elmar@cyberdude.com or elmo_xp@hotmail.com');
 OutTextXY(10,225,'elmo/x-pression.');
 OutTextXY(10,245,'hit a mouse button!');
 Repeat
  MS_Read(xMouse,yMouse, bState);
 Until bState <> 0;
 Refresh;
 Ms_show;
 Delay(200);
End;

Procedure SetFrequency;
Var
   ch              : char;
   tempstr         : string;
   code            : integer;
   xMouse, yMouse,
   bState          : word;


Begin
 if fsize = 0 then
  begin
   Warning('load a sample first');
   exit;
  end;
 DrawInBox(412, 310, 450, 330);
 SetColor(3);
 SetTextJustify(LeftText, CenterText);
 tempstr := '';
 Repeat
  Repeat
  Until Keypressed;
  ch := Readkey;
     if ch = #8 then {backspace}
      begin
       if length(tempstr) > 0 then delete(tempstr, length(tempstr), 1);
      end
     else if ch = #32 then tempstr := tempstr {spatie niet toevoegen}
     else if ch = #27 then tempstr := tempstr {escape niet toevoegen}
     else if ch = #13 then tempstr := tempstr {enter niet toevoegen}
     else
      begin
       if length(tempstr) < 3 then tempstr := tempstr + ch;
      end;
     {weergeven freq tot nu toe}
     DrawInBox(412, 310, 450, 330);
     OutTextXY(415, 320, tempstr);
 Until (ch = #13) or (ch = #27);
 if ch = #13 then val(tempstr, freq, code);
 ShowData;
End;

Procedure MainMenu;
Var
   Ch : char;
   xMouse, yMouse,
   bState          : word;

Begin
 MouseOn;
 Repeat
  Repeat
   MS_Read(xMouse,yMouse, bState);
  Until (bState <> 0) or (Keypressed);

   if Keypressed then
    begin
     Ch := ReadKey;
     if ch = #27 then Exit;
    end
   else
    begin
      {kolom1}
      if (xMouse >= 20) and (xMouse <= 100) then
      begin
       if (yMouse >= 360) and (yMouse <= 380) then LoadSample;
       if (yMouse >= 390) and (yMouse <= 410) then SaveSample(false, false); {save}
       if (yMouse >= 420) and (yMouse <= 440) then SaveSample(true, false); {save as}
       if (yMouse >= 450) and (yMouse <= 470) then SaveSample(true, true); {save sel as}
      end;
      {kolom2}
      if (xMouse >= 120) and (xMouse <= 200) then
      begin
       if (yMouse >= 360) and (yMouse <= 380) then PlayData(0, fsize);
       if (yMouse >= 390) and (yMouse <= 410) then PlayData(start, stop);
      end;
      {kolom3}
      if (xMouse >= 220) and (xMouse <= 300) then
      begin
       if (yMouse >= 390) and (yMouse <= 410) then Copy;
       if (yMouse >= 420) and (yMouse <= 440) then Cut;
       if (yMouse >= 450) and (yMouse <= 470) then Paste;
       if (xMouse <= 265) and (yMouse >= 360) and (yMouse <= 380) then SelectBegin;
       if (xMouse > 265) and (yMouse >= 360) and (yMouse <= 380) then SelectEnd;
      end;
      {kolom4}
      if (xMouse >= 320) and (xMouse <= 400) then
      begin
       if (yMouse >= 360) and (yMouse <= 380) then ReverseData;
       if (yMouse >= 390) and (yMouse <= 410) then Silence;
       if (yMouse >= 420) and (yMouse <= 440) then FadeIn;
       if (yMouse >= 450) and (yMouse <= 470) then FadeOut;
      end;
      {kolom5}
      if (xMouse >= 420) and (xMouse <= 500) then
      begin
       if (yMouse >= 360) and (yMouse <= 380) then Refresh;
       if (yMouse >= 390) and (yMouse <= 410) then SetFrequency;
{       if (yMouse >= 420) and (yMouse <= 440) then Exit; {Directory}
       if (yMouse >= 450) and (yMouse <= 470) then Exit {Exit};
      end;
      if (xMouse >= 530) and (xMouse <= 600)
      and (yMouse >= 375) and (yMouse <= 420) then Xpression {ContactUs};
    end;
 Until Keypressed <> keypressed;
End;

Procedure UnloadPointers;
Begin
 Dispose(buf);
 Dispose(clipboard);
End;

Begin {actual program}
{ CheckBreak := False;}
 GetDir(0, ProgDir);
 Freq:=21;
 InitSB;
 InitScreen;
 SetupScreen;
 SetupDataScreen;
 MainMenu;
 CloseGraph;
 CloseSB;
 UnLoadPointers;
 Chdir(ProgDir);
 Writeln('Thanx4 choosing xsamedit, read beta.txt if ya wanna help me!');
End.
