UNIT longfile;
Interface

USES Strings;
type
  TSearchRec = record
    attr : longint;
    creation : comp;
    lastaccess : comp;
    lastmodification : comp;
    highfilesize : longint;
    lowfilesize : longint;
    reserved : comp;
    name : array[0..259] of char;
    shortname : array[0..13] of char;
    handle : word;
  end;

const
  faReadOnly      =  $01;
  faHidden        =  $02;
  faSysFile       =  $04;
  faVolumeID      =  $08;
  faDirectory     =  $10;
  faArchive       =  $20;
  faAnyFile       =  $3F;

function findfirst(filespec:string;attr:word;var S:TSearchRec):integer;
function findnext(var S:TSearchRec):integer;
function findclose(var S:TSearchRec):integer;

{i (elmo) added these two routines for use in DOS programs...!}
function file_exists(filename : string) : boolean;
function ReturnShortName(path,filename:string):string;

Implementation

function findfirst(filespec:string;attr:word;var S:TSearchRec):integer;
begin
  filespec := filespec + #0;
  S.attr := attr;
  asm
    push ds
    push ss
    pop ds                                                              
    lea dx,filespec+1                                                   
    les di,S
    mov ax,$714e                                                        
    mov cx,attr
    mov si,0
    int $21
    les di,S
    mov word ptr es:[di+TSearchRec.handle], ax
    jc @1
    xor ax,ax
  @1:
    mov @result,ax
    pop ds
  end;
end;


function FindNext(var S:TSearchRec):integer;
begin
  asm
    mov ax,$714f
    mov si,0
    les di,S
    mov bx,word ptr es:[di+TSearchRec.Handle]
    int $21
    jc @1
    xor ax,ax
  @1:
    mov @result,ax
  end;
end;

function FindClose(var S:TSearchRec):integer;
begin
  asm
    mov ax,$71a1
    les di,S
    mov bx,word ptr es:[di+TSearchRec.Handle]
    int $21
    jc @1
    xor ax,ax
  @1:
    mov @result,ax
  end;
end;

function file_exists(filename : string) : boolean;
var
  S : TSearchRec;
  Res : Integer;
begin
  file_exists := false; {assume its not there!}
  Res := findfirst(filename,faAnyFile-faVolumeID,S);
  if Res = 0 then file_exists := true;
end;

Function ReturnShortName(path,filename:string): string;
var
  S : TSearchRec;
  Res : Integer;
begin
  Res := findfirst(path+'\'+filename,faAnyFile-faVolumeID,S);
  if Res = 0 then
  begin
    with S do
    begin
      if ShortName[0] <> #0 then
        ReturnShortName := StrPas(Shortname);
    end;
  end;
end;


begin
end.
