{Sound Routines GDM file format Unit        }
{Writted by : Raphius/Gyzmor Belgium        }
{Based on the original source from PHRED/OTM}
{(c) 1996, Gyzmor Belgium                   }
unit sound;

{ $DEFINE NoTune}
{ $DEFINE TEST}

interface

Var
  SoundEnabled : Boolean;

{This procedure setup the sound card}
function SetupMusic(diskfile: string): string;
{This procedure begin playing music}
Procedure BeginMusic;
{This procedure permisse you to change the music to another one}
function ChangeModule(new : string): string;
{This close properly the music}
Procedure CloseMusic;

implementation

Uses Crt, MSE_TP;

Var
  ErrInit : Word;
  SoundCardName : String;
  IOAddr : Word;
  DMA : Byte;
  IRQ : Byte;
  EMSFlag : Word;
  Module: file;
  GDMH : GdmHeader;
  MUSICChannels, ChannelCount, SampleRate : Word;

{PROCEDURE BEGINMUSIC}
Procedure BeginMusic;
Begin
  {If the variable SoundEnabled is TRUE then start playing music !}
  If SoundEnabled
    Then StartMusic;
End;




{!!Internal Functions!!}




{Setup the : SOUND CARD NAME}
Function SelectSoundCard : Integer;
Begin
  Writeln('Initializare sunet.');
  Writeln;
  Writeln('Alege placa sunet');
  Writeln;
  Writeln('  1. Gravis UltraSound');
  Writeln('  2. Sound Blaster Pro');
  Writeln('  3. Sound Blaster');
  Writeln('  4. Nu vreau sunet');
  SelectSoundCard := (Ord(ReadKey) - Ord('0'));
End;

{Setup the : IO ADDRESS}
Function SelectIOAddr: Integer;
Begin
  Writeln;
  Writeln('Addresa IO(intrare-iesire)');
  Writeln;
  Writeln('  1. 210h ');
  Writeln('  2. 220h ');
  Writeln('  3. 230h ');
  Writeln('  4. 240h ');
  Writeln('  5. 250h ');
  Writeln('  6. 260h ');
  SelectIOAddr := $200+((Ord(ReadKey)-Ord('0'))*$10);
End;

{Setup the : IRQ ADDRESS}
Function SelectIRQ : Integer;
Begin
  Writeln;
  Writeln('Selecteaza IRQ');
  Writeln;
  Writeln('  1. Irq 2');
  Writeln('  2. Irq 3');
  Writeln('  3. Irq 5');
  Writeln('  4. Irq 7');
  Writeln('  5. Irq 11');
  Writeln('  6. Irq 12');
  Case ReadKey of
    '1' : SelectIRQ := 2;
    '2' : SelectIRQ := 3;
    '3' : SelectIRQ := 5;
    '4' : SelectIRQ := 7;
    '5' : SelectIRQ := 11;
    '6' : SelectIRQ := 12;
  End;
End;

{Setup the : DMA ADDRESS}
Function SelectDMA : Integer;
Begin
  Writeln;
  Writeln('Selecteaza DMA');
  Writeln;
  Writeln('  1. Dma 1');
  Writeln('  2. Dma 3');
  Writeln('  3. Dma 5');
  Case ReadKey of
    '1' : SelectDMA := 1;
    '2' : SelectDMA := 3;
    '3' : SelectDMA := 5;
  End;
End;




{!!End of Internal Functions!!}




function SetupMusic(DiskFile: string): string;
var
  Module: file;
Begin
  {If the SoundEnabled is FALSE then EXIT immediately to next}
  SoundEnabled := False;
{$IFDEF NOTUNE}
  Exit;
{$ENDIF}
{$IFNDef Test}
  Case SelectSoundCard of
    {Choice 1 was Gravis Ultrasound so driver GUS.MSE}
    1 : SoundCardName := 'GUS.MSE';
    {Choice 2 was SbPro so driver SBPRO.MSE}
    2 : SoundCardName := 'SBPRO.MSE';
    {Choice 3 was Sound Blaster so driver SB1X.MSE}
    3 : SoundCardName := 'SB1X.MSE';
    {Choice 4 was No Sound so no driver and immediately EXIT}
    4 : Exit;
  End;
  {If no EMS then type a error message}
  If Not(EMSExist) and (SoundCardName <> 'GUS.MSE')
    Then Begin
      Writeln('Error:');
      Writeln('You NEED a last 400K memory to run the music !');
      writeln('Try to have more memory.');
      Halt(0);
    End;
  {Assign the selected IO Address to the variable IOADDR}
  IOAddr := SelectIOAddr;
  {Assign the selected IRQ Address to the variable IRQ}
  IRQ := SelectIRQ;
  {Assign the selected DMA Address to the variable DMA}
  DMA := SelectDMA;
{$ELSE}
  SoundCardName := 'GUS.MSE';
  IOAddr := $210;
  DMA := 5;
  IRQ := 12;
{$ENDIF}
  ErrInit := LoadMSE(SoundCardName, 0, 44, 8128, IOAddr, IRQ, DMA);
  If ErrInit <> 0
    Then Begin
      Writeln('Error:');
      Writeln('Error in the initialisation of the sound.');
      Delay(5000);
      Exit;
    End;
  Assign(Module,Diskfile);
  {$I-}
  Reset(Module, 1);
  {$I+}
  If IOResult <> 0
    Then Begin
      Writeln('Error:');
      Writeln('Error loading module.');
      Delay(5000);
      FreeMSE;
      Exit;
    End;
  EMSFlag := 1;
  ErrInit := LoadGDM(Module, 0, EMSFlag, GDMH);
  If ErrInit <> 0
    Then Begin
      Writeln('Error:');
      Writeln('Error reading module.');
      Delay(5000);
      FreeMSE;
      Exit;
    End;
  MusicChannels := 0;
  For ChannelCount := 1 to 32 do
    Begin
      If GDMH.PanMap[ChannelCount] <> $FF
        Then MusicChannels := MusicChannels + 1;
    End;
  SampleRate := StartOutput(MusicChannels, 0);
  SoundEnabled := True;
End;

{PROCEDURE CLOSEMUSIC}
Procedure CloseMusic;
Var
  Temp : Byte;
  Count : Byte;
Begin
  {If the Sound is enabled then slow down to 0}
  If SoundEnabled
    Then Begin
      For Count := 63 downto 0 do
        Begin
          Temp := MusicVolume(Count);
          Delay(50);
        End;
      {Stop music}
      StopMusic;
      {Stop conversing output}
      StopOutput;
      {Unload the module}
      UnloadModule;
      {Frees the memory}
      FreeMSE;
    End;
End;

{PROCEDURE CHANGEMODULE}
function changemodule(new : string): string;
var
  Newfile: file;
  Temp : Byte;
  Count : Byte;
  Temp2: Byte;
  Count2: Byte;
Begin
  {If the Sound is enabled then slow down to 0}
  If SoundEnabled
    Then Begin
      For Count := 63 downto 0 do
        Begin
          Temp := MusicVolume(Count);
          Delay(50);
        End;
   Assign(newfile,new);
   {$I-}
   Reset(newfile, 1);
   {$I+}
 unloadmodule;
 StopMusic;
 freesample(200);
 mixforground;
 LoadGDM(newfile, 0, EMSFlag, GDMH);
 StartMusic;
 musicvolume(0);
 delay(100);
 {If the sound is enabled the go up to 63}
 if soundenabled
  then begin
   for count2 := 1 to 63 do
    begin
      temp2 := musicvolume(count2);
      delay(50);
     end;
end;
End;
end;

{End of the Sound Unit}

begin
end.
